2003-06-30  Bruno Haible  <bruno@clisp.org>

	PR middle-end/6578
	* libgcc2.c (__subvsi3): Remove simplification that would not work
	when subtracting -0x80000000.
	(__subvdi3): Remove simplification that would return a wrong result.
	(__mulvsi3): Fix overflow check.
	(__absvdi2): Fix simplification that would return a wrong result.
	(__mulvdi3): Fix overflow check.

2003-06-30  Jeff Law  <law@redhat.com>

	* stmt.c (any_pending_cleanups): Lose argument THIS_CONTOUR, it
	was always passed in the value '1'.  Simplify body appropriately.
	* tree.h (any_pending_cleanups): Corresponding changes.
	* calls.c: (expand_call): Corresponding changes.

2003-06-30  Kazu Hirata  <kazu@cs.umass.edu>

	* combine.c (distribute_notes): Don't bother REG_WAS_0.
	* cse.c (cse_insn): Likewise.
	* final.c (final_scan_insn): Likewise.
	* jump.c (duplicate_loop_exit_test): Likewise.
	* rtl.c (reg_note_name): Remove REG_WAS_0.
	* rtl.h (REG_WAS_0): Remove.
	* unroll.c (final_reg_note_copy): Don't bother REG_WAS_0.
	* config/avr/avr.c (output_movqi): Don't use reg_was_0.
	(output_movhi): Likewise.
	(output_movsisf): Likewise.
	(reg_was_0): Remove.
	* config/m68hc11/m68hc11.c (m68hc11_gen_movhi): Don't use
	REG_WAS_0.
	(m68hc11_gen_movqi): Likewise.
	* config/vax/vax-protos.h: Remove the prototype for
	reg_was_0_p.
	* config/vax/vax.c (follows_p): Remove.
	(reg_was_0_p): Likewise.
	* config/vax/vax.md (movsi): Don't use reg_was_0_p.
	(movhi): Likewise.
	(movqi): Likewise.
	* doc/rtl.texi (REG_WAS_0): Remove.

2003-06-30  Mark Mitchell  <mark@codesourcery.com>

	* config/rs6000/spe.h (__ev_set_spefscr_frmc): Set the flag.

2003-06-30  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/lib1funcs.asm: Use "xtensa-config.h" from
	top-level include directory.
	* config/xtensa/lib2funcs.S: Likewise.
	* config/xtensa/xtensa.h: Likewise.
	* config/xtensa/xtensa-config.h: Remove.
	* doc/install.texi: Update location of "xtensa-config.h" header.

2003-06-30  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_extra_constraint): New function.
	* config/s390/s390-protos.h (s390_extra_constraint): Declare it.
	* config/s390/s390.h (EXTRA_CONSTRAINT): Use it.
	* config/s390/s390.c (q_constraint): Remove.
	* config/s390/s390-protos.h (q_constraint): Likewise.
	* config/s390/s390.h (EXTRA_MEMORY_CONSTRAINT): Add 'R', 'S', 'T'.
	(EXTRA_ADDRESS_CONSTRAINT): Define.

	* config/s390/s390.c (larl_operand): Refuse out-of-range operands.
	(DISP_IN_RANGE, s390_short_displacement): New.
	(legitimate_reload_operand_p): Support long displacements.
	(s390_decompose_address): Likewise.
	(legitimize_pic_address): Likewise.
	(legitimize_address): Likewise.
	(s390_fixup_clobbered_return_reg): Likewise.
	(s390_emit_prologue, s390_emit_epilogue): Likewise.
	(s390_output_mi_thunk): Likewise.

	* config/s390/s390.md (attr "op_type"): Add "RXY", "RSY", "SIY".
	(attr "atype", attr "length"): Add defaults for new op_types.
	(all insns): Change op_type attribute where appropriate.

	("*movdi_lay", "*movsi_lay", "*extendqidi2", "*extendqisi2"): New insns.
	("*tmqi_ext", "*tmdi_mem", "*tmsi_mem", "*tmhi_mem", *tmqi_mem",
	"*tstsi", "*tstsi_cconly", "*tsthiCCT", "*tsthiCCT_cconly",
	"*tsthi", "*tsthi_cconly", "*tstqiCCT", "*tstqiCCT_cconly",
	"*tstqi", "*tstqi_cconly", "*cmpsi_ccs_sign", "*cmpsi_ccs",
	"*cmpsi_ccu", "*cmphi_ccu", "*cmpqi_ccu", "*cli",
	"movti", "*movdi_64", "*movdi_31", "*movsi", "movhi", "movqi_64",
	"movqi", "*movstrictqi", "*movstricthi", "movstrictsi",
	"*movdf_64", "*movdf_31", "*movsf",
	"*load_multiple_si", "*store_multiple_di",
	"*sethighqisi", "*sethighhisi", "*sethighqidi_31", "*extendhisi2",
	"*la_64", "*la_31", "*la_31_and", "force_la_31",
	"*addsi3_carry1_cc", *addsi3_carry1_cconly",
	"*addsi3_carry2_cc", *addsi3_carry2_cconly",
	"*addsi3_cc", "*addsi3_cconly", "*addsi3_cconly2",
	"*addsi3_sign", "*addsi3_sub", "addsi3",
	"*subsi3_borrow_cc", "*subsi3_borrow_cconly", "*subsi3_cc",
	"*subsi3_cconly", "*subsi3_sign", "*subsi3_sub", "subsi3",
	"mulsi3"
	"*andsi3_cc", "*andsi3_cconly", "andsi3",
	"*andqi3_ss", "*andqi3_ss_inv",
	"*iorsi3_cc", "*iorsi3_cconly", "iorsi3",
	"*iorqi3_ss", "*iorqi3_ss_inv",
	"*xorsi3_cc", "*xorsi3_cconly", "xorsi3",
	"*xorqi3_ss", "*xorqi3_ss_inv",
	"*tls_load_31"): Add alternatives for long-displacement instructions.

	("*cmpdf_ccs", "*cmpdf_ccs_ibm", "*cmpsf_ccs", "*cmpsf_ccs_ibm",
	"*load_multiple_di", "*store_multiple_di",
	"*sethighqidi_64", "*zero_extendhisi2_31",
	"truncdfsf2_ibm", "extendsfdf2_ieee", "extendsfdf2_ibm",
	"adddf3", "*adddf3", "*adddf3_ibm",
	"addsf3", "*addsf3", "*addsf3_ibm",
	"subdf3", "*subdf3", "*subdf3_ibm",
	"subsf3", "*subsf3", "*subsf3_ibm",
	"mulsi_6432", "divmoddisi3",
	"muldf3", "*muldf3", "*muldf3_ibm",
	"mulsf3", "*mulsf3", "*mulsf3_ibm",
	"divdf3", "*divdf3", "*divdf3_ibm",
	"divsf3", "div*sf3", "*divsf3_ibm",
	"sqrtdf2", "sqrtsf2",
	"*cjump_long", "*icjump_long", "indirect_jump", "casesi_jump",
	"*doloop_si_long", "*doloop_di_long", "bas_64", "bas_31",
	"bas_r_64", "bas_r_31", "bas_tls_31", "bas_tls_64"): Adapt memory
	and address constraints for instructions that do not accept long
	displacements.

2003-06-30  Hartmut Penner  <hpenner@de.ibm.com>
	    Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/2084.md: New file.
	* config/s390/s390.md: Include it.
	* config/s390/s390.c (s390_adjust_priority): New function.
	(TARGET_SCHED_ADJUST_PRIORITY): Define.
	(s390_first_cycle_multipass_dfa_lookahead): New function.
	(TARGET_SCHED_FIRST_CYCLE_MULTIPASS_DFA_LOOKAHEAD): Define.
	(s390_sched_reorder2): New function.
	(TARGET_SCHED_REORDER2): Define.
	(s390_adjust_cost): Support PROCESSOR_2084_Z990 cpu type.
	(s390_issue_rate): Likewise.

Mon Jun 30 23:47:33 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* Makefile.in (GTFILES): Add cgraph.h.
	* cgraph.c (known_decls): Remove.
	(cgraph_hash, cgraph_nodes, cgraph_nodes_queue,
	cgraph_varpool_hash, cgraph_varpool_nodes_queue): GTYize.
	(cgraph_node): Do not allocate known_decls; use polutate hashtable.
	(cgraph_varpool_node): Likewise; add next pointer.
	(cgraph_varpool_nodes): New static variable.
	* cgraph.h (cgraph_local_info, cgraph_global_info, cgraph_rtl_info,
	cgraph_node, cgraph_edge, cgraph_varpool_node, cgraph_nodes, cgraph_n_nodes,
	cgraph_varpool_n_nodes, cgraph_varpool_nodes_queue): GTYize.
	* gengtype.c (open_base_files): Include cgraph.h

2003-06-30  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* Changelog: Remove ">>>>>>>" from previous change.

2003-06-30  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* config/cris/cris.c: Fix spelling for "testcase".
	* config/cris/cris.h: Likewise.
	* config/cris/cris.md: Likewise.
	* config/mmix/crti.asm: Likewise.
	* config/mmix/mmix.h: Likewise.
	* config/mmix/mmix.md: Likewise.

2003-06-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (LEGITIMATE_CONSTANT_P): Make it always
	1.

2003-06-30  Ulrich Weigand  <uweigand@de.ibm.com>

	* config.gcc [s390*-*-*]: Support --with-arch, --with-tune, and
	--with-mode configure options.
	* config/s390/s390.h (OPTION_DEFAULT_SPECS): Define.
	(DRIVER_SELF_SPECS): Define.
	* config/s390/linux.h (ASM_SPEC): Pass architecture mode and cpu
	architecture to assembler.
	(LINK_SPEC): Merge 31-bit and 64-bit variants.
	(LINK_ARCH31_SPEC, LINK_ARCH64_SPEC, EXTRA_SPECS): Remove.
	* config/s390/s390.c (override_options): New default rules for
	architecture mode and cpu architecture selection.
	* doc/invoke.texi (-mesa, -mzarch, -march, -mtune): Document
	new default rules.

	* config/s390/s390.h (enum processor_type): Add PROCESSOR_2084_Z990.
	* config/s390/s390.md (attr "cpu"): Add "z990" processor type.
	* config/s390/s390.c (override_options): Add "z990" to
	processor_alias_table.
	* doc/invoke.texi (-march): Document "z990" processor type.

	* config/s390/s390.c (s390_tune_flags, s390_arch_flags): New variables.
	* config/s390/s390.h (s390_tune_flags, s390_arch_flags): Declare.
	(enum processor_flags, TARGET_CPU_IEEE_FLOAT, TARGET_CPU_ZARCH,
	TARGET_CPU_LONG_DISPLACEMENT, TARGET_LONG_DISPLACEMENT): New.
	* config/s390/s390.c (override_options): Replace enum pta_flags by
	enum processor_flags.  Fill in s390_tune_flags and s390_arch_flags.

	* config/s390/s390.c (s390_cpu): Rename to ...
	(s390_tune): ... this.
	* config/s390/s390.h (s390_cpu, s390_tune): Likewise.
	* config/s390/s390.c (s390_issue_rate, override_options): Likewise.
	* config/s390/s390.md (attr "cpu"): Likewise.

2003-06-30  Neil Booth  <neil@daikokuya.co.uk>

	* c-common.c (enum c_language_kind, flag_objc): Remove.
	(fix_string_type, check_case_value, c_common_nodes_and_builtins,
	c_add_case_label, finish_label_addr_expr, boolean_increment):
	Use c_dialect_ macros.
	* c-common.h (enum c_language_kind): Extend.
	(c_dialect_cxx, c_dialect_objc): New.
	(flag_objc): Remove.
	(c_common_init_options): Update prototype.
	* c-cppbuiltin.c (define__GNUC__, c_cpp_builtins): Use c_dialect_
	macros.
	* c-decl.c (finsih_decl, grokfield, finish_struct): Use c_dialect_
	macros.
	* c-format.c (C_STD_VER, C_STD_NAME): Similarly.
	* c-lang.c (c_init_options): Remove.
	(c_language): Define.
	(LANG_HOOKS_INIT_OPTIONS): Use common hook.
	* c-lex.c (lex_charconst): Use c_dialect_ macros.
	* c-opts.c (lang_flags): Make function-local.
	(c_common_init_options): Use c_dialect_ macros.  Handle
	C++ diagnostic requirements.
	(c_common_handle_option, c_common_post_options): Use flag_cxx.
	* c-parse.in (init_reswords): Use c_dialect_objc ().
	* c-pch.c (get_ident): Use c_language.
	* c-pretty-print.c (pp_c_bool_literal): Use c_dialect_ macros.
	* c-typeck.c (comptypes, build_c_cast): Similarly.
	* objc/objc-lang.c (c_language): Define.
	(LANG_HOOKS_INIT_OPTIONS): Use common hook.
	(objc_init_options): Remove.

2003-06-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/alpha/alpha.h (FUNCTION_ARG_PADDING): Remove.
	* config/alpha/unicosmk.h: Don't #undef FUNCTION_ARG_PADDING.

2003-06-30  Wolfgang Bangerth  <bangerth@dealii.org>

	* doc/sourcebuild.texi: Don't reference gnats.html any more.

2003-06-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (compute_mov_length): Fix length of
	mov:SF on H8/300.

2003-06-30  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.h (BIGGEST_FIELD_ALIGNMENT): Make defintion
	constant.

Mon Jun 30 15:36:29 CEST 2003  Jan Hubicka  <jh@suse.cz>

	(fyl2x_sfxf3, fyl2x_dfxf3, fscale_sfxf3, fscale_dfxf3): Fix condition.

2003-06-30 Hartmut Penner  <hpenner@de.ibm.com>

	* config/rs6000/rs6000.c (rs6000_split_altivec_in_gprs): New function.
	(altivec_in_gprs_p): New function.

	* config/rs6000/rs6000-protos (rs6000_split_altivec_in_gprs): New
	prototype.
	(altivec_in_gprs_p): New prototype.

	* config/rs6000/altivec.md (*movv4si_internal): Change
	multi-assembler alternative to '#'. Add postreload splitter to
	handle this cases.
	(*movv4hi_internal): Likewise.
	(*movv4qi_internal): Likewise.
	(*movv4sf_internal): Likewise.

2003-06-30  Jason Merrill  <jason@redhat.com>

	* defaults.h (PUSH_ARGS_REVERSED): Define default here.
	* calls.c: Not here.

2003-06-30  Ben Elliston  <bje@wasabisystems.com>

	* config/arm/arm.c (arm_rtx_costs): Remove #if 0 block.
	(bad_signed_byte_operand): Likewise.
	(arm_output_epilogue): Likewise.
	(arm_final_prescan_insn): Likewise.

2003-06-30  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* cfgrtl.c (mark_killed_regs): Cast HARD_REGNO_NREGS to int.

2003-06-30  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* c-pch.c (c_common_write_pch): Flush asm_out_file to allow for
	subsequent writes.

Mon Jun 30 10:03:02 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cfgrtl.c (verify_flow_info): Accept degenerated condjumps
	in cfglayout mode.

Mon Jun 30 09:52:39 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.c (standard_80387_constant_p): Accept TFmode constants too.
	(init_ext_80387_constants): Likewise.
	(standard_80387_constant_rtx): Likewise.
	* i386.md (atanxf): Disable for TARGET_128BIT_LONG_LONG
	(atantf): Disable for !TARGET_128BIT_LONG_LONG
	(fyl2x_sfxf3, fyl2x_dfxf3): Accept TFmode operands.
	(fyl2x_xfxf3, fyl2x_tfxf3): Enable/disable as needed.
	(fscale_sfxf3, fscale_dfxf3): Accept TFmode operands.
	(fscale_xfxf3, fscale_tfxf3): Enable/disable as needed.
	(frndinttf2): New.
	(f2xm1tf2): New.
	(exp?f2): Use expsf2_tf when needed.
	(exp?f2_tf): New.
	(exptf): New.

2003-06-29 Uwe Stieber <uwe@kaos-group.de>

	* config.gcc (sh*-*-kaos*): Put tm_file setting in separate case
	statement from tmake_file set.

2003-06-29  James E Wilson  <wilson@tuliptree.org>

	* reload.c (find_reloads): Change push_reloads to push_reload in
	comment.
	* reload1.c (eliminate_regs): Likewise.
	(dump_needs): Delete prototype for deleted function.

2003-06-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtin-attrs.def (gcc_diag, gcc_cdiag, gcc_cxxdiag): New
	format attributes.
	* c-format.c (enum format_type): Add gcc_diag_format_type,
	gcc_cdiag_format_type, and gcc_cxxdiag_format_type.
	(gcc_diag_length_specs, gcc_cdiag_length_specs,
	gcc_cxxdiag_length_specs, gcc_diag_flag_pairs,
	gcc_cdiag_flag_pairs, gcc_cxxdiag_flag_pairs, gcc_diag_flag_specs,
	gcc_cdiag_flag_specs, gcc_cxxdiag_flag_specs, gcc_diag_char_table,
	gcc_cdiag_char_table, gcc_cxxdiag_char_table): New.
	(format_types_orig): Add new data.
	(find_char_info_specifier_index, init_dynamic_diag_info): New
	functions.
	(handle_format_attribute): Update to handle new format attributes.

2003-06-29  Dara Hazeghi  <dhazeghi@yahoo.com>

	* doc/install.texi: Remove install documentation for obsoleted targets
	i?86-*-sco, i?86-*-sco3.2v4, powerpcle-*-pe, powerpcle-*-winnt,
	arm-*-aof.
	Update information about IA64 toolchain, AIX make requirements,
	and binutils for m68k-*-hpux and *-*-linuxaout targets.

Mon Jun 30 00:50:43 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* regmove.c (regmove_optimize): Don't try to make src and dst match
	when they are in different modes.

Sun Jun 29 23:06:32 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* builtins.c (expand_builtin_mathfn, expand_builtin_mathfn_2): Avoid
	busy work when builtin is not supported by the backend.

2003-06-29  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* loop.c (count_one_set): Fix detection of registers set in more
	than one basic block.

2003-06-29  Andreas Jaeger  <aj@suse.de>

	* target-def.h: Remove usage of OBJECT_FORMAT_ROSE.
	* system.h: Poison OBJ_FORMAT_ROSE.
	* doc/tm.texi (Macros for Initialization): Remove documentatin of
	OBJECT_FORMAT_ROSE.
	* config/rs6000/lynx.h: Remove undef of OBJECT_FORMAT_ROSE.
	* collect2.c: Remove usage of OBJECT_FORMAT_ROSE.

2003-06-29  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (update_total_code_bytes): New function.
	(last_address): Number of bytes output for a function and its
	associated thunks.
	(compute_frame_size): Use BITS_PER_UNIT.
	(pa_output_function_epilogue): Compute last_address.  Use
	update_total_code_bytes.
	(output_lbranch): Handle long branch on portable runtime.
	(attr_length_millicode_call, attr_length_call,
	attr_length_indirect_call): Only use total_code_bytes for calls in
	the text section.
	(output_call): Only use an indirect call sequence when the target is
	not local.
	(pa_asm_output_mi_thunk): Handle updating of total_code_bytes.  Improve
	test to determine when an IA-relative branch can be used.  Add various
	long branch sequences.  Avoid using an indirect branch on all ports
	except SOM.

2003-06-29  Ulrich Weigand  <uweigand@de.ibm.com>

	* expr.c (clear_by_pieces): Fix prototype.

2003-06-29  Andreas Jaeger  <aj@suse.de>

	* cse.c: Convert prototypes to ISO C90.
	* cselib.c: Likewise.
	* cselib.h: Likewise.
	* dbxout.c: Likewise.
	* debug.c: Likewise.
	* df.c: Likewise.
	* df.h: Likewise.
	* dojump.c: Likewise.
	* doloop.c: Likewise.
	* dominance.c: Likewise.
	* dwarf2asm.c: Likewise.
	* dwarf2out.c: Likewise.
	* dwarf2out.h: Likewise.
	* dwarfout.c: Likewise.
	* except.c: Likewise.
	* except.h: Likewise.
	* emit-rtl.c: Likewise.
	* et-forest.c: Likewise.
	* et-forest.h: Likewise.
	* except.c: Likewise.
	* explow.c: Likewise.
	* expmed.c: Likewise.
	* expr.c: Likewise.
	* expr.h: Likewise.

2003-06-29  Kazu Hirata  <kazu@cs.umass.edu>

	* alloc-pool.c: Fix comment formatting.
	* bitmap.c: Likewise.
	* bitmap.h: Likewise.
	* bt-load.c: Likewise.
	* builtins.c: Likewise.
	* caller-save.c: Likewise.
	* cfganal.c: Likewise.
	* cfgrtl.c: Likewise.
	* collect2.c: Likewise.
	* cse.c: Likewise.
	* df.c: Likewise.
	* diagnostic.c: Likewise.
	* dwarf2out.c: Likewise.
	* dwarfout.c: Likewise.
	* expmed.c: Likewise.
	* final.c: Likewise.
	* flags.h: Likewise.
	* fold-const.c: Likewise.
	* gcc.c: Likewise.
	* gcov-io.h: Likewise.
	* gcov.c: Likewise.
	* genattrtab.c: Likewise.
	* genautomata.c: Likewise.
	* libgcov.c: Likewise.
	* mips-tfile.c: Likewise.
	* optabs.c: Likewise.
	* prefix.c: Likewise.
	* rtlanal.c: Likewise.
	* stmt.c: Likewise.
	* stor-layout.c: Likewise.
	* toplev.c: Likewise.
	* varasm.c: Likewise.
	* vmsdbgout.c: Likewise.

2003-06-29  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c (emit_single_push_insn): If padding is needed
	downward, adjust the stack pointer first, and then store the
	data into the stack location using an offset.

2003-06-29  Andreas Jaeger  <aj@suse.de>

	* collect2.h: Convert prototypes to ISO C90.
	* collect2.c: Likewise.
	* conflict.c: Likewise.
	* coverage.c: Likewise.
	* convert.h: Likewise.
	* convert.c: Likewise.

2003-06-29  Nathan Sidwell  <nathan@codesourcery.com>

	* c-decl.c (c_init_decl_processing): Use a location_t. Set input
	filename to <internal>.
	* tree.c (make_node): Just copy the current location.

2003-06-29  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11210
	* fold-const (decode_field_reference): Revert 2003-06-26 patch.

2003-06-29  Neil Booth  <neil@daikokuya.co.uk>

	* toplev.c (flag_dummy): Remove.
	(f_options): Restore flag pointers.

2003-06-29  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (processor_target_table): Add 970.
	* config.gcc: Add 970.

2003-06-29  Kazu Hirata  <kazu@cs.umass.edu>

	* dwarf2out.c (add_AT_string): Replace ggc_alloc_string (X,
	-1) with ggc_strdup.
	* stmt.c (expand_asm_operands): Likewise.
	* config/rs6000/rs6000.md (builtin_setjmp_receiver): Likewise.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/ip2k/ip2k.c (ip2k_reorg): Use INSN_P instead of its
	definition.

2003-06-29  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* opts.c: Include insn-attr.h.
	* Makefile.in (opts.o): Depend on INSN_ATTR_H.

2003-06-27  J"orn Rennecke <joern.rennecke@superh.com>

	* flow.c (propagate_one_insn): Use proper test for a register
	being part of the return value.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/avr/avr.c: Fix a comment typo.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/avr/avr-protos.h: Replace avr_simplify_comparision_p
	with avr_simplify_comparison_p.
	* config/avr/avr.c: Likewise.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* builtins.c: Follow spelling conventions.
	* cgraph.c: Likewise.
	* cpplex.c: Likewise.
	* config/arm/arm.c: Likewise.
	* config/arm/iwmmxt.md: Likewise.
	* config/c4x/c4x-modes.def: Likewise.
	* config/c4x/c4x.c: Likewise.
	* config/c4x/c4x.h: Likewise.
	* config/c4x/c4x.md: Likewise.
	* config/i386/i386-interix.h: Likewise.
	* config/mips/mips.h: Likewise.

2003-06-28  Neil Booth  <neil@daikokuya.co.uk>

	* config/m68k/m68k.h (TARGET_CPU_CPP_BUILTINS): Predicate
	__mc68020__ on TARGET_68020.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c: Fix a comment typo.

2003-06-28  Nathan Sidwell  <nathan@codesourcery.com>

	* c-parse.in (yylexstring): Use a location_t.

	* diagnostic.h (diagnostic_set_info): Replace file and lineno
	parameters with a location_t.
	* diagnostic.c (diagnostic_set_info): Replace file and lineno
	parameters with a location_t.
	(inform, warning, pedwarn, error, sorry, fatal_error,
	internal_error, warning_with_decl, pedwarn_with_decl,
	error_with_decl): Adjust.
	* c-error.c (pedwarn_c99): Adjust.
	* c-format.c (status_warning): Adjust.
	* rtl-error.c (file_and_line_for_asm): Rename to ...
	(location_for_asm): Return a location_t.
	(diagnostic_for_asm): Adjust.

2003-06-28  Neil Booth  <neil@daikokuya.co.uk>

	* cpptrad.c (skip_macro_block_comment): New.
	(copy_comment): Use it if appropriate.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* gcse.c (compute_ld_motion_mems): Use INSN_P instead of its
	definition.
	(store_killed_in_insn): Likewise.
	* print-rtl.c (print_rtx): Likewise.
	* config/frv/frv.c (frv_final_prescan_insn): Likewise.
	* config/m68hc11/m68hc11.c (dead_register_here): Likewise.
	(m68hc11_reassign_regs): Likewise.
	(m68hc11_reorg): Likewise.

2003-06-28  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* diagnostic.c (output_integer_with_precision): New macro.
	(output_format): Use it.  Handle more format specifiers.
	(output_long_decimal): Remove.
	(output_unsigned_decimal): Likewise.
	(output_long_unsigned_decimal): Likewise.
	(output_octal): Likewise.
	(output_long_octal): Likewise.
	(output_hexadecimal): Likewise.
	(output_long_hexadecimal): Likewise.
	(output_long_long_decimal): Likewise.

2003-06-28  Andreas Schwab  <schwab@suse.de>

	* config/ia64/ia64.md: Follow recent emit_note API change.

2003-06-28  Nathan Sidwell  <nathan@codesourcery.com>

	* c-parse.in (%union): Replace filename & lineno with location.
	(save_filename, save_lineno): Remove.
	(save_location): New.
	(fndef, old_style_parm_decls_1, lineno_datadecl, lineno_decl,
	nested_function, notype_nested_function, if_prefix, lineno_stmt,
	lineno_label, label): Adjust.

2003-06-28  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (c_strlen): Add only_value argument.
	Handle COND_EXPR and COMPOUND_EXPR.
	(expand_builtin_strlen): Optimize also strlen (i++ ? "foo" : "bar").
	Adjust c_strlen callers.
	(expand_builtin_strcpy, expand_builtin_strncpy,
	expand_builtin_strcmp, expand_builtin_strncmp,
	expand_builtin_fputs, expand_builtin_sprintf,
	fold_builtin): Adjust c_strlen callers.

2003-06-28  Josef Zlomek  <zlomekj@suse.cz>

	* bb-reorder.c (find_traces_1_round): Do not send basic block
	to next round when we are in the last round.

2003-06-28  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in: Update.
	* opts.c: Include tm_p.h.
	(handle_options): Make static.
	(decode_options): Copied from toplev.c.
	* opts.h (decode_options): New.
	* toplev.c (parse_options_and_default_flags): Move most to opts.c,
	some to...
	(general_init): ...here.
	(toplev_main): Use decode_options instead.
	* toplev.h (save_argc, save_argv): New.

2003-06-28  Kazu Hirata  <kazu@cs.umass.edu>

	* explow.c (find_next_ref): Remove.
	* rtl.h: Remove the prototype for find_next_ref.

2003-06-27  Roger Sayle  <roger@eyesopen.com>

	* config/alpha/alpha.md (anonymous define_split): Adjust emit_note
	call to match recent API change.

2003-06-27  Zack Weinberg  <zack@codesourcery.com>

	* dbxout.c (flag_debug_only_used_symbols): Delete redundant
	declaration.

	* c-format.c (check_format_string, get_constant)
	* cfgrtl.c (rtl_split_edge):
	Mark the definition static, matching the forward declaration.

2003-06-27  Gunther Nikl <gni@gecko.de>

	* unwind-c.c (PERSONALITY_FUNCTION): Delete duplicate define.

	PR target/11014
	* config/m68k/m68k.c (m68k_output_mi_thunk): Use correct assembly
	syntax for MIT / MOTOROLA.

	PR other/10240
	* configure.in: Removed $(XCFLAGS) from BUILD_CFLAGS for build != host.
	* configure: Rebuilt.

2003-06-27  Chris Demetriou  <cgd@broadcom.com>

	* config/mips/mips.c (mips_build_va_list): Make padding in
	va_list structure explicit to avoid -Wpadded warnings.

2003-06-27  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.h (SECONDARY_OUTPUT_RELOAD_CLASS): Define.
	* config/s390/s390.c (s390_secondary_output_reload_class): New function.
	* config/s390/s390-protos.h (s390_secondary_output_reload_class):
	Declare it.
	* config/s390/s390.md ("reload_outti", "reload_outdi",
	"reload_outdf"): New expanders.

	* config/s390/s390.md ("movti" + splitters): Handle non-offsettable
	memory operands as source.
	("movdi" + splitters): Likewise.
	("movdf" + splitters): Likewise.
	* config/s390/s390.c (s390_split_ok_p): New function.
	* config/s390/s390-protos.h (s390_split_ok_p): Declare it.

2003-06-27  Kazu Hirata  <kazu@cs.umass.edu>

	* combine.c (force_to_mode): Replace the equality comparison
	of INTVALs with a pointer equality comparison.
	(simplify_comparison): Likewise.

2003-06-27  Kazu Hirata  <kazu@cs.umass.edu>

	* jump.c (rtx_renumbered_equal_p): Replace an expression that
	is known to be 0 with 0.

2003-06-27  Kazu Hirata  <kazu@cs.umass.edu>

	* gcse.c (expr_equiv_p): Replace expressions that are known to
	be 0 with 0.

2003-06-27  Kazu Hirata  <kazu@cs.umass.edu>

	* cse.c (fold_rtx): Replace the equality comparison of INTVALs
	with a pointer equality comparison.

2003-06-27  Kazu Hirata  <kazu@cs.umass.edu>

	* rtlanal.c (reg_mentioned_p): Return 0 earlier if REG and IN
	are known to be not equivalent.

2003-06-27  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (function_arg): Don't pass small aggregates
	in floating point registers.  Validate that we don't receive complex
	values here.  Use #elif.
	(return_in_memory, function_value): New.
	(alpha_va_arg): Handle complex values as two arguments.
	* config/alpha/alpha.h (RETURN_IN_MEMORY): Use return_in_memory.
	(FUNCTION_VALUE, LIBCALL_VALUE): Use function_value.
	(SPLIT_COMPLEX_ARGS): New.
	* config/alpha/alpha-protos.h: Update.

2003-06-27  Ulrich Weigand  <uweigand@de.ibm.com>

	* ggc-page.c (inverse_table): Change type of mult to size_t.
	(compute_inverse): Compute inverse using size_t, not unsigned int.
	Compute inverse also for sizes larger than half a machine page.

Fri Jun 27 18:36:12 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_decl_compilation):  Only varpoolize argument
	when called before cgraph_optimize.

2003-06-27  Zack Weinberg  <zack@codesourcery.com>

	* config/darwin.h, config/elfos.h, config/i960/i960-coff.h
	* config/m68k/coff.h: ASM_FILE_START_FILE_DIRECTIVE should
	be TARGET_ASM_FILE_START_FILE_DIRECTIVE.

Fri Jun 27 17:41:16 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cgraph.c (cgraph_node, cgraph_varpool_node): Avoid re-initializing
	of known_decls.

2003-06-27  Hans-Peter Nilsson  <hp@axis.com>

	* defaults.h (REGISTER_MOVE_COST): Define default here.
	* regclass.c: Don't define default REGISTER_MOVE_COST here.
	* reload.c, reload1.c: Ditto.

2003-06-27  Richard Earnshaw <rearnsha@arm.com>

	* flags.h: Really install previous change.

2003-06-27  Nathan Sidwell  <nathan@codesourcery.com>

	* rtl.h (emit_note): Remove FILE parameter.
	* emit-rtl.c (emit_line_note): Adjust emit_note call.
	(emit_note): Remove FILE parameter. Adjust.
	* builtins.c (expand_builtin_expect): Adjust emit_note call.
	* c-semantics.c (genrtl_scope_stmt): Likewise.
	(expand_stmt): Likewise.
	* cfglayout.c (reemit_insn_block_notes): Likewise.
	(duplicate_insn_chain): Likewise.
	* except.c (expand_eh_region_start, expand_eh_region_end,
	sjlj_emit_function_enter): Likewise.
	* explow.c (probe_stack_range): Likewise.
	* expr.c (emit_block_move_via_loop): Likewise.
	* function.c (init_function_start, expand_function_start,
	expand_function_end, thread_prologue_and_epilogue_insns): Likewise.
	* integrate.c (expand_inline_function, copy_insn_list): Likewise.
	* reg-stack.c (compensate_edge): Likewise.
	* reload1.c (reload): Likewise.
	* rtlanal.c (hoist_insn_to_edge): Likewise.
	* stmt.c (expand_fixup, expand_start_loop, expand_start_null_loop,
	expand_loop_continue_here, expand_end_loop, expand_continue_loop,
	expand_exit_loop_top_cond, expand_value_return,
	expand_start_bindings_and_block, expand_end_bindings,
	expand_decl_cleanup, expand_start_case): Likewise.
	* unroll.c (copy_loop_body
	* config/alpha/alpha.c (alpha_output_mi_thunk_osf): Likewise.
	* config/ia64/ia64.c (ia64_output_mi_thunk): Likewise.
	* config/rs6000/rs6000.c (rs6000_emit_eh_toc_restore,
	rs6000_emit_allocate_stack, rs6000_output_function_prologue,
	rs6000_output_function_epilogue, rs6000_output_mi_thunk): Likewise.
	* config/sh/sh.c (sh_output_mi_thunk): Likewise.
	* config/sparc/sparc.c (sparc_output_mi_thunk): Likewise.

2003-06-27  Nathan Sidwell  <nathan@codesourcery.com>

	* c-tree.h (grokfield): Remove unused filename and line parameters.
	* c-decl.c (grokfield): Remove unused filename and line	parameters.
	* c-parse.in (component_decl): Adjust field grokking rules, adjust
	grokfield calls.
	(component_declarator): Likewise.
	(component_notype_declarator): Likewise.
	* objc/objc-act.c (build_module_descriptor): Adjust grokfield
	calls.
	(build_protocol_template, build_method_prototype_list_template,
	build_method_prototype_template, build_category_template,
	build_selector_template, build_class_template,
	build_super_template, build_ivar_template,
	build_ivar_list_template, build_method_list_template,
	build_method_template, add_instance_variable): Likewise.

2003-06-27  Kazu Hirata  <kazu@cs.umass.edu>

	* stmt.c (do_jump_if_equal): Return 0 earlier if OP1 and
	OP2 are known to be not equivalent.

2003-06-26  Devang Patel <dpatel@apple.com>

	* final.c (debug_flush_symbol_queue): New function.
	(debug_queue_symbol): New function.
	(debug_free_queue): New function.
	(debug_nesting): New variable.
	(symbol_queue): New variable.
	(symbol_queue_index): Same.
	(symbol_queue_size): Same.
	* debug.h (debug_flush_symbol_queue): New.
	(debug_queue_symbol): New.
	(debug_free_queue): New.
	(debug_nesting): New.
	(symbol_queue_index): New.
	* dbxout.c (DBXOUT_DECR_NESTING): New macro.
	(DBXOUT_DECR_NESTING_AND_RETURN): New macro.
	(dbxout_init): Delay symbol output.
	(dbxout_global_decl): Save, set and reset TREE_USED bit around
	dbxout_symbol() call.
	(dbxout_begin_function): Same.
	(dbxout_finish): Free symbol queue.
	(dbxout_type): Put appropriate symbols in queue.
	(dbxout_symbol): Put info for symbol's type in queue.
	Decrement/Increment nesting counts flush symbol queue appropriately.
	(dbxout_parms): Increment dbxout nesting.
	(dbxout_reg_parms): Same.
	* flags.h (flag_debug_only_used_symbols): New.
	* toplev.c (flag_debug_only_used_symbols): New variable.
	(lang_independent_options): Add entries for new option
	-feliminate-unused-debug-symbols.
	* common.opt: Add entry for -feliminate-unused-debug-symbols.
	* opts.c (common_handle_options): Same.
	* config/rs6000/darwin.h (CC1_SPEC): Interpret -gused as
	-feliminate-unused-debug-symbols.
	* doc/invoke.texi (Debugging Options): Document
	-feliminate-unused-debug-symbols.

2003-06-26  Roger Sayle  <roger@eyesopen.com>
	    Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (expand_builtin_sprintf): Use c_getstr and strlen to
	obtain the format string instead of using TREE_STRING_POINTER and
	TREE_STRING_LENGTH.  Only optimize sprintf(dst,"%s",src) when the
	return value is unused or the length of src is a known constant.

2003-06-26  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.h (REGISTER_NAMES): R0 is really AP.

2003-06-26  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (ia64_expand_call): Don't add ar.pfs for sibcalls.
	(ia64_split_call): Only load descriptor for GP register inputs.
	(ia64_expand_epilogue): Check current_frame_info.mask not
	current_function_is_leaf to restore ar.pfs.

2003-06-26  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (try_split): Append to new CALL_INSN_FUNCTION_USAGE
	instead of replacing it.

2003-06-26  Richard Henderson  <rth@redhat.com>

	* flow.c (propagate_one_insn): Kill function return value
	registers across tail calls.

	* flow.c (propagate_one_insn): Preserve live-at-end registers
	across tail calls.

2003-06-26  J"orn Rennecke <joern.rennecke@superh.com>

	* reload.c (can_reload_into): New function.
	(push_reload): Use it.

2003-06-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (compute_a_rotate_length): Fix the
	references to the amount of a rotation.

2003-06-26  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/sh/coff.h: Don't include dbxcoff.h.
	* config.gcc: List it here.

2003-06-26  Kazu Hirata  <kazu@cs.umass.edu>

	* postreload.c (reload_cse_simplify_set): Call cselib_lookup
	earlier.  Don't check if SRC is a constant.

2003-06-26  Kazu Hirata  <kazu@cs.umass.edu>

	* Makefile.in (OBJS): Add postreload.o.
	Remove cselib.h from the dependency list for reload1.o.
	Add a dependency list for postreload.o.
	* reload.h: Change the comment for the prototype of
	reload_cse_regs.
	* reload1.c: Don't include cselib.h.
	(reload_cse_regs): Move to postreload.c
	(reload_cse_regs_1): Likewise.
	(reload_cse_noop_set_p): Likewise.
	(reload_cse_simplify_set): Likewise.
	(reload_cse_simplify_operands): Likewise.
	(RELOAD_COMBINE_MAX_USES): Likewise.
	(reload_combine_ruid): Likewise.
	(LABEL_LIVE): Likewise.
	(reload_combine): Likewise.
	(reload_combine_note_use): Likewise.
	(reload_combine_note_store): Likewise.
	(reg_set_luid): Likewise.
	(reg_offset): Likewise.
	(reg_base_reg): Likewise.
	(reg_mode): Likewise.
	(move2add_luid): Likewise.
	(move2add_last_label_luid): Likewise.
	(MODES_OK_FOR_MOVE2ADD): Likewise.
	(reload_cse_move2add): Likewise.
	(move2add_note_store): Likewise.
	(reload_cse_simplify): Likewise.
	* postreload.c: New.

2003-06-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/avr/avr.c (final_prescan_insn): Remove support for
	-mrtl.
	* config/avr/avr.h (MASK_RTL_DUMP): Remove.
	(TARGET_RTL_DUMP): Likewise.
	(TARGET_SWITCHES): Remove -mrtl.

2003-06-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Change emit_a_rotate to
	output_a_rotate.  Add a prototype for compute_a_rotate_length.
	* config/h8300/h8300.c (emit_a_rotate): Change to
	output_a_rotate.
	(compute_a_rotate_length): New.
	(h8300_adjust_insn_length): Remove.
	* config/h8300/h8300.h (ADJUST_INSN_LENGTH): Remove.
	* config/h8300/h8300.md (adjust_length): Remove.
	(*rotlqi3_1): Use output_a_rotate and compute_a_rotate_length.
	(*rotlhi3_1): Likewise.
	(*rotlsi3_1): Likewise.

2003-06-26  Roger Sayle  <roger@eyesopen.com>
	    Richard Henderson  <rth@redhat.com>

	* builtins.c (expand_builtin_mathfn): Always stabilize the argument
	list against re-evaluation.  If expand_unop fails, call expand_call
	with the stabilized argument list rather than return NULL_RTX.
	(expand_builtin_mathfn2): Likewise, always stabilize the argument
	list, and call expand_call ourselves if expand_binop fails.

2003-06-26  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11210
	* fold-const (decode_field_reference): Strip only NOPs that
	don't affect the sign.

2003-06-26  Dhananjay Deshpande  <dhananjayd@kpitcummins.com>

	* gcc/config/sh/sh.md (push_fpscr): Enable for TARGET_SH2E.
	(pop_fpscr, fpu_switch): Likewise.

2003-06-26  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* value-prof.c: New.
	* value-prof.h: New.
	* Makefile.in (value-prof.o): New.
	(LIBGCOV): Add _gcov_merge_single and _gcov_merge_delta
	(profile.o): Add value-prof.h and tree.h dependency.
	* flags.h (flag_profile_values): Declare.
	* gcov-io.h (GCOV_COUNTERS, GCOV_COUNTER_NAMES, GCOV_MERGE_FUNCTIONS):
	Add new counters.
	(GCOV_COUNTER_V_INTERVAL, GCOV_COUNTER_V_POW2, GCOV_COUNTER_V_SINGLE,
	GCOV_COUNTER_V_DELTA): New counter sections.
	(__gcov_merge_single, __gcov_merge_delta): Declare.
	* flow.c (mark_used_regs): Set subregs_of_mode only when the
	structure is initialized.
	* libgcov.c (__gcov_merge_single, __gcov_merge_delta): New functions.
	* profile.c: Include value-prof.h and tree.h.
	(gen_interval_profiler, gen_pow2_profiler, gen_one_value_profiler,
	gen_const_delta_profiler, instrument_values): New static functions.
	(get_exec_counts): Fix comment.
	(branch_prob): Invoke instrument_values.
	* toplev.c (flag_profile_values): New flag.
	* doc/invoke.texi (-fprofile-values): Document.

2003-06-26  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* Makefile.in (cfgrtl.o): Add expr.h dependency.
	* cfgrtl.c: Include expr.h.
	(mark_killed_regs, safe_insert_insn_on_edge): New
	functions.
	* config/i386/i386.h (AVOID_CCMODE_COPIES): Define.
	* basic-block.h (safe_insert_insn_on_edge): Declare.

2003-06-26  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (missing_arg): Make non-static.
	(c_common_handle_option): Don't check for missing arguments.
	* opts.c (handle_option): Check for missing arguments.

2003-06-26  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/power4.md (power4-veccomplex): Correct latency.

2003-06-25  Loren James Rittle  <ljrittle@acm.org>

	* configure.in (ld_vers): Portability [sed].
	* configure: Regenerate with autoconf213.

2003-06-25  H.J. Lu <hongjiu.lu@intel.com>

	* doc/extend.texi: Document new builtin functions for Intel
	Prescott New Intrunctions.

	* doc/invoke.texi: Document new command-line options, -mpni and
	-mno-pni, for Intel Prescott New Intrunctions.

	* config.gcc (extra_headers): Add pmmintrin.h for i[34567]86-*-*.

	* config/i386/i386.c (override_options): Turn on MASK_SSE2
	for -mpni. Turn on MASK_SSE for -msse2.
	(bdesc_2arg): Add PNI builtins with 2 args.
	(bdesc_1arg): Add PNI builtins with 1 arg.
	(ix86_init_mmx_sse_builtins): Handle PNI builtins.
	(ix86_expand_builtin): Likewise.

	* config/i386/i386.h (MASK_3DNOW, MASK_3DNOW_A,
	MASK_128BIT_LONG_DOUBLE, MASK_64BIT, MASK_MS_BITFIELD_LAYOUT,
	MASK_TLS_DIRECT_SEG_REFS): Renumbered.
	(TARGET_PNI): New.
	(TARGET_SWITCHES): Don't enable MASK_SSE for -msse2 here. Add
	-mpni and -mno-pni.
	(TARGET_CPU_CPP_BUILTINS): Defined __PNI__ for PNI.
	(ix86_builtins): Add PNI builtins.
	(config/i386/i386.md): Add PNI patterns.

	* config/i386/pmmintrin.h: New file.

2003-06-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (call): Fix the insn lengths.
	(call_value): Likewise.

Thu Jun 26 00:13:35 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* c-common.c (handle_used_attribute): Use mark_referenced.
	* varasm.c (mark_referenced): Break out from ...
	(assemble_name): ... here.
	* tree.h (mark_referenced): Declare.

2003-06-25  Wolfgang Bangerth  <bangerth@dealii.org>

	* gccbug.in: Add PCH to list of categories.

2003-06-25 Martin Schaffner <schaffner@gmx.li>

	* cppfiles.c: Clarify comments.
	* cpphash.h: Likewise.
	* cpplib.h: Likewise.
	* cppmacro.c: Likewise.
	* mkdeps.h: Likewise.

2003-06-25  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (complain_wrong_lang, write_langs): Remove.
	(c_common_handle_option): Complaints about wrong language are
	handled in opts.c now.
	* opts.c (complain_wrong_lang, write_langs, handle_options): New.
	(find_opt): Fix thinko.
	(handle_option): Update prototype.  Complain about switches for
	a different front end.
	* opts.h (lang_names, handle_options): New.
	(handle_option): Remove.
	* opts.sh: Write out language names array.
	* toplev.c (parse_options_and_default_flags): Use handle_options.

2003-06-25  H.J. Lu <hongjiu.lu@intel.com>

	* config/i386/i386.c (MASK_SSE1): Removed.
	(MASK_SSE164): Removed.
	(MASK_SSE264): Removed.
	(bdesc_2arg): Replace MASK_SSE1 with MASK_SSE. Replace
	MASK_SSE164 with MASK_SSE | MASK_64BIT. Replace MASK_SSE264
	with MASK_SSE2 | MASK_64BIT.
	(bdesc_1arg): Likewise.
	(ix86_init_mmx_sse_builtins): Likewise.

	* config/i386/i386.h (TARGET_SSE): Remove MASK_SSE2.
	(TARGET_SWITCHES): Enable both MASK_SSE and MASK_SSE2 for
	-msse2.

2003-06-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* hwint.h (HOST_WIDE_INT_PRINT, HOST_WIDE_INT_PRINT_C): New macros.
	(HOST_WIDE_INT_PRINT_DEC_SPACE,
	HOST_WIDE_INT_PRINT_UNSIGNED_SPACE,
	HOST_WIDEST_INT_PRINT_DEC_SPACE,
	HOST_WIDEST_INT_PRINT_UNSIGNED_SPACE): Delete.
	(HOST_WIDE_INT_PRINT_DEC, HOST_WIDE_INT_PRINT_DEC_C,
	HOST_WIDE_INT_PRINT_UNSIGNED, HOST_WIDE_INT_PRINT_HEX): Define in
	terms of HOST_WIDE_INT_PRINT and possibly HOST_WIDE_INT_PRINT_C.

	* final.c (asm_fprintf): Use HOST_WIDE_INT_PRINT.
	* ra-debug.c (dump_static_insn_cost): Likewise.

2003-06-26  Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.h (BIGGEST_FIELD_ALIGNMENT): Define instead
	of ADJUST_FIELD_ALIGN if IN_TARGET_LIBS.
	Replace occurances of '???' with 'XXX' incase they are
	mistaken for trigraphs.
	(THUMB_PRINT_OPERAND_ADDRESS): abort if a compound address
	does not have a register for the first operand.

2003-06-25	Dhananjay Deshpande <dhananjayd@kpitcummins.com>

	* config/sh/sh.c (sh_register_move_cost):
	Add case for moving between MAC_REGS.

2003-06-25  Zack Weinberg  <zack@codesourcery.com>

	PR 10178
	* langhooks.h (struct lang_hooks): Add no_body_blocks bool.
	* langhooks-def.h (LANG_HOOKS_NO_BODY_BLOCKS): New; default false.
	* c-lang.c, objc/objc-lang.c: Override LANG_HOOKS_NO_BODY_BLOCKS
	to true.
	* stmt.c (is_body_block): If lang_hooks.no_body_blocks, always
	return 0.

2003-06-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (bt-load.o): Depend on $(TM_P_H).
	* bt-load.c: Include "tm_p.h".

2003-06-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (compute_mov_length): Adjust for the
	new optimization.
	* config/h8300/h8300.md (*movsi_h8300): Optimize the load of
	an SImode constant whose upper and lower are the same.

Wed Jun 25 11:31:59 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* varasm.c (assemble_name): Mark needed variables even when
	global info is ready.

2003-06-24  Jerry Quinn  <jlquinn@optonline.net>

	PR other/11280
	* gcc/doc/invoke.texi (Optimization Options): Remove -Os from
	-freorder-functions description.

2003-06-25  Josef Zlomek  <zlomekj@suse.cz>

	* dwarf2out.c (gen_field_die): Return if type of decl is error mark.

2003-06-25  Neil Booth  <neil@daikokuya.co.uk>

	* opts.c (common_handle_option): Add missing break;s.

2003-06-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Add a prototype for
	compute_mov_length.
	* config/h8300/h8300.c (compute_mov_length): New.
	* config/h8300/h8300.md (*movqi_h8300): Use it.
	(*movqi_h8300hs): Likewise.
	(movstrictqi): Likewise.
	(*movhi_h8300): Likewise.
	(*movhi_h8300hs): Likewise.
	(movstricthi): Likewise.
	(*movsi_h8300): Likewise.
	(*movsf_h8300): Likewise.
	(*movsi_h8300hs): Likewise.
	(*movsf_h8300hs): Likewise.

2003-06-24  Kazu Hirata  <kazu@cs.umass.edu>

	* jump.c (next_nondeleted_insn): Remove.
	* rtl.h: Remove the prototype for next_nondeleted_insn.

2003-06-24  Roger Sayle  <roger@eyesopen.com>

	PR optimization/11311
	* builtins.c (powi_cost): Fix typo.  The number of multiplications
	required is the number to reduce the argument, result, plus the
	cost of calculating the residual, val [not n, the original value].

2003-06-24  Roger Sayle  <roger@eyesopen.com>

	* config/alpha/osf5.h (TARGET_C99_FUNCTIONS): Define.

2003-06-24  Richard Henderson  <rth@redhat.com>
	    (blame to: Loren James Rittle  <ljrittle@acm.org>)

	* real.h (ieee_extended_intel_96_round_53_format): New.
	* real.c (ieee_extended_intel_96_round_53_format): New.
	* config/i386/freebsd.h (SUBTARGET_OVERRIDE_OPTIONS): Use it
	for XFmode and TFmode.

2003-06-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (4 anonymous patterns): Give internal
	names.
	(movsi_h8300): Change the name to *movsi_h8300.
	(movsi_h8300hs): Change the name to *movsi_h8300hs.
	(movsf_h8300): Change the name to *movsf_h8300.
	(movsf_h8300hs): Change the name to *movsf_h8300hs.

2003-06-24  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (expand_builtin_strcpy): Don't evaluate side-effects in
	src twice.

2003-06-24  J"orn Rennecke <joern.rennecke@superh.com>

	Back out these patches:
	 2003-06-02  J"orn Rennecke <joern.rennecke@superh.com>
	  * sh.h (OLD_ARG_MODE): New macro.
	  (FUNCTION_ARG_ADVANCE, FUNCTION_ARG_PASS_BY_REFERENCE): Use it.
	  (FUNCTION_ARG_1): Break out of:
	  (FUNCTION_ARG).  Use OLD_ARG_MODE.
	 2003-06-06  J"orn Rennecke <joern.rennecke@superh.com>
	  * sh.h (FUNCTION_ARG_1): Consistently use NEW_MODE for the mode
	  of the generated register.

	* sh.h (FUNCTION_ARG_SCmode_WART): Define.
	(FUNCTION_ARG): Unless FUNCTION_ARG_SCmode_WART is defined and
	an even number of floating point regs are in use, use the same
	sequence of argument passing registers for SCmode as would be
	used for two SFmode values.
	* sh.c (sh_va_arg): If FUNCTION_ARG_SCmode_WART is defined,
	swap real / imaginary parts in incoming SCmode values passed
	in registers.

2003-06-24  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	PR target/11260
	* config/alpha/alpha.md (sqrtdf2): Fix operand substitution.

Tue Jun 24 18:49:33 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* Makefile.in (cgraph.o): Depend on output.h, not depend on
	tree-inline.h
	* cgraph.c: Do not include tree-inline.h; include output.h
	(known_fns): Rename to ...
	(known_decls): ... this one; update all uses.
	(cgraph_varpool_hash): New static variable.
	(cgraph_varpool_n_nodes, cgraph_varpool_nodes_queue): New global
	variables.
	(cgraph_varpool_hash_node, eq_cgraph_varpool_node, cgraph_varpool_node,
	cgraph_varpool_node_for_identifier, cgraph_varpool_mark_needed_node,
	cgraph_varpool_finalize_decl, cgraph_varpool_assemble_pending_decls):
	New functions.
	* cgraph.h (cgraph_varpool_node): New structure.
	(cgraph_varpool_n_nodes, cgraph_varpool_nodes_queue): Declare.
	(cgraph_varpool_node, cgraph_varpool_node_for_identifier,
	cgraph_varpool_finalize_decl, cgraph_varpool_mark_needed_node,
	cgraph_varpool_asemble_pending_decls): Declare.
	* cgraphunit.c (record_call_1): Notice variable references.
	(cgraph_finalize_compilation_unit): Assemble pending variables.
	* toplev.c (wrapup_global_declarations): Use varpool.
	(compile_file): Assemble pending declarations.
	(rest_of_decl_compilation): Use varpool in unit-at-a-time mode.
	* varasm.c (assemble_name): Notice varpool references.

Tue Jun 24 13:52:11 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* langhooks-def.h (LANG_HOOKS_PREPARE_ASSEMBLE_VARIABLE): New macro.
	* langhooks.h (lang_hooks_for_decls): Add prepare_assemble_variable.
	* varasm.c (assemble_variable): Call prepare_assemble_variable.

2003-06-23  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_builtin): Use expand_builtin_pow to expand
	calls for pow, powf, powl and their __builtin_ variants.
	(expand_builtin_pow): If the second argument is a constant
	integer and compiling with -ffast-math, use expand_powi to
	generate RTL if powi_cost is less than POWI_MAX_MULTS.
	(powi_cost): New function to return the number of multiplications
	necessary to evaluate an Nth power, for integer constant N.
	(expand_powi): New function to expand the RTL for evaluating
	the Nth power of a floating point value, for integer constant N.

	* doc/tm.texi (POWI_MAX_MULTS): Document new target macro.

Mon Jun 23 23:07:35 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cgraph.c (cgraph_nodes_queue): Declare.
	(eq_node): Take identifier as p2.
	(cgraph_node): Update htab_find_slot_with_hash call.
	(cgraph_node_for_identifier): New.
	(cgraph_mark_needed_node): Move here from cgraphunit.c.
	* cgraph.h (cgraph_nodes_queue): Declare.
	(cgraph_node_for_identifier): Declare.
	* cgraphunit.c (cgraph_finalize_function): Collect entry points here
	instead of in cgraph_finalize_compilation_unit; constructors and
	destructors are entry points.
	(cgraph_finalize_compilation_unit): Reorganize debug outout;
	examine nested functions after lowerng; call collect_functions hook.
	(cgraph_mark_local_functions): DECL_COMDAT functions are not local.
	(cgraph_finalize_compilation_unit): Do not collect entry points.
	* varasm.c: Include cgraph.h
	(assemble_name): Mark referenced identifier as needed.

	* cgraphunit.c (record_call_1): Use get_callee_fndecl.

2003-06-23  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (x86_output_mi_thunk): Don't pass MEM to %P0,
	just SYMBOL_REF.
	* config/s390/s390.c (s390_output_mi_thunk): Avoid .plt in -m31
	mode, as it requires pic register loaded.

	* varasm.c (resolve_unique_section): Remove prototype.  No longer
	static.
	* tree.h (resolve_unique_section): New prototype.

2003-06-23  Andreas Schwab  <schwab@suse.de>

	PR debug/9905
	* dwarf2out.c (loc_descriptor_from_tree): Handle MODIFY_EXPR by
	recursing through first argument.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog.1: Fix a typo.
	* cfgrtl.c: Fix comment typos.
	* dwarf2out.c: Likewise.
	* expmed.c: Likewise.
	* genrecog.c: Likewise.
	* jump.c: Likewise.
	* rtlanal.c: Likewise.
	* ssa-dce.c: Likewise.
	* toplev.c: Likewise.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/extend.texi: Fix typos.
	* doc/md.texi: Likewise.
	* doc/tm.texi: Likewise.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* basic-block.h: Fix comment formatting.
	* bt-load.c: Likewise.
	* builtins.c: Likewise.
	* c-common.c: Likewise.
	* c-common.h: Likewise.
	* c-format.c: Likewise.
	* coverage.c: Likewise.
	* cpplib.h: Likewise.
	* cpppch.c: Likewise.
	* dbxout.c: Likewise.
	* diagnostic.c: Likewise.
	* dwarf2out.c: Likewise.
	* expr.c: Likewise.
	* fold-const.c: Likewise.
	* function.c: Likewise.
	* gcc.c: Likewise.
	* gcov-io.c: Likewise.
	* gcov-io.h: Likewise.
	* gcov.c: Likewise.
	* profile.c: Likewise.
	* real.h: Likewise.
	* sched-deps.c: Likewise.

2003-06-23  Roger Sayle  <roger@eyesopen.com>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add a note on testing and
	remove duplicates from testers list.

2003-06-23  Nick Clifton  <nickc@redhat.com>

	* read-rtl.c (read_braced_string): Check for EOF.  If
	encountered issue an error message.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Document dump options, dT and dW.

2003-06-23  Kazu Hirata  <kazu@cs.umass.edu>

	* genrecog.c (pred_table): Remove the entry for
	mode_independent_operand.
	* recog.c (next_insns_test_no_inequality): Remove.
	(mode_independent_operand): Likewise.
	* recog.h: Remove the prototype for mode_independent_operand.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (output_simode_bld): Use rotxl.l to
	store into bit 0.
	* config/h8300/h8300.md (*extzv_1_r_h8300hs): Change cc of the
	second alternative to set_znv.
	(*extzv_1_r_inv_h8300hs): Likewise.

2003-06-23  Hans-Peter Nilsson  <hp@bitrange.com>

	* configure.in (in_tree_gas): Find out here whether GAS is ELF,
	set in_tree_gas_is_elf accordingly.
	(in_tree_ld): Find out whether LD emulation is ELF, set
	in_tree_ld_is_elf accordingly.
	(gcc_cv_as_subsections, gcc_cv_as_hidden, gcc_cv_as_leb128)
	(gcc_cv_as_eh_frame, gcc_cv_as_shf_merge)
	(gcc_cv_as_dwarf2_debug_line, gcc_cv_as_gdwarf2_flag)
	(gcc_cv_as_gstabs_flag): Use $in_tree_gas_is_elf instead of
	grepping gas/Makefile.
	(gcc_cv_ld_ro_rw_mix, gcc_cv_ld_eh_frame_hdr, gcc_cv_ld_pie): Use
	$in_tree_ld_is_elf instead of grepping ld/Makefile.
	* configure: Regenerate.

2003-06-22  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_builtin_mathfn_2): Use tree_cons to build
	up the stabilized argument list, not build_tree_list.
	(expand_builtin_strcpy): Construct new argument list manually
	instead of using chainon to modify the original argument list.
	(expand_builtin_stpcpy): Construct new argument list manually
	instead of using copy_list and chainon.
	(expand_builtin_sprintf): New function.  Optimize calls to
	sprintf when the format is "%s" or doesn't contain a '%'.
	(expand_builtin): Expand BUILT_IN_SPRINTF using the new function
	expand_builtin_sprintf.

2003-06-22  Andreas Schwab  <schwab@suse.de>

	* function.c (set_insn_locators): Mark as unused.

2003-06-22  Neil Booth  <neil@daikokuya.co.uk>

	* common.opt: Add -finline-limit.
	* opts.c (common_handle_options): Handle it.
	* opts.sh: Temporary kludge for -finline-limit.
	* toplev.c (decode_f_option, independent_decode_option): Die.
	(parse_options_and_default_flags): No independent_decode_option.

2003-06-22  Andreas Jaeger  <aj@suse.de>

	* calls.c (emit_call_1): Readd lost ATTRIBUTE_UNUSED.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Document dumps, .btl, .cfg, and .bypass.

2003-06-22  Andreas Schwab  <schwab@suse.de>

	* doc/invoke.texi: Remove leading `-' from options in index.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* bt-load.c: Follow spelling conventions.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c (emit_move_insn_1): Fix a comment typo.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Alphabetize dump options.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Remove a duplicate -dk.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Update dump file names.

2003-06-22  Zack Weinberg  <zack@codesourcery.com>

	* config/i370/i370.c, config/i370/i370.h: Use HOST_CHARSET_ASCII
	and HOST_CHARSET_EBCDIC, not HC_ASCII and HC_EBCDIC.

2003-06-22  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/rtl.texi: Fix the @findex for pre_modify.

2003-06-22  Andreas Jaeger  <aj@suse.de>

	* caller-save.c: Convert to ISO C90.
	* calls.c: Likewise.
	* cfg.c: Likewise.
	* cfganal.c: Likewise.
	* cfgbuild.c: Likewise.
	* cfgcleanup.c: Likewise.
	* cfghooks.c: Likewise.
	* cfglayout.c: Likewise.
	* cfglayout.h: Likewise.
	* cfgloop.c: Likewise.
	* cfgloop.h: Likewise.
	* cfgloopanal.c: Likewise.
	* cfgloopmainip.c: Likewise.
	* cfgrtl.c: Likewise.

2003-06-22  Richard Earnshaw  <rearnsha@arm.com>

	* arm.h (BIGGEST_ALIGNMENT): Use TARGET_REALLY_IWMMXT for selecting
	64-bit alignment.

2003-06-22  Richard Earnshaw  <rearnsha@arm.com>

	* arm.md (all call_value patterns): Remove register constraints on
	value operand.

2003-06-22  Neil Booth  <neil@daikokuya.co.uk>

	* common.opt: More -f switches.
	* opts.c (common_handle_options): Handle them.
	* toplev.c (time_report): Make extern.
	(f_options): USe flag_dummy.
	(decode_f_option): No need to use f_options now.
	* toplev.h (flag_cprop_registers, flag_ssa, flag_ssa_ccp,
	flag_ssa_dce, time_report, flag_new_regalloc): Make extern.

2003-06-22  Andreas Jaeger  <aj@suse.de>

	* c-lex.c: Convert to ISO C90.
	* c-objc-common.c: Likewise.
	* c-opts.c: Likewise.
	* c-pch.c: Likewise.
	* c-ppoutput.c: Likewise.
	* c-pragma.h: Likewise.
	* c-pretty-print.c: Likewise.
	* c-pretty-print.h: Likewise.
	* c-semantics.c: Likewise.
	* c-tree.h: Likewise.
	* c-typeck.c: Likewise.

	* c-lang.c: Convert to ISO C90.

2003-06-22  Neil Booth  <neil@daikokuya.co.uk>

	* opts.c (find_opt): Fix to always guarantee a find of a
	switch with joined parameter.
	* opts.h (struct cl_option): New member back_chain.
	* opts.sh: Update to calculate and add back_chain member.

2003-06-22  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* diagnostic.h (output_host_wide_integer): Declare.
	* diagnostic.c (output_long_long_decicaml): New function.
	(output_host_wide_integer): Likewise.
	(output_format): Use them.  Handle "%ll" and "%w".

2003-06-21  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (*-*-netbsd*): Add t-libgcc-pic to tmake_file.

2003-06-21  Zack Weinberg  <zack@codesourcery.com>

	* aclocal.m4 (gcc_AC_C_CHARSET): Delete.
	* configure.in: Don't use gcc_AC_C_CHARSET.
	* configure, config.in: Regenerate.
	* config/i370/i370.c, config/i370/i370.h: Use
	(HOST_CHARSET == HC_EBCDIC) or (HOST_CHARSET == HC_ASCII)
	instead of HOST_EBCDIC or !HOST_EBCDIC.  Clarify comments a tad.

2003-06-21  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in: Update.
	* common.opt: New switches.
	* opts.c: Include diagnostic.h.
	(common_handle_option): Handle new switches.
	* toplev.c (flag_loop_optimize, flag_crossjumping, flag_if_conversion,
	flag_if_conversion2, flag_delete_null_pointer_checks,
	flag_rerun_cse_after_loop): Make extern.
	(flag_dummy): New.
	(f_options): Update to use flag_dummy for moved options.
	(decode_f_option): Some switches moved to opts.c.
	* toplev.h (flag_loop_optimize, flag_crossjumping, flag_if_conversion,
	flag_if_conversion2, flag_delete_null_pointer_checks,
	flag_rerun_cse_after_loop, flag_keep_static_consts, flag_peel_loops,
	flag_tracer, flag_thread_jumps, flag_unroll_loops,
	flag_unroll_all_loops, flag_unswitch_loops): New.

Sat Jun 21 13:41:00 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_va_arg): Fix allocation of temporary slot.

2003-06-20  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Add a prototype for
	same_cmp_preceding_p.
	* config/h8300/h8300.c (same_cmp_preceding): New.
	* config/h8300/h8300.md: Extend peephole2's that transform
	compare:SI into shorter sequences so that they can deal with
	signed comparisons.

2003-06-21  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Use Windows instead of Win32.

	Update Andreas Jaeger's entry.

	Merge the two entries of Kaveh Ghazi, David Edelsohn, and
	Loren J. Rittle.

2003-06-21  Nathanael Nerode  <neroden@gcc.gnu.org>

	* mkconfig.sh: Add multiple inclusion guards to generated headers.

2003-06-20  Neil Booth  <neil@daikokuya.co.uk>

	* c-decl.c (store_parm_decls): Make saved_warn_shadow boolean.
	* common.opt: Add remaining -W options and -g.
	* diagnostic.c (warnings_are_errors): Remove.
	* flags.h: Make most warning flags boolean.
	* opts.c (common_handle_option): Handle remaining -W options, and -g.
	Move many warning flags from toplev.c, making them boolean.
	* toplev.c: Remove many warning flags.
	(decode_W_option): Remove.
	(decode_g_option): Make extern.  Error on unknown switch.
	(lang_independent_W_options): Use warn_dummy.
	(independent_decode_option): Just handle -f switches now.
	* toplev.h (decode_g_option): New.

2003-06-20  Aldy Hernandez  <aldyh@redhat.com>

	PR/11092
	* config/rs6000/rs6000.h (LEGITIMATE_CONSTANT_P): Adjust for
	vectors.

2003-06-20  Kelley Cook  <kelleycook@wideopenwest.com>

	* opts.sh: Tweak awk script for portability.

2003-06-20  Mark Mitchell  <mark@codesourcery.com>

	PR c++/10888
	* tree-inline.c (expand_call_inline): Do not warn about failing to
	inline functions declared in system headers.
	* doc/invoke.texi (-Winline): Expand on documentation.

2003-06-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_file_start): Disable
	file_start_file_directive for ELF and not MDEBUG.

2003-06-20  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (ROUND_TYPE_ALIGN): Remove.

2003-06-20  Richard Henderson  <rth@redhat.com>

	* hooks.c (hook_int_void_no_regs): Rename from
	hook_reg_class_void_no_regs; change return type.
	* hooks.h: Update.
	* target-def.h (TARGET_BRANCH_TARGET_REGISTER_CLASS): Update.
	* target.h (branch_target_register_class): Change return type to int.
	Add documentation.
	* config/sh/sh.c (sh_target_reg_class): Change return type.
	* doc/tm.texi (TARGET_BRANCH_TARGET_REGISTER_CLASS): Likewise.

2003-06-20  Andreas Tobler <toa@pop.agri.ch>

	* c-format.c: Change _Bool to bool reverting part of the last
	patch.

2003-06-20  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* som.h (ASM_OUTPUT_SOURCE_LINE): Use targetm.strip_name_encoding to
	strip name encoding.

2003-06-20  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in (gcc_cv_as_gstabs_flag): Disable if assembler warns.
	* configure: Regenerate.
	Fixes PR driver/9362.

2003-06-20  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/alpha/alpha.c (alpha_file_start): Fix typo.

2003-06-20  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.h (PUT_SDB_FUNCTION_END): Pass 0 as third arg
	to ASM_OUTPUT_SOURCE_LINE.

2003-06-20  Daniel Egger  <degger@fhm.edu>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Building): Correct and improve statement
	about parallel builds.

2003-06-20  Andreas Jaeger  <aj@suse.de>

	* c-common.c: Change _Bool to bool reverting part of the last
	patch.

2003-06-20  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.h (expand_function_end): Remove all parameters.
	* function.c (expand_function_end): Remove all parameters.
	Use input_location. Never expand_end_bindings.
	* c-decl.c (c_expand_body_1): Adjust expand_function_end call.
	* coverage.c (create_coverage): Likewise.

2003-06-20  Nick Clifton  <nickc@redhat.com>

	* doc/extend.texi (ARM Built-in Functions): New node.  Document
	ARM builtin functions for iWMMXt support.

2003-06-20  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (--with-gnu-as): Mention SPARC/Solaris and
	SPARC64/Solaris as platforms where --with-gnu-as makes a difference.
	(--with-as): Add @anchor.
	(--with-gnu-ld): Fix typo.
	(--with-ld): Add @uref to --with-as.

2003-06-19  Zack Weinberg  <zack@codesourcery.com>

	* doc/tm.texi: Uniformly use @defmac for macros, rather than
	@table items.  Minor formatting and editorial corrections.

2003-06-20  Neil Booth  <neil@daikokuya.co.uk>

	* line-map.c, line-map.h: Convert to ISO prototypes.

2003-06-20  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* gcse.c (store_killed_in_insn): Fix.

2003-06-19  Zack Weinberg  <zack@codesourcery.com>

	* target.h (asm_out.file_start, file_start_app_off,
	file_start_file_directive): New hooks.
	* target-def.h (TARGET_ASM_FILE_START_FILE_DIRECTIVE,
	TARGET_ASM_FILE_START_APP_OFF, TARGET_ASM_FILE_START):
	New hook-definition macros.
	* doc/tm.texi: Document new hooks; remove docs of ASM_FILE_START.
	* varasm.c (default_file_start): New.
	* output.h: Prototype it.
	* toplev.c (init_asm_output): Use targetm.asm_out.file_start.
	* system.h: Poison ASM_FILE_START.

	* config/alpha/alpha.c (alpha_write_verstamp): Delete.
	(alpha_file_start): New, define if !TARGET_ABI_UNICOSMK.
	(unicosmk_asm_file_start): Rename unicosmk_file_start,
	make static, take no arguments.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_END,
	TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set as appropriate.
	* config/alpha/unicosmk.h: Don't define ASM_FILE_START nor
	TARGET_ASM_FILE_END.  Remove reference to ASM_FILE_START in
	comment.
	* config/arc/arc.c (arc_asm_file_start): Rename
	arc_file_start, take no arguments, make static.
	(TARGET_ASM_FILE_START): Set it.
	* config/arm/arm.c (aof_file_start): New static function.
	(TARGET_ASM_FILE_START): Set it, when appropriate.
	* config/arm/coff.h, config/arm/elf.h:
	Set TARGET_ASM_FILE_START_APP_OFF to true.
	* config/avr/avr.c (asm_file_start): Rename avr_file_start,
	take no arguments, make static.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE):
	Set them.
	* config/c4x/c4x.c (c4x_file_start): New static function.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE):
	Set them.
	* config/cris/cris.c (cris_file_start): New static function.
	(TARGET_ASM_FILE_START): Set it.
	* config/dsp16xx/dsp16xx.c (coff_dsp16xx_file_start): Rename
	dsp16xx_file_start, make static.
	(luxworks_dsp16xx_file_start): Delete.
	(TARGET_ASM_FILE_START): Set it.
	* config/h8300/h8300.c (asm_file_start): Rename
	h8300_file_start, make static, take no arguments.
	(TARGET_ASM_FILE_START): Set it.
	* config/i370/i370.c (i370_file_start): New static function.
	(TARGET_ASM_FILE_START): Set it.
	* config/i386/i386.c (x86_file_start): New static function.
	(TARGET_ASM_FILE_START): Set it.
	* config/i386/i386.h (X86_FILE_START_VERSION_DIRECTIVE,
	X86_FILE_START_FLTUSED): New macros, default to false.
	* config/i386/i386-interix.h: Override X86_FILE_START_FLTUSED to 1.
	* config/i386/sysv4.h, config/i386/sco5.h: Override
	X86_FILE_START_VERSION_DIRECTIVE to true.
	* config/ia64/ia64.c (ia64_file_start): New static function.
	(TARGET_ASM_FILE_START): Set it.
	(emit_safe_across_calls): Take no arguments.
	* config/ia64/ia64.md: Update to match.
	* config/m32r/m32r.c (m32r_asm_file_start): Rename
	m32r_file_start, make static, take no arguments.
	(TARGET_ASM_FILE_START): Set it.
	* config/m68hc11/m68hc11.c (m68hc11_asm_file_start): Rename
	m68hc11_file_start, make static, take no arguments.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set.
	(print_options): Delete.
	* config/m68k/m68k.c (m68k_hp320_file_start): New static function.
	(TARGET_ASM_FILE_START_APP_OFF): Set.
	* config/m68k/hp320.h: Set TARGET_ASM_FILE_START to
	m68k_hp320_file_start.
	* config/mips/mips.c (iris6_asm_file_start, mips_asm_file_start):
	Make static, take no arguments.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set.
	* config/mmix/mmix.c (mmix_asm_file_start): Rename
	mmix_file_start, make static, take no arguments.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set.
	* config/mn10300/mn10300.c (asm_file_start): Rename
	mn10300_file_start, make static, take no arguments.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set.
	* config/ns32k/ns32k.c (TARGET_ASM_FILE_START_APP_OFF): Set.
	* config/pa/pa.c (pa_file_start_level, pa_file_start_space,
	pa_file_start_file, pa_file_start_mcount, pa_elf_file_start,
	pa_som_file_start, pa_linux_file_start, pa_hpux64_gas_file_start,
	pa_hpux64_hpas_file_start): New static functions.
	* config/pa/elf.h: Set TARGET_ASM_FILE_START to pa_elf_file_start.
	* config/pa/pa-linux.h: Set TARGET_ASM_FILE_START to
	pa_linux_file_start.
	* config/pa/pa64-hpux.h: Set TARGET_ASM_FILE_START to
	pa_hpux64_gas_file_start or pa_hpux64_hpas_file_start, as
	appropriate.
	* config/pa/som.h: Set TARGET_ASM_FILE_START to pa_som_file_start.
	* config/rs6000/rs6000.c: Include xcoffout.h when TARGET_XCOFF.
	(rs6000_file_start): Make static, take no arguments.  Reset
	default_cpu under certain conditions.
	(rs6000_xcoff_file_start): New function.
	* config/rs6000/rs6000.h (TARGET_ASM_FILE_START): Set.
	* config/rs6000/xcoff.h (TARGET_ASM_FILE_START,
	TARGET_ASM_FILE_START_FILE_DIRECTIVE): Override.
	* config/sh/sh.c (output_file_start): Rename
	sh_file_start, make static, take no arguments.  Merge in old
	code from sh/elf.h's ASM_FILE_START, conditioned on TARGET_ELF.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set.
	* config/sh/sh.c (TARGET_ELF): Define to 0.
	* config/sh/elf.h (TARGET_ELF): Redefine to 1.
	* config/v850/v850.c (asm_file_start): Delete.
	(TARGET_ASM_FILE_START_FILE_DIRECTIVE): Set.
	* config/vax/vax.c (vax_file_start): New static function.
	(TARGET_ASM_FILE_START, TARGET_ASM_FILE_START_APP_OFF): Set.

	* config/darwin.h: Override ASM_FILE_START_FILE_DIRECTIVE to false.
	* config/elfos.h, config/svr3.h, config/arm/elf.h, config/arm/pe.h
	* config/i386/att.h, config/i386/gas.h, config/i386/linux.h
	* config/i386/sysv4.h, config/i386/sco5.h, config/i960/i960-coff.h
	* config/m68k/coff.h, config/m68k/hp320.h, config/mcore/mcore-pe.h
	* config/vax/vaxv.h: Set ASM_FILE_START_FILE_DIRECTIVE to true.

	* config/darwin.h, config/elfos.h, config/alpha/elf.h
	* config/alpha/openbsd.h, config/alpha/osf.h, config/alpha/vms.h
	* config/arc/arc.h, config/arm/aof.h, config/arm/aout.h
	* config/arm/coff.h, config/arm/elf.h, config/arm/pe.h
	* config/avr/avr.h, config/c4x/c4x.h, config/cris/cris.h
	* config/dsp16xx/dsp16xx.h, config/h8300/elf.h, config/h8300/h8300.h
	* config/i370/i370.h, config/i386/att.h, config/i386/gas.h
	* config/i386/i386-interix.h, config/i386/linux.h, config/i386/sysv4.h
	* config/i386/sco5.h, config/i960/i960-coff.h, config/i960/i960.h
	* config/ia64/ia64.h, config/ia64/sysv4.h, config/m32r/m32r.h
	* config/m68hc11/m68hc11.h, config/m68k/coff.h, config/m68k/m68k.h
	* config/mcore/mcore-pe.h, config/mips/iris6.h, config/mips/mips.h
	* config/mmix/mmix.h, config/mn10300/mn10300.h, config/ns32k/ns32k.h
	* config/pa/elf.h, config/pa/pa-linux.h, config/pa/pa64-hpux.h
	* config/pa/som.h, config/pdp11/pdp11.h, config/rs6000/linux64.h
	* config/rs6000/lynx.h, config/rs6000/xcoff.h, config/sh/elf.h
	* config/sh/sh.h, config/sparc/sparc.h, config/v850/v850.h
	* config/vax/vax.h, config/vax/vaxv.h: Don't (re)define ASM_FILE_START.

	* config/alpha/alpha-protos.h, config/arc/arc-protos.h
	* config/avr/avr-protos.h, config/dsp16xx/dsp16xx-protos.h
	* config/h8300/h8300-protos.h, config/ia64/ia64-protos.h
	* config/m32r/m32r-protos.h, config/m68hc11/m68hc11-protos.h
	* config/mips/mips-protos.h, config/mmix/mmix-protos.h
	* config/mn10300/mn10300-protos.h, config/rs6000/rs6000-protos.h
	* config/sh/sh-protos.h, config/v850/v850-protos.h: Update.

	* xcoffout.h, config/rs6000/aix.h, config/rs6000/xcoff.h:
	Remove reference to ASM_FILE_START in comment.
	* config/arm/aof.h, config/arm/aout.h, config/arm/freebsd.h
	* config/arm/linux-gas.h, config/arm/netbsd-elf.h
	* config/arm/netbsd.h: Delete definition of ARM_OS_NAME.

2003-06-19  Graeme Peterson <gp@qnx.com>

	* gcc.c (target_sysroot_suffix, target_sysroot_hdrs_suffix,
	SYSROOT_SUFFIX_SPEC, SYSROOT_HEADERS_SUFFIX_SPEC, sysroot_suffix_spec,
	sysroot_hdrs_suffix_spec): New.
	(static_specs): Initialize new variables.
	(add_sysroot_suffix_prefix, do_spec_1, main): Use new variables.
	* doc/tm.texi (SYSROOT_SUFFIX_SPEC, SYSROOT_HEADERS_SUFFIX_SPEC):
	New macros.

2003-06-19  Andreas Jaeger  <aj@suse.de>

	* c-aux-info.c: Convert to ISO C90.
	* c-pragma.c: Likewise.
	* c-common.c: Likewise.
	* c-common.h: Likewise.
	* c-convert.c: Likewise.
	* c-cppbuiltin.c: Likewise.
	* c-dump.c: Likewise.
	* c-decl.c: Likewise
	* c-format.c: Likewise.
	* c-incpath.c: Likewise.
	* c-incpath.h: Likewise.

2003-06-19  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (expand_errno_check): Assume that flag_errno_math
	and HONOR_NANS have been tested before calling here.  Only try
	to set errno ourselves if the decl can't throw an exception.
	(expand_builtin_mathfn): Move the code to stabilize the arg
	after the main switch, so that that its only done when needed.
	BUILT_IN_SQRT{,F,L} doesn't set errno if its arg is nonnegative.
	Don't modify the original expr when stabilizing the argument.
	(expand_builtin_mathfn_2): Likewise, move the code to stabilize
	the args after the main switch, and don't modify the orginal exp.

2003-06-19  Aldy Hernandez  <aldyh@redhat.com>

	* expr.c (const_vector_from_tree): Initialize remaining elements
	to 0.

2003-06-19  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/spe.md ("spe_evfscfsi"): Change operand types.
	Change "fix" to "float".

2003-06-19  Andreas Jaeger  <aj@suse.de>

	* c-tree.h: Remove declaration of poplevel.

	* tree.h: Remove declaration of approx_sqrt.

	* c-lex.c: Remove redundant declaration of asm_out_file.

	* flags.h: Remove declaration of warn_unknown_pragma and
	main_input_filename.

	* rtl.h: Remove functions from fold-const.c since they're already
	declared in tree.h.

	* regs.h: Remove redundant declaration of reg_names.

	* bt-load.c (migrate_btr_defs): Correct printf arguments.

	* protoize.c: Fix breakage from last patch.

2003-06-19  J"orn Rennecke <joern.rennecke@superh.com>

	* hooks.h (hook_reg_class_void_no_regs): Only declare if tm.h
	has been included.

2003-06-18  James A Morrison <ja2morri@student.math.uwaterloo.ca>

	* config/sparc/sparc.c: Update copyright year.

2003-06-19  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (init_cumulative_args): Limit CALL_LIBCALL
	to ABI_V4.

2003-06-18  Joseph S. Myers  <jsm@polyomino.org.uk>

	PR bootstrap/4068
	* config/i386/liunx.h: Don't include sys/ucontext.h for glibc 2.0.

2003-06-19  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (TARGET_INITIALIZER and friends): Move
	to the end of the file.  Remove unnecessary prototypes.

2003-06-19  Hans-Peter Nilsson  <hp@axis.com>

	* bt-load.c (migrate_btr_def) [INSN_SCHEDULING]: Conditionalize
	calls to insn_default_latency and result_ready_cost.  Initialize
	def_latency to 1.

2003-06-18  Richard Henderson  <rth@redhat.com>

	* config/ia64/unwind-ia64.c (_Unwind_GetCFA): New.
	(_Unwind_FindEnclosingFunction): Implement.

2003-06-18  Kazu Hirata  <kazu@cs.umass.edu>

	* toplev.c (rest_of_handle_sched): Hide the entire function if
	INSN_SCHEDULING is not defined.
	(rest_of_compilation): Call rest_of_handle_sched() only when
	INSN_SCHEDULING is defined.

2003-06-18  Stephen Clarke <stephen.clarke@superh.com>
	    J"orn Rennecke <joern.rennecke@superh.com>

	* bt-load.c: New file.
	* Makefile.in (OBJS): Include bt-load.o
	(bt-load.o): Add dependencies.
	* flags.h (flag_branch_target_load_optimize): Declare.
	(flag_branch_target_load_optimize2): Likewise.
	* hooks.c (hook_reg_class_void_no_regs): New function.
	(hook_bool_bool_false): Likewise.
	* hooks.h (hook_reg_class_void_no_regs, hook_bool_bool_false): Declare.
	* rtl.h (branch_target_load_optimize): Declare.
	* target-def.h (TARGET_BRANCH_TARGET_REGISTER_CLASS): Define.
	(TARGET_BRANCH_TARGET_REGISTER_CALLEE_SAVED): Likewise.
	(TARGET_INITIALIZER): Include these.
	* target.h (struct gcc_target): Add branch_target_register_class
	and branch_target_register_callee_saved members.
	* toplev.c (enum dump_file_index): Add DFI_branch_target_load
	(dump_file) Add "tars" entry.
	(flag_branch_target_load_optimize): New variable.
	(flag_branch_target_load_optimize2): Likewise.
	(lang_independent_options): Add entries for new options.
	(rest_of_compilation): Call branch_target_load_optimize.
	* doc/tm.texi (TARGET_BRANCH_TARGET_REGISTER_CLASS): Document.
	(TARGET_BRANCH_TARGET_REGISTER_CALLEE_SAVED): Likewise.
	* doc/invoke.texi: Document -fbranch-target-load-optimize and
	-fbranch-target-load-optimize2.
	* rtl.h (epilogue_completed): Declare.
	* recog.c (epilogue_completed): New variable.
	* toplev.c (rest_of_compilation): Set it.
	* flow.c (mark_regs_live_at_end): Use it.
	* config/ia64/ia64.c (ia64_output_mi_thunk): Set it.
	* config/rs6000/rs6000.c (rs6000_output_mi_thunk): Likewise.
	* config/sh/sh.c (sh_output_mi_thunk): Likewise.
	* config/sparc/sparc.c (sparc_output_mi_thunk): Likewise.

	* sh.c (shmedia_space_reserved_for_target_registers): New variable.
	(sh_target_reg_class): New function.
	(sh_optimize_target_register_callee_saved): Likwise.
	(shmedia_target_regs_stack_space): Likewise.
	(shmedia_reserve_space_for_target_registers_p): Likewise.
	(shmedia_target_regs_stack_adjust): Likewise.
	(TARGET_BRANCH_TARGET_REGISTER_CLASS): Override.
	(TARGET_BRANCH_TARGET_REGISTER_CALLEE_SAVED): Likewise.
	(calc_live_regs): If flag_branch_target_load_optimize2 and
	TARGET_SAVE_ALL_TARGET_REGS is enabled, and we have space reserved
	for target registers, make sure that we save all target registers.
	(sh_expand_prologue, sh_expand_epilogue): Take target register
	optimizations into account.  Collapse stack adjustments if that
	is beneficial.
	(initial_elimination_offset): Reserve space for target registers
	if necessary.
	* sh.h (SAVE_ALL_TR_BIT, TARGET_SAVE_ALL_TARGET_REGS): Define.
	(OPTIMIZATION_OPTIONS): Enable flag_branch_target_load_optimize.

2003-06-18  Nick Clifton  <nickc@redhat.com>

	* config.gcc: Add an extra_header for ARM targets.
	Support configuring with --with-cpu=iwmmxt.
	* doc/invoke.texi: Document new value for -mcpu= ARM switch.
	* config/arm/aof.h (REGISTER_NAMES): Add iwmmxt register
	names.  Fix formatting.
	* config/arm/aout.h (REGISTER_NAMES): Add iwmmxt register
	names.
	* config/arm/arm-protos.h (arm_emit_vector_const): New
	prototype.
	(arm_output_load_gr): New prototype.
	* config/arm/arm.c (extra_reg_names1): Delete.
	(TARGET_INIT_BUILTINS, TARGET_EXPAND_BUILTIN, FL_IWMMXT,
	* arch_is_iwmmxt): Define.
	(all_cores, all_architecture): Add entry for iwmmxt.
	(arm_override_options): Add support for iwmmxt.
	(use_return_insn, arm_function_arg, arm_legitimate_index_p,
	arm_print_value, arm_rtx_costs_1, output_move_double,
	arm_compute_save_reg_mask, arm_output_epilogue,
	arm_get_frame_size, arm_expand_prologue, arm_print_operand,
	arm_assemble_integer, arm_hard_regno_ok, arm_regno_class):
	Likewise.
	(arm_init_cumulative_args): Count iwmmxt registers.
	(arm_function_ok_for_sibcall): Return false of sibcall_blocked
	has been set.
	(struct minipool_node): Add fix_size field.
	(add_minipool_forward_ref): Add support for 8-byte aligning of
	the pool.
	(add_minipool_backward_ref, add_minipool_offsets,
	dump_minipool, push_minipool_fix): Likewise.
	(struct builtin_description): New struct.
	(builtin_description): New array of iwmmxt builtin functions.
	(arm_init_iwmmxt_builtins): New function.
	(arm_init_builtins): New function.
	(safe_vector_operand): New function.
	(arm_expand_binop_builtin): New function.
	(arm_expand_unop_builtin): New function.
	(arm_expand_builtin): New function.
	(arm_emit_vector_const): New function.
	(arm_output_load_gr): New function.
	* config/arm/arm.h (TARGET_CPU_iwmmxt, TARGET_IWMMXT,
	TARGET_REALLY_IWMMXT, arm_arch_iwmmxt, IWMMXT_ALIGNMENT,
	TYPE_NEEDS_IWMMXT_ALIGNMENT, ADJUST_FIELD_ALIGN,
	DATA_ALIGNMENT, LOCAL_ALIGNMENT, VECTOR_MODE_SUPPORTED_P): Define.
	(BIGGEST_ALIGNMENT): Set to 64 if ATPCS support is enabled.
	(CPP_CPU_ARCH_SPEC): Add entries for iwmmxt.
	(FIXED_REGISTERS, CALL_USED_REGISTERS, REG_ALLOC_ORDER,
	reg_class, REG_CLASS_NAMES, REG_CLASS_CONTENTS,
	REG_CLASS_FOR_LETTER): Add iwmmxt registers.
	(SUBTARGET_CONDITIONAL_REGISTER_USAGE): Disable iwmmxt
	registers unless the iwmmxt target is selected.
	(FIRST_IWMMXT_GR_REGNUM, LAST_IWMMXT_GR_REGNUM,
	FIRST_IWMMXT_REGNUM, LAST_IWMMXT_REGNUM, IS_IWMMXT_REGNUM,
	IS_IWMMXT_GR_REGNUM): Define.
	(FIRST_PSEUDO_REGISTER): Bump to 63.
	(struct machine_function): Add sibcall_blocked field.
	(Struct CUMULATIVE_ARGS): Add iwmmxt_nregs, named_count and
	nargs fields.
	(enum arm_builtins): New enum list.
	* config/arm/arm.md (UNSPEC_WSHUFH, UNSPEC_WACC,
	UNSPEC_TMOVMSK, UNSPEC_WSAD, UNSPEC_WSADZ, UNSPEC_WMACS,
	UNSPEC_WMACU, UNSPEC_WMACSZ, UNSPEC_WMACUZ, UNSPEC_CLRDI,
	UNSPEC_WMADDS, UNSPEC_WMADDU): New unspecs.
	(VUNSPEC_TMRC, VUNSPEC_TMCR, VUNSPEC_ALIGN8, VUNSPEC_WCMP_EQ,
	VUNSPEC_WCMP_GTU, VUNSPEC_WCMP_GT): New vunspecs.
	(movv2si, movv4hi, movv8qi): New expands for vector moves.
	Include iwmmxt.md.
	* config/arm/t-xscale-elf (MULTILIB_OPITONS): Add iwmmxt
	multilib.
	(MULTILIB_DIRNAMES, MULTILIB_REDUNDANT_DIRS): Likewise.
	* config/arm/mmintrin.h: New ARM specific header file.
	* config/arm/iwmmx.md: New iWMMXt specific machine patterns.

2003-06-18  J"orn Rennecke <joern.rennecke@superh.com>

	* toplev.c (Remaining -d letters summary): Update.

2003-06-18  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* config/rs6000/rs6000.c (init_cumulative_args): Add and handle LIBCALL
	argument.
	(function_arg): Handle CALL_LIBCALL flag.
	* config/rs6000/rs6000-protos.h (init_cumulative_args): Update
	prototype.
	* config/rs6000/rs6000.h (CALL_LIBCALL): New macro.
	(INIT_CUMULATIVE_LIBCALL_ARGS): New macro.
	(INIT_CUMULATIVE_ARGS): Add LIBCALL argument.
	(INIT_CUMULATIVE_INCOMING_ARGS): Likewise.

2003-06-18  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in: Update.
	* common.opt: New options.
	* opts.c (maybe_warn_unused_parameter, set_Wextra, handle_param,
	set_Wunused): New.
	(common_handle_option): Handle new options.
	* toplev.c (set_target_switch): Export.
	(set_Wextra, set_Wunused, maybe_warn_unused_parameter): Move to opts.c.
	(decode_W_option): -Wunused and -Wextra handled in opts.c now.
	(independent_decode_option): More options handled in opts.c now.
	Change prototype.
	* toplev.h (set_target_switch): New.

2003-06-17  Robert Abeles  <rabeles@archaelogic.com>

	PR debug/4252
	* c-opts.c (c_common_handle_option): Pass -fdump argument suffix
	to dump_switch_p().
	* tree-dump.c (dump_switch_p): Remove redundant 'dump-' prefix
	from static strings in dump_files.

2003-06-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* system.h (ANSI_PROTOTYPES, PTR_CONST, LONG_DOUBLE, VPARAMS,
	VA_OPEN, VA_FIXEDARG, VA_CLOSE, VA_START): undef and poison these
	libiberty macros.

2003-06-17  Jason Merrill  <jason@redhat.com>

	PR c++/10929
	* tree-inline.c (expand_call_inline): Don't warn about failing to
	inline a function which was made inline by -finline-functions.

2003-06-17  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Update to ISO C.
	* config/h8300/h8300.c: Likewise.
	* config/h8300/h8300.h: Likewise.
	* config/h8300/h8300.md: Likewise.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Replace BUILD_CC references with CC_FOR_BUILD.
	* configure: Regenerate.
	* Makefile.in: Replace BUILD_CC references with CC_FOR_BUILD.

2003-06-17  Ranjit Mathew  <rmathew@hotmail.com>

	* install.texi (Testing): Add information on how to run Java
	runtime tests separately.

2003-06-17  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.md (trap): Use break 0 when !TARGET_GAS.

	* config/mips/iris6-o32.h (MIPS_ISA_DEFAULT): Remove.
	(MIPS_CPU_STRING_DEFAULT): Redefine to mips2.

2003-06-17  Christopher Faylor  <cgf@redhat.com>

	* doc/install.texi: Add msvc rebuild caveat.

2003-06-17  Kazu Hirata  <kazu@cs.umass.edu>

	* config/sh/coff.h: Replace Hitachi with Renesas.
	* config/sh/elf.h: Likewise.
	* config/sh/embed-elf.h: Likewise.
	* config/sh/lib1funcs.asm: Likewise.
	* config/sh/sh-protos.h: Likewise.
	* config/sh/sh.c: Likewise.
	* config/sh/sh.h: Likewise.
	* config/sh/sh.md: Likewise.

2003-06-17  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog.3: Fix comment typos.
	* ChangeLog.6: Likewise.
	* config/d30v/d30v.c: Likewise.
	* config/h8300/h8300.md: Likewise.
	* config/m32r/m32r.md: Likewise.
	* config/mips/mips.c: Likewise.
	* config/mips/mips.md: Likewise.
	* config/ns32k/NOTES: Likewise.

2003-06-17  Ranjit Mathew  <rmathew@hotmail.com>
	    Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/sourcebuild.texi (libgcj Tests): Simplify instructions on how
	to run Java runtime tests separately.

2003-06-17  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Update a comment.

2003-06-17  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (ROUND_TYPE_ALIGN, LOCAL_ALIGNMENT): Complex modes
	are aligned like integral modes.
	(SH5_WOULD_BE_PARTIAL_NREGS): Also test for CDImode and DCmode.

	* sh.h (EXTRA_CONSTRAINT_Csy): Allow PIC_DIRECT_ADDR_P.
	(LEGITIMATE_PIC_OPERAND_P): Allow LABEL_REF.
	* sh.md (*pt): Remove.

	* sh.h (REG_ALLOC_ORDER): Avoid squandering call-saved registers.

	* sh.md (return_media_rte): New pattern.
	(return_media): Use it.

2003-06-17  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/contrib.texi: Replace Hitachi with Renesas.
	* doc/install.texi: Likewise.
	* doc/invoke.texi: Likewise.

2003-06-17  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (CONST_OK_FOR_J16): Fix HOST_BITS_PER_WIDE_INT >= 64
	behaviour.

2003-06-17  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* doc/tm.texi (MD_FALLBACK_FRAME_STATE_FOR): Mention MAKE_THROW_FRAME.

	* config/rs6000/linux.h (MD_FALLBACK_FRAME_STATE_FOR): Partly revert
	2003-01-23 patch. Corrected to handle kernels with changed ucontext.

	* config/rs6000/sysv4.h (SUBTARGET_OVERRIDE_OPTIONS): Error on invalid
	-msdata=eabi usages.

	* gcc/config/rs6000/sysv4.h (USE_LIBC_1): Delete all uses.

2003-06-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alloc-pool.c: Don't check HAVE_LONG_DOUBLE.
	* fixinc/gnu-regex.c: Don't define `volatile'.
	* ggc-page.c: Don't check HAVE_LONG_DOUBLE.
	* ggc-simple.c: Likewise.
	* system.h: Don't define `volatile'.

	* aclocal.m4 (gcc_AC_C_VOLATILE, gcc_AC_C_LONG_DOUBLE): Delete.
	* configure.in (gcc_AC_C_VOLATILE, gcc_AC_C_LONG_DOUBLE): Don't
	call these macros.
	* config.in, configure: Regenerated.

2003-06-17  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/ia64/ia64.c (ia64_expand_builtin, case IA64_BUILTIN_BSP):
	Handle POINTERS_EXTEND_UNSIGNED.

2003-06-17  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.c (TARGET_ASM_UNALIGNED_DI_OP) [TARGET_IRIX5 &&
	!TARGET_IRIX6]: Define as NULL.

2003-06-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* config/sparc/sparc.c (sparc_va_arg): Don't align 16-byte+ structures.

2003-06-17  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* dbxout.c (dbxout_source_line_counter): New global variable.
	Mark it with GTY(()).
	(dbxout_source_line): Increment dbxout_source_line_counter
	and pass it to ASM_OUTPUT_SOURCE_LINE.
	* sdbout.c (sdbout_source_line_counter): New global variable.
	Mark it with GTY(()).
	(unnamed_struct_number): Mark it with GTY(()).
	(sdbout_source_line): Increment sdbout_source_line_counter
	and pass it to ASM_OUTPUT_SOURCE_LINE.
	* xcoffout.c (ASM_OUTPUT_SOURCE_LINE): Add third parameter
	(xcoffout_source_line): Pass 0 as third argument to
	ASM_OUTPUT_SOURCE_LINE.
	(xcoffout_begin_prologue): Likewise.
	* config/dbxout.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	Use it instead of 'sym_lineno' but without incrementing it.
	* config/dbxelf.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/lynx.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/ptx4.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/alpha/alpha.c (alpha_start_function): Pass 0 as third
	argument to ASM_OUTPUT_SOURCE_LINE.
	* config/alpha/alpha.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	* config/arm/aout.h: Remove useless comment.
	* config/avr/avr.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	* config/i960/i960.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/m32r/m32r.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	Use it instead of 'sym_lineno' but without incrementing it.
	* config/m68k/hp320.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	* config/mcore/mcore-pe.h (ASM_OUTPUT_SOURCE_LINE): Add third
	parameter. Use it instead of 'sym_lineno' but without incrementing it.
	* config/mips/mips.c (mips_output_function_prologue): Pass 0 as third
	argument to ASM_OUTPUT_SOURCE_LINE.
	* config/mips/mips.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	* config/mmix/mmix.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/pa/som.h (ASM_OUTPUT_SOURCE_LINE): Add third parameter.
	Use it instead of 'sym_lineno' but without incrementing it.
	* config/rs6000/linux64.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/sh/elf.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/sparc/aout.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* config/sparc/pbd.h (ASM_OUTPUT_SOURCE_LINE): Likewise.
	* doc/tm.texi (ASM_OUTPUT_SOURCE_LINE): Document third parameter.

2003-06-17  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (mips_expand_block_move): Declare.
	(expand_block_move, output_block_move): Remove.
	* config/mips/mips.h (enum block_move_type): Remove.
	* config/mips/mips.c (block_move_call, output_block_move): Remove.
	(mips_block_move_straight, mips_adjust_block_mem): New function.
	(mips_block_move_loop): Renamed and reworked from block_move_loop.
	(mips_expand_block_move): Likewise expand_block_move.  Return false
	to fall back on the target-independent code.
	* config/mips/mips.md (movstrsi): Use mips_expand_block_move.
	(movstrsi_internal*): Remove.

2003-06-16  Zack Weinberg  <zack@codesourcery.com>

	* cpplib.h, cpphash.h, cppcharset.c, cpperror.c, cppexp.c
	* cppfiles.c, cpphash.c, cppinit.c, cpplex.c, cpplib.c
	* cppmacro.c, cpppch.c, cpptrad.c, cppspec.c: Convert to
	ISO C: new-style function declarations, no need for PARAMS,
	no special punctuation on indirect function calls, use string
	constant concatenation where convenient.

2003-06-17  Andreas Jaeger  <aj@suse.de>

	* rtl.h: Remove declarations from coverage.h.
	* toplev.c: Include coverage.h.
	* Makefile.in (toplev.o): Depend on coverage.h.

	* toplev.h: Remove extra declaration of print_time.

	* gengtype.c (close_output_files): Remove duplicated declaration.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/sparc/sysv4.h: Remove target-independent comment;
	replace "GNU CC" with "GCC".
	* config/vxworks.h: Replace "GNU compiler" with "GCC".
	* config/sparc/aout.h, config/sparc/biarch64.h, config/sparc/elf.h,
	config/sparc/freebsd.h, config/sparc/linux.h, config/sparc/linux64.h,
	config/sparc/lite.h, config/sparc/litecoff.h, config/sparc/liteelf.h,
	config/sparc/netbsd-elf.h, config/sparc/openbsd.h,
	config/sparc/rtemself.h, config/sparc/sol2-64.h,
	config/sparc/sol2-bi.h, config/sparc/sol2-gas-bi.h,
	config/sparc/sol2-gld-bi.h, config/sparc/sol2-gld.h,
	config/sparc/sol2.h, config/sparc/sp64-aout.h,
	config/sparc/sp64-elf.h, config/sparc/sp86x-elf.h,
	config/sparc/sparc-protos.h, config/sparc/sysv4-only.h: Replace
	"GNU compiler", "GNU CC" with "GCC".
	* config/sparc/cypress.md, config/sparc/hypersparc.md,
	config/sparc/sparc-modes.def, config/sparc/sparc.c,
	config/sparc/sparc.md, config/sparc/sparclet.md,
	config/sparc/supersparc.md, config/sparc/ultra1_2.md,
	config/sparc/ultra3.md: Replace "GNU CC", "GNU Compiler", and
	"GNU C Compiler" with "GCC".
	* config/ip2k/ip2k.h: Replace "GNU CC" and "GNU compiler" with "GCC".

2003-06-16  Aldy Hernandez  <aldyh@redhat.com>

	* simplify-rtx.c (simplify_subreg): Do not over-extend vector
	constants.

	* testsuite/gcc.c-torture/execute/simd-4.c: New.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/ip2k/ip2k.h: Remove target-independent comments.

	* config.gcc: Explicitly mention elfos.h in ip2k entry.
	* config/ip2k/ip2k.h: Don't #include it here.

2003-06-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* bitmap.c, builtins.c, c-incpath.c, cgraph.c, config/frv/frv.c,
	config/mips/mips.c, cppfiles.c, cpphash.c, cppinit.c, cpplib.c,
	dwarf2out.c, dwarfout.c, except.c, expr.c, expr.h, fold-const.c,
	function.c, gcc.c, genoutput.c, gensupport.c, global.c,
	haifa-sched.c, hashtable.c, ifcvt.c, integrate.c, local-alloc.c,
	loop.c, mips-tdump.c, mips-tfile.c, mkdeps.c, protoize.c,
	read-rtl.c, recog.h, reload1.c, sbitmap.c, ssa-dce.c,
	stringpool.c, tlink.c, tree.c, varasm.c, varray.c: Don't use
	the PTR macro.

	* gengtype.c: Don't use UNION_INIT_ZERO.
	* system.h (UNION_INIT_ZERO): Delete.

2003-06-16  Richard Henderson  <rth@redhat.com>

	* simplify-rtx.c (simplify_subreg): Use GET_MODE_SIZE instead of
	GET_MODE_UNIT_SIZE when simplifying constant vectors.

2003-06-16  Andreas Jaeger  <aj@suse.de>

	* timevar.c (get_run_time): Remove function provided also by
	libiberty.
	* timevar.h: Remove get_run_time declaration.

2003-06-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m68hc11/m68hc11.c (m68hc11_rtx_costs): Remove
	unreachable code.

2003-06-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtin-attrs.def, builtin-attrs.def, builtins.c, cpplex.c,
	cpplib.c, gencheck.c, gengenrtl.c, machmode.def, protoize.c: Don't
	use macros from "symcat.h", instead rely on ISO C.

	* system.h: Don't include "symcat.h".
	* configure.in (AC_C_STRINGIZE): Delete.
	* config.in, configure: Regenerate.

2003-06-16  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Makefile.in (install-mkheaders): Use INSTALL_SCRIPT for scripts.

	* tree.h (STMT_CHECK): New macro.
	Also upper-case argument names on all checking macros and
	fix some whitespace problems; assume CODE argument does not
	have side-effects.

2003-06-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* scan.h: Convert to ISO C.
	* system.h: Likewise.

	* c-format.c (dynamic_format_types): New pointer for dynamic data.
	(find_length_info_modifier_index, init_dynamic_asm_fprintf_info):
	New functions split out of...
	(handle_format_attribute): ...here.

2003-06-16  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (REG_CLASS_FROM_LETTER): Change to:
	(REG_CLASS_FROM_CONSTRAINT).
	(CONST_OK_FOR_I): Rename to:
	(CONST_OK_FOR_I08).  Changed all users.
	(CONST_OK_FOR_J): Rename to:
	(CONST_OK_FOR_I16).  Changed all users.
	(CONST_OK_FOR_K): Rename to:
	(CONST_OK_FOR_P27).  Changed all users.
	(CONST_OK_FOR_L): Rename to:
	(CONST_OK_FOR_K08).  Changed all users.
	(CONST_OK_FOR_O): Rename to:
	(CONST_OK_FOR_I06).  Changed all users.
	(CONST_OK_FOR_P): Rename to:
	(CONST_OK_FOR_I10).  Changed all users.
	(CONSTRAINT_LEN, CONST_OK_FOR_I, CONST_OK_FOR_J16): Define.
	(CONST_OK_FOR_J, CONST_OK_FOR_K, CONST_OK_FOR_P): Likewise.
	(EXTRA_CONSTRAINT_A, EXTRA_CONSTRAINT_Bsc): Likewise.
	(EXTRA_CONSTRAINT_B, PIC_OFFSET_P, PIC_DIRECT_ADDR_P): Likewise.
	(EXTRA_CONSTRAINT_Cpg, EXTRA_CONSTRAINT_C): Likewise.
	(EXTRA_MEMORY_CONSTRAINT,(EXTRA_CONSTRAINT_Sr0): Likewise.
	(CONST_OK_FOR_LETTER_P): Replace with
	(CONST_OK_FOR_CONSTRAINT_P).
	(EXTRA_CONSTRAINT_S): Rename to:
	(EXTRA_CONSTRAINT_C16).  Changed all users.
	(MOVI_SHORI_BASE_OPERAND_P): Don't allow direct addresses.
	(EXTRA_CONSTRAINT_T): Rename to:
	(EXTRA_CONSTRAINT_Csy).  Changed all users.
	(EXTRA_CONSTRAINT_Z): Remove.
	(EXTRA_CONSTRAINT): Replace with:
	(EXTRA_CONSTRAINT_STR).
	(EXTRA_CONSTRAINT_U): Rename to:
	 (EXTRA_CONSTRAINT_Z).  Changed all users.
	* sh.c (and_operand): Use CONST_OK_FOR_J16.
	* sh.md (cmpeqsi_t-1, cmpeqsi_t, adddi3_media): Use new constraints.
	(addsi3_media, addsi3_compact, andsi3_compact, anddi3): Likewise.
	(iorsi3, iordi3, xorsi3, xordi3, ashlsi3_std, ashlhi3_k): Likewise.
	(lshrsi3_k, movsi_i, movsi_ie, movsi_i_lowpart, movsi_media): Likewise.
	(movsi_media_nofpu, movqi_media, movhi_i, movhi_media): Likewise.
	(*movdi_i, movdi_media, movdi_media_nofpu, shori_media): Likewise.
	(movdf_media, movdf_media_nofpu, movv2sf_i, movv4sf_i): Likewise.
	(movsf_media, movsf_media_nofpu, movsi_y, beq_media): Likewise.
	(beq_media_i, bne_media, pt, ptb, movv8qi_i, movv2hi_i): Likewise.
	(movv4hi_i, movv2si_i, negcmpeqv8qi, negcmpeqv2si): Likewise.
	(negcmpeqv4hi, negcmpgtuv8qi, negcmpgtv2si, negcmpgtv4hi): Likewise.
	(mcmv, mcnvs_lw, mcnvs_wb, mcnvs_wub, mextr_rl, mextr_lr): Likewise.
	(mextr1, mextr2, mextr3, mextr4, mextr5, mextr6, mextr7): Likewise.
	(mperm_w, mperm_w_little, mperm_w_big, msad_ubq_i): Likewise.
	(mshards_q, mshfhi_b, mshflo_b, mshf4_b, mshf0_b, mshfhi_l): Likewise.
	(mshflo_l, mshf4_l, mshf0_l, mshfhi_w, mshflo_w, mshf4_w): Likewise.
	(mshf0_w, mshflo_w_x, mshfhi_l_di, mshfhi_l_di_rev): Likewise.
	(mshflo_l_di_rev, mshflo_l_di_x, concat_v2sf): Likewise.
	(mshflo_l_di_x_rev, subv2si3, subv4hi3, sssubv2si3): Likewise.
	(sssubv4hi3): Likewise.
	(movsf_i): Change I[08]/r to G/r.
	(movsf_ie): Change f/{G,H}/c/X to f/{G,H}/c/Bsc.

	* sh.c (sh_output_mi_thunk): Use CONST_OK_FOR_ADD.

2003-06-16  Vladimir Makarov  <vmakarov@redhat.com>

	* config/i386/i386.c (ix86_memory_move_cost): Fix typo.

2003-06-16  Andreas Jaeger  <aj@suse.de>

	* basic-block.h: Remove duplicate prototype of
	note_prediction_to_br_prob.

	* tree.h: Remove duplicate prototype of strip_float_extensions.

2003-06-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* config/c4x/c4x.c: Don't include "c-tree.h".
	* config/pa/pa.c: Likewise.
	* langhooks.c: Likewise.
	* tree.h (poplevel): Declare.

2003-06-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (const_costs): Move this to ...
	(h8300_rtx_costs): ... here.

2003-06-16  Roger Sayle  <roger@eyesopen.com>

	* optabs.h (enum optab_index): Add new OTI_tan and OTI_atan.
	(tan_optab, atan_optab): Define corresponding macros.
	* optabs.c (init_optabs): Initialize tan_optab and atan_optab.
	* genopinit.c (optabs): Implement tan_optab and atan_optab
	using tan?f2 and atan?f2 patterns.
	* builtins.c (expand_builtin_mathfn): Handle BUILT_IN_TAN{,F,L}
	using tan_optab, and BUILT_IN_ATAN{,F,L} using atan_optab.
	Change the default value of errno_set to false.
	(expand_builtin): Expand BUILT_IN_TAN{,F,L} and BUILT_IN_ATAN{,F,L}
	using expand_builtin_mathfn.

	* config/i386/i386.md (atansf2, atandf2, atanxf2, atantf2): New
	expander patterns implemented using existing atan2?f3 patterns.

2003-06-16  Roger Sayle  <roger@eyesopen.com>

	* expr.c (expand_expr <PLUS_EXPR>): If operand_equal_p considers
	both operands of the addition equal, reuse the expanded RTL.
	(expand_expr <MULT_EXPR>): Likewise for multiplication.

2003-06-16  Roger Sayle  <roger@eyesopen.com>
	    Jeff Law  <law@redhat.com>

	* fold-const.c (operand_equal_p): Consider two calls to "const"
	functions with identical non-volatile arguments to be equal.
	Consider the FUNCTION_DECL for the "__builtin_foo" form of a
	built-in function to be equal to the "foo" form.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/rs6000/sysv4le.h: Remove target-independent comment.
	Replace "GNU compiler" with "GCC" in comment.

2003-06-16  Andreas Jaeger  <aj@suse.de>

	* tracer.c: Remove duplicate declaration.

	* toplev.c: Remove extra declaration of decode_d_option.

	* ssa.c: Remove duplicate declaration.

	* sreal.c: Remove extra declaration of dump_sreal.

	* reload1.c: Remove duplicate declarations.

	* integrate.c: Remove extra declaration of
	set_decl_abstract_flags.

	* flow.c: Remove extra declaration of dump_flow_info.

	* alias.c: Remove extra declaration of get_addr.

2003-06-16  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/rtems.h, config/sol2.h, config/svr4.h, config/usegas.h,
	config/vxworks.h: GNU CC -> GCC.

	* convert.c, dwarf2out.c, dwarfout.c, emit-rtl.c, function.c,
	lists.c, print-rtl.c, print-tree.c, read-rtl.c, rtl-error.c,
	stmt.c, toplev.c, integrate.h, loop.h, machmode.h, rtl.h,
	ssa.h, tree.def: Replace overly specific references to "GNU C"
	and "GNU C Compiler" with references to "GCC".

2003-06-16  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (prepare_move_operand): Check if operand 0 is an invalid
	memory reference.  Fix test that checks if operand 1 is using r0.
	* sh.md (movhi_i): Don't allow st.w r0,@(rX,rY) .

	* defaults.h (REG_CLASS_FROM_CONSTRAINT): Only define if not already
	defined.

2003-06-15  Nathan Sidwell  <nathan@codesourcery.com>

	* function.h (struct emit_status): Remove x_last_linenum,
	x_last_filename. Add x_last_location.
	* rtl.h: #include "input.h".
	(NOTE_DATA): New.
	* cfglayout.c (duplicate_insn_chain): Use emit_line_note for line
	number notes.
	* emit-rtl.c (last_linenum, last_filename): Remove.
	(last_location): New.
	(emit_line_note_after): LINE must always be >= 0.
	(emit_line_note): Likewise. Check not duplicate here...
	(emit_note): ... rather than here.
	(emit_line_note_force, force_next_line_note, init_emit): Adjust.
	* integrate.c (expand_inline_function): Use emit_line_note for
	line number notes.
	(copy_insn_list): Likewise.
	* unroll.c (copy_loop_body): Likewise.
	* Makefile.in (RTL_H): Add input.h.

2003-06-16  Richard Sandiford  <rsandifo@redhat.com>

	* optabs.c (emit_libcall_block): Don't hoist insns past a label.

2003-06-16  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha-protos.h, config/alpha/elf.h,
	config/alpha/osf.h, config/alpha/unicosmk.h, config/alpha/vms.h,
	config/alpha/vms-cc.c, config/alpha/vms-ld.c: Update to ISO C.
	* config/alpha/alpha.c: Likewise.  Move targetm init to end of file.
	Remove unneeded static function decls.

2003-06-16  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (c_common_handle_option): s/on/value/.
	(OPT_fabi_version_, OPT_ftabstop_, OPT_ftemplate_depth_): Use value
	directly rather than converting the argument.
	* c.opt: Update docs.  Use UInteger where appropriate.
	* common.opt: Use UInteger where appropriate.
	* opts.c (integral_argument): New.
	(handle_argument): Handle integral arguments, and optional
	joined arguments.
	(common_handle_option): Update.
	* opts.h (CL_MISSING_OK, CL_UINTEGER): New.
	* opts.sh: Handle JoinedOrMissing and UInteger flags.

2003-06-16  Neil Booth  <neil@daikokuya.co.uk>

	* config/rs6000/sysv4.h (ASM_OUTPUT_ALIGNED_LOCAL): Remove
	unnecessary extern declaration.

2003-06-15  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/gofast.h, config/interix.h, config/interix3.h,
	config/libgloss.h, config/linux-aout.h, config/linux.h,
	config/lynx-ng.h, config/lynx.h: GNU CC -> GCC.
	* config/kaos.h: "GNU compiler" -> GCC.
	* config/linux-aout.h, config/lynx.h: Clarify comment describing file.

	* config/ip2k/crt0.S, config/ip2k/ip2k-protos.h,
	config/ip2k/ip2k.c, config/ip2k/ip2k.md, config/ip2k/libgcc.S:
	GNU CC -> GCC.

	* config/svr3.h: Remove #if 0 code, misleading comments.
	GNU CC -> GCC.

2003-06-15  Zack Weinberg  <zack@codesourcery.com>

	* vmsdbgout.c (vmsdbgout_finish): Rename parameter to
	main_input_filename to avoid conflict with input_filename macro.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* config/mips/mips.h (asm_file_name, g_switch_set,
	g_switch_value): Remove.
	* config/rs6000/sysv4.h (SUBTARGET_OVERRIDE_OPTIONS): Remove
	unnecessary extern declarations.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* config/frv/frv.h: Remove declaration of g_switch_value.
	* config/m32r/m32r.h: Remove declaration of g_switch_value.
	* config/m68hc11/m68hc11.c: Remove declaration of asm_file_name.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* opts.sh: Quote '+' in regex.

2003-06-15  Andrew Pinski <pinskia@physics.uc.edu>

	* config/rs6000/t-rs6000: Add dependence of cfglayout.h to rs6000.o.
	* config/rs6000/rs6000.c: Include cfglayout.h.
	* config/alpha/alpha.c: Likewise.
	* config/ia64/ia64.c: Likewise.
	* config/sparc/sparc.c: Likewise.
	* config/sh/sh.c: Likewise.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* opts.sh: Quote '+' in regex.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (lang_flags): Update for new spelling of flags.
	(write_langs): Similarly.
	* c.opt: Specify languages.
	* opts.h: Remove languages.
	* opts.sh: Recognise front-end defined languages.
	* doc/sourcebuild.texi: Update.

2003-06-15  Andreas Jaeger  <aj@suse.de>

	* alloc-pool.c: Convert to ISO C90 prototypes.
	* alloc-pool.h: Likewise.
	* alias.c: Likewise.
	* attribs.c: Likewise.
	* bb-reorder.c: Likewise.
	* bitmap.h: Likewise.
	* bitmap.c: Likewise.
	* builtins.c: Likewise.

	* tree.h: Convert prototypes of attribs.c to ISO C90.
	* basic-block.h: Convert prototypes of bb-reorder.c to ISO C90.
	* rtl.h: Convert prototypes of alias.c and builtins.c to ISO C90.
	* expr.h: Convert prototypes of builtins.c to ISO C90.

2003-06-15  Roger Sayle  <roger@eyesopen.com>

	* config/i386/i386.md (expsf2, expdf2, expxf2): New patterns to
	implement exp, expf and expl built-ins as inline x87 intrinsics.
	(UNSPEC_FSCALE, UNSPEC_FRNDINT, UNSPEC_F2XM1): New unspecs to
	represent x87's fscale, frndint and f2xm1 insns respectively.
	(*fscale_sfxf3, *fscale_dfxf3, *fscale_xf3): New insn patterns
	to encode x87's "fscale" instruction followed by a pop.
	(*frndintxf2): New insn pattern for "frndint".
	(*f2xm1xf2): New insn pattern for "f2xm1".

	* reg-stack.c (subst_stack_regs_pat): Handle UNSPEC_FRNDINT and
	UNSPEC_F2XM1 like UNSPEC_{SIN,COS} and handle UNSPEC_FSCALE like
	UNSPEC_FPATAN.

2003-06-15  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* gencheck.c (main): Avoid generating duplicate macros.

	* Makefile.in (stagefeedback-start): Use $(SUBDIRS) instead of
	knowing names of language subdirectories.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* c-pch.c (asm_file_name): Remove.
	* common.opt: Add more switches.
	* flags.h (g_switch_set): Boolify.
	* opts.c (g_switch_value, g_switch_set, exit_after_options,
	version_flag): Move from toplev.c.
	(common_handle_option): Handle more switches from toplev.c.
	* toplev.c (display_help, display_target_options, decode_d_option,
	print_version): Make non-static, remove prototypes.
	(aux_base_name, asm_file_name, aux_info_file_name): Constify.
	(version_flag, g_switch_value, g_switch_set, exit_after_options):
	Remove.
	(independent_decode_option): Move some handlers to opts.c.
	* toplev.h (aux_info_file_name, aux_base_name, asm_file_name,
	exit_after_options, version_flag, display_help, display_target_options,
	print_version, decode_d_option): New.

2003-06-15  Kazu Hirata  <kazu@cs.umass.edu>

	* config/alpha/alpha.md: Follow spelling conventions.
	* config/arm/arm.c: Likewise.
	* config/arm/arm.h: Likewise.
	* config/arm/arm.md: Likewise.
	* config/arm/crtn.asm: Likewise.
	* config/m32r/m32r.c: Likewise.
	* config/m32r/m32r.md: Likewise.
	* config/rs6000/rs6000.c: Likewise.

2003-06-15  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_output_mi_thunk_osf): Call
	insn_locators_initialize.
	* config/ia64/ia64.c (ia64_output_mi_thunk): Likewise.
	* config/rs6000/rs6000.c (rs6000_output_mi_thunk): Likewise.
	* config/sparc/sparc.c (sparc_output_mi_thunk): Likewise.
	* config/sh/sh.c (sh_output_mi_thunk): Do it later.

2003-06-15  Kazu Hirata  <kazu@cs.umass.edu>

	* builtins.c (expand_builtin_expect_jump): Remove redundant
	tests that are also in any_condjump_p().

2003-06-15  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* libgcc2.c: Delete sysV68 L_trampoline section.
	* config/m68k/mot3300-crt0.S: Delete file.
	* config/m68k/mot3300Mcrt0.S: Likewise.

2003-06-15  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/aoutos.h: Remove.
	* config.gcc: Remove reference to aoutos.h.
	* config/m68k/m68k-aout.h: Remove reference to aoutos.h.

2003-06-14  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/install.texi: Follow spelling conventions.
	* doc/tm.texi: Likewise.
	* config/fp-bit.c: Likewise.
	* config/arm/arm.c: Likewise.
	* config/frv/frv.c: Likewise.
	* config/ns32k/NOTES: Likewise.
	* config/ns32k/STATUS: Likewise.

2003-06-14  Roger Sayle  <roger@eyesopen.com>
	    Zack Weinberg  <zack@codesourcery.com>

	* rtl.h (STORE_FLAG_VALUE): Remove default definition from here.
	* defaults.h (STORE_FLAG_VALUE): Move default definition to here.
	* doc/tm.texi (STORE_FLAG_VALUE): Document the default value.

	* config/alpha/alpha.h (STORE_FLAG_VALUE): Remove definition.
	* config/arc/arc.h (STORE_FLAG_VALUE): Likewise.
	* config/arm/arm.h (STORE_FLAG_VALUE): Likewise.
	* config/cris/cris.h (STORE_FLAG_VALUE): Likewise.
	* config/i370/i370.h (STORE_FLAG_VALUE): Likewise.
	* config/i386/i386.h (STORE_FLAG_VALUE): Likewise.
	* config/i960/i960.h (STORE_FLAG_VALUE): Likewise.
	* config/ia64/ia64.h (STORE_FLAG_VALUE): Likewise.
	* config/ip2k/ip2k.h (STORE_FLAG_VALUE): Likewise.
	* config/m32r/m32r.h (STORE_FLAG_VALUE): Likewise.
	* config/mcore/mcore.h (STORE_FLAG_VALUE): Likewise.
	* config/mips/mips.h (STORE_FLAG_VALUE): Likewise.
	* config/mmix/mmix.h (STORE_FLAG_VALUE): Likewise.
	* config/ns32k/ns32k.h (STORE_FLAG_VALUE): Likewise.
	* config/pa/pa.h (STORE_FLAG_VALUE): Likewise.
	* config/pdp11/pdp11.h (STORE_FLAG_VALUE): Likewise.
	* config/sh/sh.h (STORE_FLAG_VALUE): Likewise.
	* config/sparc/sparc.h (STORE_FLAG_VALUE): Likewise.
	* config/v850/v850.h (STORE_FLAG_VALUE): Likewise.
	* config/xtensa/xtensa.h (STORE_FLAG_VALUE): Likewise.

2003-06-14  Nathan Sidwell  <nathan@codesourcery.com>

	* opts.sh (POSIXLY_CORRECT): Unset it.

	* tree.h (init_function_start): Remove filename and line paramters.
	* function.c (init_function_start): Remove filename and line
	parameters. Use DECL_SOURCE_LOCATION.
	* c-decl.c (store_parm_decls): Adjust init_function_start call.
	(c_expand_body_1): Likewise.
	* coverage.c (create_coverage): Likewise.
	* objc/objc-act.c (build_tmp_function_decl): Set line number to
	zero.
	(hack_method_prototype): Adjust init_function_start call.

2003-06-14  Richard Earnshaw  <rearnsha@arm.com>

	PR target/3724
	* arm/linux-elf.h (PROFILE_HOOK): Define.

2003-06-14  Richard Earnshaw  <rearnsha@arm.com>

	PR target/11183
	* arm.h (CANNOT_CHANGE_MODE_CLASS): Define.

2003-06-14  Roger Sayle  <roger@eyesopen.com>

	* opts.sh: Work around a mysterious feature in cygwin's gawk
	where specifying the input files explicitly has a different
	behavior to piping them via stdin.

2003-06-14  Neil Booth  <neil@daikokuya.co.uk>

	* doc/sourcebuild.texi: Update.

2003-06-14  Richard Earnshaw  <rearnsha@arm.com>

	PR target/11183
	* arm.c (output_move_double): Pass SImode to adjust_address.

2003-06-14  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in: Update to use common.opt and lang_opt_files.
	(c-options.c, c-options.h): Remove.
	(options.c, options.h): Add.
	* c-opts.c: Include options.h not c-options.h.
	* common.opt: New file.
	* configure, configure.in: Add lang_opt_files.
	* opts.c: Include flags.h and diagnostic.h.
	(common_handle_option): New.
	(handle_option): Update to recognize common options and all
	language-dependent options.
	* opts.h (CL_F77, CL_JAVA, CL_ADA, CL_COMMON, CL_TREELANG): New.
	(struct cl_option): Make flags of type int.
	* opts.h: Flag option with front ends to which it applies.
	Handle duplicate options.
	* toplev.c (filename): Remove.
	(independent_decode_option): Don't handle filenames and -quiet.
	(process_options, do_compile): Update.

2003-06-14  Nick Clifton  <nickc@redhat.com>

	* doc/install.texi (Specific): Add description of different
	ARM supported file format targets.

Sat Jun 14 11:12:04 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* reorg.c (emit_delay_sequence, dbr_schedule): Clear insn locators
	inside delay slots.

2003-06-13  Matt Kraai  <kraai@alumni.cmu.edu>

	* unwind-c.c: Define NO_SIZE_OF_ENCODED_VALUE.
	* unwind-pe.h (size_of_encoded_value): Do not define if
	NO_SIZE_OF_ENCODED_VALUE is defined.

2003-06-13  Roger Sayle  <roger@eyesopen.com>

	* expr.c (expand_expr <COMPLEX_CST>): Handle the case of
	expanding a complex constant into a CONCAT target.

2003-06-13  Zack Weinberg  <zack@codesourcery.com>

	* config/svr3.h (ASM_FILE_START): Don't use ASM_FILE_START_1.
	(ASM_FILE_START_1): Delete.
	* config/i386/att.h, config/i386/sco5.h,
	config/i386/sysv3.h
	(ASM_FILE_START_1): Delete.

2003-06-13  Kelley Cook  <kelleycook@wideopenwest.com>

	* config/i386/bsd.h: Remove ASM_FILE_START.
	* config/i386/djgpp.h: Likewise.
	* config/i386/gas.h (ASM_FILE_START): Output .file before .intel_syntax.

	* config/i386/djgpp.h: Move included unix.h, bsd.h, gas.h to ...
	* config.gcc (i[34567]86-pc-msdosdjgpp): ... here.

2003-06-13  Vladimir Makarov  <vmakarov@redhat.com>

	PR bootstrap/10835
	* haifa-sched.c (max_lookahead_tries,
	cached_first_cycle_multipass_dfa_lookahead,
	cached_issue_rate): New variables.
	(max_issue): Check the number of tries.
	(choose_ready): Calculate max_lookahead_tries.
	(sched_init): Check cached_issue_rate.

2003-06-13  Richard Henderson  <rth@redhat.com>

	* cfgbuild.c (make_edges): Set ABNORMAL with SIBCALL.
	* cfgrtl.c (purge_dead_edges): Expect it too.

2003-06-13  Jim Wilson  <wilson@tuliptree.org>
	    Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR bootstrap/10983
	* combine.c (make_extraction): Use gen_lowpart_for_combine
	when extracting from a REG and not in the destination of a SET.

2003-06-13  Doug Evans  <dje@sebabeach.org>

	* tsystem.h (abort): Declare in inhibit_libc case to remove build
	warnings for addvsi3, et.al.

2003-06-13  Aldy Hernandez  <aldyh@redhat.com>

	* c-common.c (handle_mode_attribute): Use VECTOR_MODE_P macro.

	* simplify-rtx.c (simplify_subreg): Same.

	* emit-rtl.c (gen_lowpart_common): Same.

2003-06-13  Kazu Hirata  <kazu@cs.umass.edu>

	* builtins.c: Fix comment typos.
	* fold-const.c: Likewise.

2003-06-13  Doug Evans  <dje@sebabeach.org>
	    Kazuhiro Inaoka <inaoka.kazuhiro@renesas.com>

	* config/m32r/m32r-protos.h (m32r_pass_by_reference): Declare.
	* config/m32r/m32r.c (m32r_pass_by_reference): New fn.
	(m32r_va_arg): Use it.
	* config/m32r/m32r.h (FUNCTION_ARG_PASS_BY_REFERENCE): Ditto.
	(RETURN_IN_MEMORY): Ditto.

2003-06-13  Nathanael Nerode  <neroden@gcc.gnu.org>

	* c-typeck.c: Remove #if 0 clauses.

	PR other/1494
	* config/alpha/openbsd.h, config/i386/openbsd.h,
	config/m68k/openbsd.h, config/sparc/openbsd.h: Remove
	residual reference to EGCS.

2003-06-13  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (output_call_mem): If the address references the link-register
	use an instruction sequence that avoids early-clobbering IP.
	(eliminate_lr2ip): Delete.

2003-06-13  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-format.c (format_types_orig): Disallow '*' width/precision in
	asm_fprintf format checks.

2003-06-13  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_va_arg): Fix alignment when retrieving
	non-integral types from integer register save area slots.

2003-06-13  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/i386/svr3dbx.h: GNU CC -> GCC; Intel 385 -> Intel 386.

2003-06-13  Florian Weimer  <fw@deneb.enyo.de>

	* doc/invoke.texi (SPARC Options): Document ``-mimpure-text''.

2003-06-13  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/linux.h (TARGET_ASM_FILE_END): Set TARGET_ASM_FILE_END
	to file_end_indicate_exec_stack.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR target/11089
	* config/i386/i386.md (sse_movaps): Use an expander to force
	one operand to be a register.
	(sse_movups): Likewise.

2003-06-13  Doug Evans  <dje@sebabeach.org>

	Remove some build warnings.
	* config/m32r/initfini.c (__CTOR_LIST__,__DTOR_LIST__): Attribute used.
	(__do_global_ctors,__do_global_dtors): Ditto.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR middle-end/10557
	* rtlanal.c (subreg_offset_representable_p): Relax subreg check.

2003-06-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m32r/m32r.md: Fix a comment typo.

2003-06-13  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Christian Ehrhardt <ehrhardt@mathematik.uni-ulm.de>

	PR target/10142
	* config/sparc/sparc.c (function_arg_record_value_parms): Add
	new 'stack' field.
	(function_arg_record_value_1): Set 'stack' to 1 if we run out of
	integer slots for an integer field.
	(function_arg_record_value_3): Shift vector index.
	(function_arg_record_value_2): Likewise.
	(function_arg_record_value): Initialize 'stack' to 0.
	Set 'stack' to 1 if we run out of integer slots for an integer field.
	Generate (parallel [(expr_list (nil) ...) ...]) if 'stack' is set to 1.

2003-06-13  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/10955
	* unroll.c (unroll_loop): Fix off-by-one bug.

2003-06-12  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (function_arg): Remove typo.

2003-06-12  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (legitimate_constant_p): Handle UNSPEC_NTPOFF
	and UNSPEC_DTPOFF.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR middle-end/10475
	* expmed.c (emit_store_flag): Use simplify_gen_subreg directly
	for extracting sub-words.

2003-06-12  Richard Henderson  <rth@redhat.com>

	PR target/7594
	* config/m68k/m68k.md (zero_extendhisi2): Use gen_lowpart_SUBREG.
	(zero_extendqihi2, zero_extendqisi2): Likewise.

2003-06-12  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (function_arg): Always split vectors for
	e500 if it's a stdarg function.
	(function_arg_advance): Advance 2 registers for vectors in a
	stdarg function.
	(init_cumulative_args): Initialize stdarg.
	(rs6000_spe_function_arg): New.

	* config/rs6000/rs6000.h (rs6000_args): Add stdarg.

2003-06-12  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (MODES_TIEABLE_P): Add SPE vectors.

2003-06-12  Roger Sayle  <roger@eyesopen.com>

	PR middle-end/168
	* fold-const.c (tree_expr_nonnegative_p):  Handle addition
	and multiplication of zero extensions, floating point division,
	and integer<->fp, fp<->fp and zero extension conversions.
	The built-in ceil and floor functions preserve signedness.

2003-06-12  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* ChangeLog.2: Likewise.
	* c-decl.c: Likewise.
	* cfgloop.h: Likewise.
	* cgraph.c: Likewise.
	* coverage.c: Likewise.
	* cppcharset.c: Likewise.
	* cpphash.h: Likewise.
	* cpplex.c: Likewise.
	* cpplib.c: Likewise.
	* dbxout.c: Likewise.
	* df.c: Likewise.
	* dwarf2out.c: Likewise.
	* dwarfout.c: Likewise.
	* emit-rtl.c: Likewise.
	* explow.c: Likewise.
	* gcov-io.c: Likewise.
	* gcov-io.h: Likewise.
	* gcov.c: Likewise.
	* gengtype.c: Likewise.
	* ggc.h: Likewise.
	* opts.c: Likewise.
	* real.c: Likewise.
	* reload.c: Likewise.
	* stmt.c: Likewise.

2003-06-12  Janis Johnson  <janis187@us.ibm.com>

	* doc/install.texi (m32r-*-elf): Change company to Renesas.

Thu Jun 12 20:00:55 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* basic-block.h (flow_delete_block_noexpunge): Kill.
	* cfgrtl.c (flow_delete_block_noexpunge): Merge to
	rtl_delete_block.

2003-06-10  Richard Henderson  <rth@redhat.com>

	PR inline-asm/4823
	* reg-stack.c (any_malformed_asm): New.
	(check_asm_stack_operands): Set it.
	(convert_regs_1): Check it before aborting.

2003-06-12  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/spe.md: Change all clobbers of the accumulator to sets.

2003-06-12  Jakub Jelinek  <jakub@redhat.com>

	* c-opts.c (complain_wrong_lang): Add on argument.
	Print no- switch if on is false.
	(c_common_decode_option): Adjust caller.

2003-06-12  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_emit_prologue): Use LA instead of AR
	to initialize GOT register.

2003-06-12  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (tree_expr_nonnegative_p): Add support for
	floating point constants, addition and multiplication.

2003-06-12  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.md (adddi3_compact, subdi3_compact): Add earlyclobber
	constraint modifier for operand 0.

2003-06-12  Hans-Peter Nilsson  <hp@axis.com>

	Don't warn on dollars in builtin macro definitions,
	e.g. __REGISTER_PREFIX__.
	* cpphash.h (struct cpp_reader): Move member warn_dollars...
	* cpplib.h (struct cpp_options): ...to here.  Change type to
	unsigned char.
	* cppinit.c (cpp_create_reader): Set it to 1 here.
	(post_options): Don't set it here.
	* c-opts.c (c_common_init_options): Reset it to 0 here.
	(finish_options): Set it here.
	* cpplex.c (forms_identifier_p): Tweak for new location of
	warn_dollars.

	* configure.in (assembler dwarf2 debug_line support): Define insn
	for cris-*-* and mmix-*-*.
	* configure: Regenerate.

2003-06-11  Uwe Stieber  <uwe@kaos-group.de>

	* config.gcc (arm*-*-kaos*, i[34567]86-*-kaos*, powerpc-*-kaos*,
	powerpcle-*-kaos*, strongarm-*-kaos*): New targets.
	(sh-*-elf*): Add sh*-*-kaos* support.
	* config/kaos.h, config/arm/kaos-strongarm.h, config/arm/kaos-arm.h,
	config/i386/kaos-i386.h, config/rs6000/kaos-ppc.h,
	config/sh/kaos-sh.h: New files.

2003-06-12  Kazu Hirata  <kazu@cs.umass.edu>

	* gcse.c (fis_get_condition): Make it a global function.
	* reload1.c (reload_cse_move2add): Detect implicit sets.
	* rtl.h: Add a prototype for fis_get_condition.

2003-06-11  Richard Henderson  <rth@redhat.com>

	* stmt.c (expand_asm_operands): Don't warn for memories with
	queued addresses.

2003-06-11  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/sh.h (SUBTARGET_ASM_RELAX_SPEC): Rewrite without
	brackets.

2003-06-11  Neil Booth  <neil@daikokuya.co.uk>

	* hooks.c (hook_int_size_t_constcharptr_int_0): New.
	* hooks.h (hook_int_size_t_constcharptr_int_0): New.
	* langhooks-def.h (lhd_decode_option, LANG_HOOKS_DECODE_OPTION): Die.
	(LANG_HOOKS_HANDLE_OPTION, LANG_HOOKS_INITIALIZER): Update.
	* langhooks.c (lhd_decode_option): Remove.
	* langhooks.h (struct lang_hooks): Remove decode_option.
	* opts.c (handle_option): No longer use decode_option.

2003-06-11  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* cfgloopanal.c (variable_initial_value): Update the set of altered
	registers correctly.

2003-06-11  Roger Sayle  <roger@eyesopen.com>
	    Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* config/d30v/d30v.h: Delete reference to ASM_FINAL_SPEC.
	* config/i386/netbsd-elf.h: Likewise.
	* config/m32r/m32r.h: Likewise.
	* config/mn10300/mn10300.h: Likewise.
	* config/stormy16/stormy16.h: Likewise.
	* config/v850/v850.h: Likewise.
	* config/vax/netbsd-elf.h: Likewise.
	* config/xtensa/elf.h: Likewise.
	* config/xtensa/linux.h: Likewise.

2003-06-11  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/iris5gas.h (MDEBUG_ASM_SPEC): Override to match
	DWARF 2 default.

	* config/mips/dbxmdebug.h: New file.
	* config.gcc (mips-sgi-irix6*o32, mips-sgi-irix5*): Use it with
	gas and --with-stabs.

2003-06-11  Ulrich Weigand  <uweigand@de.ibm.com>

	* expr.c (can_move_by_pieces): align argument may be unused.

2003-06-11  J"orn Rennecke <joern.rennecke@superh.com>

	* expr.c (convert_move): Handle moves between two CONCATs.

2003-06-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (RETURN_IN_MEMORY): Accept DImode if
	!TARGET_H8300.

2003-06-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (final_prescan_insn): Don't dump rtl.
	* config/h8300/h8300.h (MASK_RTL_DUMP): Remove.
	(TARGET_RTL_DUMP): Likewise.
	(TARGET_SWITHCES): Remove -mrtl-dump.

2003-06-10  Richard Henderson  <rth@redhat.com>

	* optabs.c (gen_cond_trap): Fix prepare_operand typo.

2003-06-10  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.md (call_gp): Fix memory mode.

2003-06-10  James E Wilson  <wilson@tuliptree.org>

	PR target/8812
	* reload1.c (choose_reload_regs): For equiv reg, add loop over all
	hard regs for reload_reg_used_at_all and reg_class_contents checks.

2003-06-10  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (print_operand): Remove support for
	operand character 'b'.
	Add the AND case to operand character 'c'.
	* config/h8300/h8300.md (two anonymous patterns): Replace
	operand character 'b' with 'c'.

2003-06-10  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (print_operand): Remove support for
	operand character 'u'.

2003-06-10  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Fix typo.
	* configure: Regenerate.

2003-06-10  Loren James Rittle  <ljrittle@acm.org>

	* config/alpha/alpha.c (unicosmk_file_end): Add conditional
	compilation guard.

2003-06-10  J"orn Rennecke <joern.rennecke@superh.com>

	* sh-protos.h (function_symbol): Declare.
	* sh.c (expand_block_move, expand_ashiftrt): Use it.
	(sh_expand_prologue, sh_expand_epilogue): Likewise.
	(sh_initialize_trampoline): Likewise.
	(function_symbol): New function.
	* sh.md (udivsi3, divsi3, mulsi3, ic_invalidate_line): Use it.
	(initialize_trampoline, call, call_pop, call_value, sibcall): Likewise.
	(call_value_pop, shcompact_return_tramp): Likewise.

	* sh.h (OVERRIDE_OPTIONS): Don't suppress --profile-arc-flag.

	* sh.md (GOTaddr2picreg): Use gen_lowpart to get lowpart of
	target register.

2003-06-10  DJ Delorie  <dj@redhat.com>

	* doc/md.texi (Machine Constraints): Document stormy's Z
	constraint.

2003-06-10  Geoffrey Keating  <geoffk@apple.com>

	* except.c (call_site_base): Mark with GTY.

2003-06-10  Richard Earnshaw  <rearnsha@arm.com>

	* arm-proto.h: Convert to ISO C90 prototypes.
	* arm.c: Likewise.

2003-06-10  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (sh_output_mi_thunk): Call insn_locators_initialize.

2003-06-10  Steve Ellcey  <sje@cup.hp.com>

	* calls.c (expand_call): Convert structure_value_addr to Pmode if
	necessary.

2003-06-10  Andrew Haley  <aph@redhat.com>

	* langhooks-def.h (LANG_HOOKS_DECL_OK_FOR_SIBCALL): New.
	(LANG_HOOKS_DECLS): Add LANG_HOOKS_DECL_OK_FOR_SIBCALL.
	(lhd_decl_ok_for_sibcall): New.
	* langhooks.c (lhd_decl_ok_for_sibcall): New.
	* langhooks.h (lang_hooks_for_decls.ok_for_sibcall): New field.
	* calls.c (expand_call): Check lang_hook before generating a
	sibcall.

2003-06-10  DJ Delorie  <dj@redhat.com>

	* config/stormy16/stormy16.c (xstormy16_extra_constraint_p): Add Z,
	which matches (const_int 0) for addhi3.
	* config/stormy16/stormy16.md: Document known constraints.
	(addhi3): Handle adding zero.

2003-06-10  Kazuhiro Inaoka <inaoka.kazuhiro@renesas.com>

	* config/m32r/m32r.h (HARD_REGNO_RENAME_OK): New.
	* config/m32r/m32r.c (m32r_hard_regno_rename_ok): New.
	* config/m32r/m32r-protos.h: Prototype it.

2003-06-10  Janis Johnson  <janis187@us.ibm.com>

	* config/rs6000/eabi.h (TARGET_OS_CPP_BUILTINS): Define builtins
	common to rs6000 sysv targets.
	* config/rs6000/eabisim.h (TARGET_OS_CPP_BUILTINS): Ditto.
	* config/rs6000/rtems.h (TARGET_OS_CPP_BUILTINS): Ditto.

2003-06-10  Nick Clifton  <nickc@redhat.com>

	* config.gcc: Add arm-wince-pe target.
	* config/arm/pe.h (MULTILIB_DEFAULTS): Define.
	Add comment about default apcs26 support.
	* config/arm/t-pe (MULTILIB_OPTIONS): Add an -mapcs-32
	multilib.
	(MULTILIB_DIRNAMES): Add 'apcs32'.
	* config/arm/t-wince-pe: New makefile fragment.
	* config/arm/wince-pe.h: New file.  Overrides a few definitions
	in arm/pe.h

2003-06-10  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (fold_builtin): Optimize cos(-x) as cos(x).
	* fold-const.c (fold <NEGATE_EXPR>): Convert -f(x) into f(-x)
	when x is easily negated and f is sin, tan or atan.
	(fold <MULT_EXPR>): Optimize tan(x)*cos(x) and cos(x)*tan(x) as
	sin(x) with flag_unsafe_math_optimizations.
	(fold <RDIV_EXPR>): With flag_unsafe_math_optimizations fold
	sin(x)/cos(x) as tan(x) and cos(x)/sin(x) as 1.0/tan(x).

2003-06-10  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (fold <EQ_EXPR>):  Don't fold x == x only if x
	is a floating point type *and* we currently honor NaNs.
	(fold <NE_EXPR>): Likewise.

2003-06-10  Mark Mitchell  <mark@codesourcery.com>

	PR c++/11131
	* tree-inline.c (inlinable_function_p): Call the language-specific
	hook early.

2003-06-09  David Taylor  <dtaylor@emc.com>

	* config/rs6000/rs6000.c (rs6000_va_start, rs6000_va_arg):  Skip over
	the f_res field.

2003-06-09  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Remove references to host_truncate_target.
	* configure: Regenerate.
	* config.gcc: Remove references to truncate_target,
	host_truncate_target.

	* Makefile.in, configure.in, config/m68hc11/t-m68hc11-gas:
	Replace "build_canonical" with build, "host_canonical" with host.
	* configure.in: Use GCC_TOPLEV_SUBDIRS.
	* aclocal.m4: Include ../config/acx.m4.
	* configure: Regenerate.

2003-06-09  David Taylor  <dtaylor@emc.com>

	* config/rs6000/rs6000.c (rs6000_build_va_list): Give the two
	bytes of padding in the __va_list_tag structure a name (reserved).

2003-06-09  Jason Merrill  <jason@redhat.com>

	* fold-const.c (operand_equal_p): Handle ADDR_EXPR and TRUTH_NOT_EXPR.

2003-06-09  Osku Salerma  <osku@iki.fi>

	* c-format.c (check_format_string, get_constant): New.
	(handle_format_attribute, handle_format_arg_attribute,
	decode_format_attr): Change to use above functions.

2003-06-09  Richard Henderson  <rth@redhat.com>

	* stmt.c (expand_asm_operands): Re-word warning.

2003-06-08  Andrew Pinski  <pinskia@physics.uc.edu>

	PR target/8787
	* config/i386/djgpp.h (ASM_FILE_START): emit `.intel_syntax'
	if -masm=intel.

2003-06-09  James E Wilson  <wilson@tuliptree.org>

	* config/frv/cmovc.c, config/frv/cmovh.c, config/frv/cmovw.c,
	config/frv/frvbegin.c, config/frv/frvend.c, config/frv/lib1funcs.asm:
	Add libgcc exception.

2003-06-09  David Edelsohn  <edelsohn@gnu.org>
	    Ayal Zaks  <gcchaifa@us.ibm.com>

	* config/rs6000/rs6000.md (define_attr "type"): Add insert_word.
	(insvsi*): Add insert_word attribute.
	* config/rs6000/rs6000.c (rs6000_variable_issue): Add TYPE_INSERT_WORD.
	* config/rs6000/{40x.md,603.md,6xx.md,7450.md,7xx.md,mpc.md,
	power4.md,rios1.md,rios2.md,rs64.md}: Add insert_word.

2003-06-09  Kazu Hirata  <kazu@cs.umass.edu>

	* fold-const.c (fold): Fix a comment typo.

2003-06-09  Nathan Sidwell  <nathan@codesourcery.com>

	* tree-inline.c (expand_call_inline): DECL_SOURCE_LINE_FIRST is
	removed.

2003-06-09  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (gen_block_redirect): Use locators.

2003-06-09  Richard Earnshaw  <rearnsha@arm.com>

	* arm.h (THUMB_PRINT_OPERAND_ADDRESS): Use %wd in format and remove
	cast to int.

2003-06-09  Richard Sandiford  <rsandifo@redhat.com>

	* configure.in: Assume gas 2.14 and above can handle MIPS relocation
	operators.
	* configure: Regenerated.

2003-06-09  Richard Sandiford  <rsandifo@redhat.com>
	    Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.h (GLOBAL_POINTER_REGNUM): New macro.
	(PIC_OFFSET_TABLE_REGNUM): Look at pic_offset_table_rtx after reload.
	(STARTING_FRAME_OFFSET): Don't allocate a cprestore slot for
	n32/64 PIC.
	(MUST_SAVE_REGISTERS): Delete.
	* config/mips/mips.c (mips_frame_info): Remove extra_size field.
	(machine_function): Add global_pointer field.
	(mips_classify_constant): Check for (const $gp) using pointer equality
	with pic_offset_table_rtx.
	(mips_classify_constant): Handle RELOC_LOADGP_HI and RELOC_LOADGP_LO.
	(mips_restore_gp): Use current_function_outgoing_args_size.
	(print_operand): Use PIC_OFFSET_TABLE_REGNUM instead of
	GP_REG_FIRST + 28.  Handle relocation strings that have
	more than one '('.
	(mips_reloc_string): Handle RELOC_LOADGP_HI and RELOC_LOADGP_LO.
	(mips_global_pointer): New function.
	(mips_save_reg_p): New function, mostly split out from...
	(compute_frame_size): ...here.  Remove handling of extra_size.
	Reclaim args_size if no variables depend on it.  Don't treat gp
	as a special case: handle it in the main GPR loop.
	(mips_initial_elimination_offset): Fix comment.
	(save_restore_insns): Save every register in the GPR mask,
	removing distinction between mask and real_mask.
	(mips_output_function_prologue): Update .frame psuedo-op after
	the removal of extra_size.  Move the SVR4 PIC stack allocation
	and cprestore instructions to mips_expand_prologue.
	(mips_gp_insn): New function.
	(mips_expand_prologue): Set REGNO (pic_offset_table_rtx) to
	the chosen global pointer.  Handle SVR4 PIC stack allocation
	in the same way as other ABIs.  Adjust varargs code accordingly.
	Emit a cprestore insn after allocating the stack.  Use mips_gp_insn
	to emit the loadgp sequence.  Follow it with a loadgp_blockage
	if not using explicit relocs.
	(mips_output_function_epilogue): Reinstate the default gp register.
	(mips16_gp_pseudo_reg): Use pic_offset_table_rtx.
	(mips16_optimize_gp): Likewise.
	* config/mips/mips.md (UNSPEC_LOADGP): Remove.
	(UNSPEC_SETJMP, UNSPEC_LONGJMP): Remove.
	(UNSPEC_CPRESTORE, RELOC_LOADGP_HI, RELOC_LOADGP_LO): New.
	(loadgp): Remove.
	(loadgp_blockage, cprestore): New instructions.
	(builtin_setjmp_setup): Implement using emit_move_insn.  Use
	pic_offset_table_rtx.
	(builtin_setjmp_setup_32, builtin_setjmp_setup_64): Remove.
	(builtin_longjmp): Use gen_raw_REG to force use of $28.

2003-06-09  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (mips_output_division): Declare.
	* config/mips/mips.h (MASK_CHECK_RANGE_DIV): Remove.
	(MASK_BRANCHLIKELY): Use MASK_CHECK_RANGE_DIV's old number.
	(TARGET_NO_CHECK_ZERO_DIV, TARGET_CHECK_RANGE_DIV): Remove.
	(TARGET_CHECK_ZERO_DIV): New macro.
	(TARGET_SWITCHES): Remove -mcheck-range-div & -mno-check-range-div.
	* config/mips/mips.c (mips_output_division): New function.
	* config/mips/mips.md (length): Take TARGET_CHECK_ZERO_DIV into
	account when calculating the default length of a division.
	(divmodsi4, divmoddi4, udivmodsi4, udivmoddi4): Turn into define_insns.
	Enable regardless of optimization level.  Use mips_output_division.
	(divmodsi4_internal, divmoddi4_internal, udivmodsi4_internal,
	udivmoddi4_internal, div_trap, div_trap_normal, div_trap_mips16,
	divsi3, divsi3_internal, divdi3, divdi3_internal, modsi3,
	modsi3_internal, moddi3, moddi3_internal, udivsi3, udivsi3_internal,
	udivdi3, udivdi3_internal, umodsi3, umodsi3_internal, umoddi3,
	umoddi3_internal): Remove.

2003-06-09  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_reg_names): Change hilo entry to "".
	(mips_sw_reg_names): Likewise.
	(mips_regno_to_class): Change hilo entry to NO_REGS.
	(hilo_operand): Use MD_REG_P.
	(extend_operator): New predicate.
	(override_options): Remove 'a' constraint.
	(mips_secondary_reload_class): Remove hilo handling.  Also remove
	handling of (plus sp reg) reloads for mips16.
	(mips_register_move_cost): Remove hilo handling.
	* config/mips/mips.h (FIXED_REGISTERS): Make hilo entry fixed.
	(MD_REG_LAST): Remove hilo from range.
	(HILO_REGNUM): Delete.
	(reg_class): Remove HILO_REG and HILO_AND_GR_REGS.
	(REG_CLASS_NAMES, REG_CLASS_CONTENTS): Update accordingly.
	(PREDICATE_CODES): Add entry for extend_operator.
	(DEBUG_REGISTER_NAMES): Change hilo entry to "".
	* config/mips/mips.md: Remove hilo clobbers wherever they occur.
	Remove constraints from multiplication define_expands.  Remove
	clobbers from "decorative" define_expand patterns.
	(UNSPEC_HILO_DELAY): Delete.
	(*mul_acc_si, *mul_sub_si): Add early-clobber to operand 6.
	(mulsidi3, umulsidi3): Change pattern to match the TARGET_64BIT case.
	Adjust C code to just emit insns for !TARGET_64BIT.
	(mulsidi3_internal): Rename to mulsidi3_32bit.
	(mulsidi3_64bit): Use a "d" constraint for the destination.
	Use extend_operator so that the pattern can handle umulsidi3 as well.
	Split the instruction after reload.
	(*mulsidi3_64bit_parts): New pattern, generated by mulsidi3_64bit.
	(umulsidi3_internal): Rename to umulsidi3_32bit.
	(umulsidi3_64bit): Remove.
	(*smsac_di, *umsac_di): Line-wrap fixes.
	(udivsi3_internal): Don't allow operand 2 to be constant.
	(udivdi3_internal, umodsi3_internal, umoddi3_internal): Likewise.
	(movdi_internal2, movsi_internal): Remove hilo alternatives.
	(reload_in[sd]i, reload_out[sd]i, hilo_delay): Remove.

2003-06-09  Richard Sandiford  <rsandifo@redhat.com>

	PR target/10913
	* config/mips/mips.h (TARGET_FILE_SWITCHING, NO_DBX_FUNCTION_END,
	PUT_SDB_SCL, PUT_SDB_INT_VAL, PUT_SDB_VAL, PUT_SDB_ENDEF,
	PUT_SDB_TYPE, PUT_SDB_SIZE, PUT_SDB_DIM, PUT_SDB_START_DIM,
	PUT_SDB_NEXT_DIM, PUT_SDB_LAST_DIM, PUT_SDB_TAG, PUT_SDB_SRC_FILE,
	SDB_GENERATE_FAKE, TEXT_SECTION): Delete.
	(PUT_SDB_DEF, PUT_SDB_PLAIN_DEF, PUT_SDB_BLOCK_START,
	PUT_SDB_BLOCK_END, PUT_SDB_FUNCTION_END): Replace use of
	asm_out_text_file with asm_out_file.
	* config/mips/iris5gas.h (PUT_SDB_SIZE, PUT_SDB_TYPE): Likewise.
	* config/mips/elf.h (TEXT_SECTION): Undefine.
	* config/mips/elf64.h (TEXT_SECION): Undefine.
	* config/mips/openbsd.h (TEXT_SECION): Undefine.
	* config/mips/mips.c (asm_out_text_file, asm_out_data_file): Delete.
	(override_options): Disable small-data optimizations unless using
	gas or explicit relocations.
	(mips_asm_file_start, mips_asm_file_end, mips_output_function_epilogue,
	iris6_asm_named_section, iris6_asm_file_start): Remove code for
	handling TARGET_FILE_SWITCHING.
	(copy_file_data): Move into TARGET_IRIX6 block.

2003-06-08  Richard Henderson  <rth@redhat.com>

	* expr.h (EXPAND_MEMORY): New.
	* expr.c (expand_expr): Check it.
	* stmt.c (expand_asm_operands): Provide it when the constraint
	requires a memory.  Warn for memory input constraints without
	a memory operand.

2003-06-08  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* varasm.c: Don't include c-tree.h.

2003-06-08  Andreas Jaeger  <aj@suse.de>

	* predict.h: Convert to ISO C90 prototypes.
	* predict.c: Likewise.
	* tree-dump.h: Likewise.
	* tree-dump.c: Likewise.
	* diagnostic.h: Likewise.
	* diagnostic.c: Likewise.
	* combine.c: Likewise.

	* rtl.h: Convert prototypes of combine.c to ISO C90.

Sun Jun  8 21:27:41 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* cfglayout.c (insn_scope): New static function
	(block_locators_*, line_locators*, file_locators*): New static varrays.
	(scope_to_insns_initialize): Use them.
	(insn_line, insn_file): New functions.
	(scope_to_insns_finalize): Use insn_scope.
	(prologue_locator, epilogue_locator): New global variables.
	* emit-rt.c (try_split, make_insn_raw, make_jump_insn_raw,
	make_call_insn_raw, emit_copy_of_insn_after): Use locators.
	(emit_insn_after_scope, emit_insn_before_scope
	emit_jump_insn_after_scope, emit_jump_insn_before_scope
	emit_call_insn_after_scope, emit_call_insn_before_scope): Rename to...
	(emit_insn_after_setloc, emit_insn_before_setloc
	emit_jump_insn_after_setloc, emit_jump_insn_before_setloc
	emit_call_insn_after_setloc, emit_call_insn_before_setloc): ... these;
	use locators.
	* final.c (notice_source_line): Use locators.
	(final_start_function): Set initial source file and line.
	(final_scan_insn): Use locators.
	* ifcvt.c (noce_try_store_flag, noce_try_store_flag_constants,
	noce_try_addcc, noce_try_store_flag_mask, noce_try_cmove,
	noce_try_cmove_arith, noce_try_minmax, noce_try_abs,
	noce_process_if_block, find_cond_trap): Likewise.
	* integrate.c (copy_insn_list): Likewise.
	* jump.c (duplicate_loop_exit_test): LIkewise.
	* print-rtl.c (print_rtx): Print locators.
	* recog.c (peephole2_optimize): Likewise.
	* rtl.h (INSN_SCOPE): Remove.
	(emit_insn_after_scope, emit_insn_before_scope
	emit_jump_insn_after_scope, emit_jump_insn_before_scope
	emit_call_insn_after_scope, emit_call_insn_before_scope): Rename to...
	(emit_insn_after_setloc, emit_insn_before_setloc
	emit_jump_insn_after_setloc, emit_jump_insn_before_setloc
	emit_call_insn_after_setloc, emit_call_insn_before_setloc): ... these;
	(insn_file, insn_line, prologue_locator, epilogue_locator): Declare.
	* unroll.c (copy_loop_body): Use locators.
	* function.c (set_insn_locators): New function.
	(thread_prologue_and_epilogue_insns): Set the locators accordingly.

2003-06-08  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (LONG_LONG_TYPE_SIZE): Set to 64.
	* config/h8300/t-h8300 (LIB1ASMFUNCS): Remove _floatdisf
	_fixsfdi _fixunssfdi.
	(LIB2FUNCS_EXTRA): Add entries for clzhi2, ctzhi2, parityhi2,
	popcounthi2.
	(TARGET_LIBGCC2_CFLAGS): Remove -DDI=SI.
	* config/h8300/clzhi2.c: New.
	* config/h8300/ctzhi2.c: Likewise.
	* config/h8300/parityhi2.c: Likewise.
	* config/h8300/popcounthi2.c: Likewise.

Sun Jun  8 15:52:17 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.md (subsi_3_zext, sse2_nandv2di3): Fix predicates.
	* i386.c (k8_avoid_jump_misspredicts): Fix debug output.

	* cfg.c (verify_flow_info): Move IL independent checks from cfgrtl here.
	(dump_bb): New based on old dump_bb in cfgrtl.c
	(debug_bb, debug_bb_n): Move the functions from cfgrtl.c here.
	* cfghooks.h (cfgh_verify_flow_info): Return status.
	* cfglayout.c (cfg_layout_finalize): Verify CFG correctness.
	* cfgrtl.c (debug_bb, debug_bb_n): Move to cfg.c
	(dump_bb): Remove generic parts.
	(rtl_verify_flow_info_1): Break out from rtl_verify_flow_info.
	(rtl_verify_flow_info): Only check things dependeing on linearized RTL.

2003-06-08  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in: Rename options.c and options.h to c-options.c and
	c-options.h.
	(OBJS): Remove options.o.
	* c-opts.c: Don'tInclude c-options.h instead of options.h.
	* opts.c: Don't include options.h.
	(find_opt): Can't use enum opt_code or N_OPTS.
	* opts.h (struct cl_option, cl_options, cl_options_count): Move from...
	* opts.sh: ... here.

2003-06-07  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	PR pch/9830
	* ggc-common.c (HAVE_MMAP_FILE): Include sys/types.h
	if HAVE_MINCORE is defined.
	(MAP_FAILED): Define if not defined.
	(gt_pch_save): Test against MAP_FAILED.
	(gt_pch_restore): If HAVE_MINCORE, use MAP_FIXED to force
	the mapping address to the preferred base after checking it
	is possible to do so. Test against MAP_FAILED.
	* configure.in: Test for the presence of mincore in libc.
	* config.in: Regenerate.
	* configure: Regenerate.

2003-06-07  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (alpha_setup_incoming_varargs): Fix
	conditional compilation guard.

2003-06-08  Kazu Hirata  <kazu@cs.umass.edu>

	* optabs.c (expand_abs): Set result_unsignedp to 1 if
	flag_trav is zero.

2003-06-07  Richard Henderson  <rth@redhat.com>

	* c-cppbuiltin.c (c_cpp_builtins): Define __EXCEPTIONS for C also.

2003-06-07  Richard Henderson  <rth@redhat.com>

	* basic-block.h (EDGE_SIBCALL): New.
	(EDGE_ALL_FLAGS): Update.
	* cfg.c (dump_edge_info): Add sibcall name.
	* cfgbuild.c (make_edges): Use EDGE_SIBCALL.
	* cfgrtl.c (purge_dead_edges): Handle sibcalls.

2003-06-07  Andreas Jaeger  <aj@suse.de>

	* mklibgcc.in (lib2funcs): Remove _exit.
	* libgcc2.c: Remove L_exit.
	* gbl-ctors.h: Remove declarations dependend on NEED_ATEXIT.

	* system.h: Poison NEED_ATEXIT, ON_EXIT, EXIT_BODY.

	* doc/tm.texi (Misc): Remove NEED_ATEXIT, ON_EXIT, EXIT_BODY.

	* ggc.h: Convert to ISO C90 prototypes.
	* ggc-none.c: Likewise.
	* ggc-common.c: Likewise.
	* ggc-page.c: Likewise.
	* ggc-simple.c: Likewise.

	* crtstuff.c: Remove undefined usage of INIT_SECTION_PREAMBLE.

	* system.h: Poison INIT_SECTION_PREAMBLE.

2003-06-07  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc (with_cpu handling): Translate sparc64 in
	$machine to --with-cpu=v9.
	* config/alpha/alpha.c
	(TARGET_ASM_GLOBALIZE_LABEL [TARGET_ABI_UNICOSMK]): Correct definition.
	(alpha_setup_incoming_varargs): #ifdef out when TARGET_ABI_UNICOSMK.

	* target.h: New hook asm_out.file_end.
	* target.h: Update to match.  New hook macro TARGET_ASM_FILE_END.
	* toplev.c (compile_file): Use targetm.asm_out.file_end.
	* system.h: Poison ASM_FILE_END.
	* varasm.c (file_end_indicate_exec_stack): New.
	* output.h: Prototype it.
	* doc/tm.texi: Document TARGET_ASM_FILE_END and
	file_end_indicate_exec_stack.  Delete references to attasm.h.

	* config/darwin.h (TARGET_ASM_FILE_END): Reset to darwin_file_end.
	(ASM_FILE_END): Delete; move code...
	* config/darwin.c (darwin_file_end): Here; new function.
	* config/darwin-protos.h: Prototype it.
	* config/alpha/alpha.c (unicosmk_asm_file_end): Make static,
	rename unicosmk_file_end.
	* config/arm/aof.h (ASM_FILE_END): Delete; move code...
	* config/arm/arm.c (aof_file_end): ... here; new static function.
	Set TARGET_ASM_FILE_END to aof_file_end if AOF_ASSEMBLER.
	Make aof_dump_imports and aof_dump_pic_table static.
	* config/avr/avr.c (asm_file_end): Rename avr_file_end, make static.
	Set TARGET_ASM_FILE_END to avr_file_end.
	* config/c4x/c4x.c (c4x_file_end): Make static.  Take no arguments.
	Set TARGET_ASM_FILE_END to c4x_file_end.
	* config/h8300/h8300.c (asm_file_end): Rename h8300_file_end,
	make static. Take no arguments.  Set TARGET_ASM_FILE_END to
	h8300_file_end.
	* config/i370/i370.h (ASM_FILE_END): Delete; move code...
	* config/i370/i370.c (i370_file_end): ... here; new static function.
	Set TARGET_ASM_FILE_END to i370_file_end.
	 * config/i386/i386.c (ix86_asm_file_end): Rename ix86_file_end.
	 Take no arguments.  Call file_end_indicate_exec_stack if
	 NEED_INDICATE_EXEC_STACK; don't use SUBTARGET_FILE_END.
	* config/i386/i386.h: Set TARGET_ASM_FILE_END, not ASM_FILE_END.
	Define NEED_INDICATE_EXEC_STACK to 0.
	* config/i386/linux.h, config/i386/linux64.h: Redefine
	NEED_INDICATE_EXEC_STACK to 1 instead of setting SUBTARGET_FILE_END.
	* config/i386/winnt.c (i386_pe_asm_file_end): Rename to
	i386_pe_file_end.  Take no arguments.  Use ix86_file_end.
	* config/ia64/ia64.c (ia64_hpux_asm_file_end): Rename to
	ia64_hpux_file_end, make static.  Take no arguments.
	* config/ip2k/ip2k.c (asm_file_start, asm_file_end,
	commands_in_prologues, commands_in_epilogues): Delete.
	(function_epilogue): Update to match.
	* config/mips/mips.c (mips_asm_file_end): Rename mips_file_end,
	make static.  Take no arguments.
	(iris6_asm_file_end): Rename iris6_file_end, make static, use
	mips_file_end, take no arguments.
	Set TARGET_ASM_FILE_END to iris6_file_end or mips_file_end as
	appropriate.
	* config/mmix/mmix.c (mmix_asm_file_end): Rename mmix_file_end,
	make static, take no arguments. Set TARGET_ASM_FILE_END to
	mmix_file_end.
	* config/pa/pa.c (output_deferred_plabels): Make static, take
	no arguments.  Set TARGET_ASM_FILE_END to output_deferred_plabels.
	* config/rs6000/xcoff.h (TARGET_ASM_FILE_END): Set it.
	(ASM_FILE_END): Delete; move code...
	* config/rs6000/rs6000.c (rs6000_xcoff_file_end): ... here;
	new static function.

	* config/avr/avr.h, config/cris/cris.h, config/h8300/h8300.h
	* config/mmix/mmix.h, config/mips/iris6.h, config/mips/mips.h:
	Don't set ASM_FILE_END.
	* config/alpha/linux-elf.h, config/m68k/linux.h, config/rs6000/linux.h
	* config/rs6000/linux64.h, config/s390/linux.h, config/sparc/linux.h
	* config/sparc/linux64.h: Set TARGET_ASM_FILE_END to
	file_end_indicate_exec_stack; don't set ASM_FILE_END.
	* config/alpha/unicosmk.h, config/i386/cygming.h
	* config/ia64/hpux.h: Set TARGET_ASM_FILE_END, not ASM_FILE_END.
	* config/arm/arm-protos.h, config/alpha/alpha-protos.h
	* config/avr/avr-protos.h, config/c4x/c4x-protos.h
	* config/h8300/h8300-protos.h, config/ia64/ia64-protos.h
	* config/ip2k/ip2k-protos.h, config/mips/mips-protos.h
	* config/mmix/mmix-protos.h, config/pa/pa-protos.h: Update.

Sat Jun  7 18:32:13 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.h (OPTION_DEFAULT_SPECS): Avoid -mcpu default when -march is
	specified.

Sat Jun  7 15:20:01 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* Makefile.in (stageprofile_build): Kill redundant target.
	* i386.c (mdep_reorg): Don't pad jumps for Athlon.

2003-06-07  Andreas Jaeger  <aj@suse.de>

	* doc/tm.texi (Costs): Remove DONT_REDUCE_ADDR documentation.

	* config/avr/avr.h: Remove comment regarding DONT_REDUCE_ADDR.
	* config/dsp16xx/dsp16xx.h: Likewise.
	* config/i386/i386.h: Likewise.
	* config/ip2k/ip2k.h: Likewise.

2003-06-07  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in (OJBS, c-opts.o): Update.
	(c-options.c, c-options.h): Rename options.h and options.c.
	(options.h): Rename options_.h.
	(opts.o): New.
	* c-common.h (c_common_handle_option): Replace c_common_decode_option.
	(c_common_init_options): Update prototype.
	* c-lang.c (c_init_options): Update prototype.
	(LANG_HOOKS_HANDLE_OPTION): Override.
	(LANG_HOOKS_DECODE_OPTION): Drop.
	* c-opts.c: Include opts.h and options.h instead of c-options.h
	and c-options.c.
	(lang_flags): Move to file scope.
	(find_opt, c_common_decode_option): Remove.
	(CL_C, CL_OBJC, CL_CXX, CL_OBJCXX, CL_JOINED, CL_SEPARATE,
	CL_REJECT_NEGATIVE): Move to opts.h.
	(missing_arg): Update prototype.
	(c_common_init_options): Update for new prototype.
	(c_common_handle_options): Filenames are passed as N_OPTS.
	* hooks.c (hook_int_void_0): New.
	* hooks.h (hook_int_void_0): New.
	* langhooks-def.h (LANG_HOOKS_INIT_OPTIONS): New default.
	(LANG_HOOKS_HANDLE_OPTION): Default to NULL for now.
	(LANG_HOOKS_INITIALIZER): Update.
	* langhooks.h (init_options): Update.
	(handle_option): New.
	* opts.c, opts.h: New files.
	* opts.sh: Update c file to include opts.h and options.h.
	* toplev.c: Include opts.h; change options.h to options_.h.
	(parse_options_and_default_flags): Get lang_mask, use
	handle_option for language-specific handling.
	* objc/objc-lang.c (LANG_HOOKS_DECODE_OPTON): Drop.
	(LANG_HOOKS_HANDLE_OPTION): Override.
	(objc_init_options): Update.

2003-06-07  Magnus Kreth <magnus.kreth@gmx.de>
	    Thibaud Gaillard <thibaud.gaillard@nto.atmel.com>

	PR other/7031
	* Makefile.in (install-common): Remove GCOV_INSTALL_NAME instead of
	gcov.

2003-06-07  Kelley Cook  <kelleycook@wideopenwest.com>

	* configure.in (HAVE_LD_RO_RW_SECTION_MIXING): Remove quotes in
	section names.
	* configure: Regenerate.

2003-06-07  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/linux64.h (CRT_CALL_STATIC_FUNCTION): Define.

2003-06-06  James E Wilson  <wilson@tuliptree.org>

	PR inline-asm/10890
	* reload1.c (merge_assigned_reloads): Abort only if two reloads have
	different in fields.

2003-06-06  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: Make $(target_subdir) correspond with top level usage.
	* Makefile.in: Likewise.
	* configure: Regenerate.

2003-06-06  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.h (ASM_OUTPUT_SKIP, ASM_OUTPUT_ALIGNED_COMMON,
	ASM_OUTPUT_ALIGNED_LOCAL): Cast `SIZE' and `ALIGNED' parameters to
	unsigned HOST_WIDE_INT.
	* pa-pro-end.h (ASM_OUTPUT_ALIGNED_COMMOM, ASM_OUTPUT_ALIGNED_LOCAL):
	Likewise.
	* pa64-hpux.h (ASM_OUTPUT_ALIGNED_COMMON, ASM_OUTPUT_ALIGNED_LOCAL):
	Likewise.

2003-06-06  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* doc/install.texi (Prerequisites): New section documenting
	tools and packages necessary prior to building and/or
	modifying GCC.
	* doc/install.texi2html: Also generate prerequisites.html.

2003-06-06  Richard Earnshaw  <rearnsha@arm.com>

	PR target/11052
	* ifcvt.c (noce_process_if_block): Fail if the destination has
	side-effects.

2003-06-06  Jason Merrill  <jason@redhat.com>

	* stmt.c (resolve_asm_operand_names): Rename from
	resolve_operand_names.  No longer static.  Avoid needless copying.
	Don't build array of constraints.
	(expand_asm_operands): Build it here.
	* tree.h: Declare resolve_asm_operand_names.

	* stmt.c (expand_decl): Put artificial vars into registers even
	when not optimizing, and don't mark the regs as user vars.

2003-06-06  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (FUNCTION_ARG_1): Consistently use NEW_MODE for the mode
	of the generated register.

2003-06-06  Daniel Jacobowitz  <drow@mvista.com>

	* config.gcc: Add a missing sparc64 case.

2003-06-06  Jakub Jelinek  <jakub@redhat.com>

	* mklibgcc.in: Propagate .note.GNU-stack section if needed into
	the .hidden assembly stubs.

2003-06-06  H.J. Lu <hongjiu.lu@intel.com>

	* config.gcc (extra_headers): Add emmintrin.h for i[34567]86-*-*
	and x86_64-*-*.

	* config/i386/mmintrin.h: Update version and add alternate
	intrinsic names.
	* config/i386/xmmintrin.h: Likewise.

	* config/i386/xmmintrin.h: Include <emmintrin.h>. Move SSE2
	intrinsics to ...
	* config/i386/emmintrin.h: Here. New file.

2003-06-06  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (fold <ABS_EXPR>):  Re-fold the result of folding
	fabs(-x) into fabs(x).  Use tree_expr_nonnegative_p to determine
	when the ABS_EXPR (fabs or abs) is not required.
	(tree_expr_nonnegative_p): Move the logic that sqrt and exp are
	always nonnegative from fold to here.  Additionally, cabs and fabs
	are always non-negative, and pow and atan are non-negative if
	their first argument is non-negative.

	* builtins.c (fold_builtin_cabs): New function to fold cabs{,f,l}.
	Evaluate cabs of a constant at compile-time.  Convert cabs of a
	non-complex argument into fabs.  Convert cabs(z) into
	sqrt(z.r*z.r + z.i*z.i) at the tree-level with -ffast-math or
	-funsafe-math-optimizations or -ffast-math.
	(fold_builtin): Convert BUILT_IN_FABS{,F,L} into an ABS_EXPR.
	Fold BUILT_IN_CABS{,F,L} using fold_builtin_cabs.

Thu Jun  5 20:51:09 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* sourcebuild.texi (Front End Directory): Document new hooks.

Fri Jun  6 11:02:35 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* function.c (FLOOR_ROUND, CEIL_ROUND): Fix.
	* i386.md (gen_pro_epilogue_adjust_stack): Deal with gigantic
	stack frames.
	(pro_epilogue_adjust_stack_rex64_2): New pattern

Fri Jun  6 11:03:14 CEST 2003  Jan Hubicka  <jh@suse.cz>
			       Pop Sebastian
			       Zdenek Dvorak <rakdver@atrey.karlin.mff.cuni.cz>

	* cfghooks.h, cfghooks.c: New files.
	* Makefile.in (BASIC_BLOCK_H): Depends on cfghooks.h.
	(OBJS): Add cfghooks.o.
	(cfghooks.o): New rule.
	* basic-block.h (split_edge): Rename to rtl_split_edge.
	(verify_flow_info): Rename to rtl_verify_flow_info.
	(cfghooks.h): Included here.
	* cfgrtl.c (split_edge): Renamed rtl_split_edge.
	(verify_flow_info): Renamed rtl_verify_flow_info.
	* toplev.c (rest_of_compilation): Call rtl_register_cfg_hooks.

	* basic-block.h (split_block, split_edge, flow_delete_block,
	redirect_edge_and_branch, redirect_edge_and_branch_force): Delete.
	(flow_delete_block_noexpunge):  Return void.
	* cfg.c (verify_flow_info): New function.
	* cfgcleanup.c (try_simplify_condjump, outgoing_edges_match,
	try_crossjump_to_edge, try_optimize_cfg, delete_unreachable_blocks):
	Use delete_block.
	* cfglayout.c (function_footer): Rename to...
	(cfg_layout_function_footer): ... this variable
	(unlink_insn_chain): Make global.
	(fixup_reorder_chain, record_effective_endpoints): Update.
	(cleanup_unconditional_jumps): Use delete_block.
	(cfg_layout_redirect_edge, cfg_layout_split_block): Move to cfgrtl.c
	(cfg_layout_duplicate_bb): Use redirect_edge_and_branch_force.
	(cfg_layout_initialize, cfg_layout_finalize): Update hooks.
	* cfglayout.h (cfg_layout_redirect_edge, cfg_layout_split_block):  Delete.
	(cfg_layout_function_footer): Declare.
	* cfgloopmanip (split_loop_bb): Do not update RBI.
	(remove_bbs): Use delete_block.
	(loop_reidrect_edge, loop_delete_branch_edge): Use
	redirect_edge_and_branch.
	(create_preheader): Use split_block and redirect_edge_and_branch_force.
	(split_edge_with): Likewise.
	* cfgrtl.c: Include cfglayout.h
	(split_edge): Rename to ...
	(rtl_split_edge) ... this one; make local.
	(redirect_edge_and_branch): Rename to ...
	(rtl_redirect_edge_and_branch) ... this one; make local.
	(redirect_edge_and_branch_force): Rename to ...
	(rtl_redirect_edge_and_branch_force) ... this one; make local.
	(cfg_layout_delete_block, cfg_layout_delete_edge_and_branch_force): New.
	(cfg_layout_redirect_edge_and_branch, cfg_layout_split_block): Move here from
	cfglayout.c; update to directly call RTL counterparts.
	(rtl_cfg_hooks, cfg_layout_rtl_cfg_hooks): New functions.
	* ifcvt.c (find_cond_trap): Use delete_block.
	(find_if_case_1): Use delete_block.
	(find_if_case_2): Use delete_block.
	* rtl.h (unlink_insn_chain): Declare.
	* toplev.c (rtl_reigster_cfg_hooks): New.

2003-06-05  Richard Henderson  <rth@redhat.com>

	* recog.c (peephole2_optimize): Revert last change.

2003-06-05  Richard Henderson  <rth@redhat.com>

	* recog.c (peephole2_optimize): Don't split block unless
	can_throw_internal.

2003-06-06  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (get_shift_alg): Correct the syntax of rotxl.
	* config/h8300/h8300.md (*addsi3_lshiftrt_16_zexthi): Likewise.

2003-06-05  Kelley Cook  <kelleycook@wideopenwest.com>

	PR optimization/4490
	* config/i386/i386.md: Don't use XFMode if TARGET_128BIT_LONG_DOUBLE.
	* doc/invoke.texi (m96bit-long-double, m128bit-long-double):  Reword
	documentation to accurately reflect what these options do.

2003-06-06  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/linux.h (STARTFILE_SPEC): Handle -pie.  Simplify.
	(ENDFILE_SPEC): Redefine to handle -pie.

2003-06-05  Phil Edwards <phil@jaj.com>

	* Makefile.in (qmtest-g++): Use target_alias, not target.

2003-06-05  Per Bothner  <pbothner@apple.com>

	* toplev.c (push_srcloc):  Simplify behavior to save current location
	and set current location to parameters.
	(pop_srcloc):  Simplify semantics.
	(lang_dependent_init):  Remove now-useless initial push_srcloc.

2003-05-06  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (loc_descriptor_from_tree): Return 0 for
	language-specific tree codes.

2003-06-05  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR middle-end/9986
	* pa.c (pa_init_builtins): Also set implicit_built_in_decls for
	BUILT_IN_FPUTC_UNLOCKED to NULL_TREE.

Thu Jun  5 18:32:46 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* install.tex: Document profiledbootstrap.

	* configure.in:  Add support for lang.stageprofile and
	lang.stagefeedback
	* Makefile.in (clean, distclean): Kill new stages
	(POSTSTAGE1_FLAGS_TO_PASS): Break from ...
	(STAGE2_FLAGS_TO_PASS): ... this one.
	(STAGEPROFILE_FLAGS_TO_PASS, STAGEFEEDBACK_FLAGS_TO_PASS): New.
	(stage[2-4]_build): Add POSTSTAGE1_FLAGS_TO_PASS.
	(stageprofile_build, stageprofile_copy, stagefeedback_build,
	stagefeedback_copy): New.
	(restageprofile, restagefeedback, stageprofile-start,
	stageprofile, stagefeedback-start): Likewise.

2003-06-05  David Miller  <davem@redhat.com>
	    Richard Henderson  <rth@redhat.com>

	* optabs.c (HAVE_conditional_trap): Provide default.
	(gen_conditional_trap): Likewise.
	(init_optabs): Merge init_traps.
	(gen_cond_trap): Use prepare_operand.  Restructure and avoid ifdef.

Thu Jun  5 14:59:44 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* combine.c (simplify_if_then_else): (IF_THEN_ELSE (NE REG 0) (0) (8))
	is REG for nonzero_bits (REG) == 8.

Thu Jun  5 13:23:51 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.md (align): Fix warning; clarify what to do when no p2align
	is available.

2003-06-05  Nick Clifton  <nickc@redhat.com>

	* config.gcc (m32r-elf): Revert previous delta.
	* config/m32r/t-m32r (crtinit.o): Fix rule to work with
	multilibs.  Remove m32rx specific version.
	(crtfini.o): Likewise.
	(EXTRA_MULTILIB_PARTS): Define.

2003-06-05  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/md.texi (Machine Constraints): Correct the meaning of
	constraints related to floating-point registers on SPARC.

2003-06-05  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Paolo Bonzini  <bonzini@gnu.org>

	PR target/10663
	* configure.in (HAVE_LD_RO_RW_SECTION_MIXING): Redirect
	assembler and linker output to /dev/null.
	Use a 'sed' construct instead of 'grep -A1'.
	* configure: Regenerate.

2003-06-04  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (struct ix86_address): Add seg.
	(no_seg_address_operand): New.
	(ix86_decompose_address): Restructure PLUS loop.  Accept one
	UNSPEC_TP if TARGET_TLS_DIRECT_SEG_REFS.  Adjust ESP swap test
	to test for a regnum, not stack_pointer_rtx.
	(ix86_address_cost): Reduce cost if non-default segment.
	(legitimate_address_p): Remove UNSPEC_TP check.
	(get_thread_pointer): Add to_reg argument.  Don't represent
	the thread pointer as a memory load.
	(legitimize_tls_address): Split out of ...
	(legitimize_address): ... here.
	(print_operand_address): Handle parts.seg.
	(ix86_expand_move): Use legitimize_tls_address.
	(ix86_rtx_costs): Handle UNSPEC_TP.
	* config/i386/i386.h (MASK_TLS_DIRECT_SEG_REFS): New.
	(TARGET_TLS_DIRECT_SEG_REFS): New.
	(TARGET_SWITCHES): Add tls-direct-seg-refs.
	(TARGET_TLS_DIRECT_SEG_REFS_DEFAULT): Default.
	(PREDICATE_CODES): Add no_seg_address_operand.
	* config/i386/i386.md (lea_1): Use it.
	(lea_1_rex64, lea_1_zext, lea_2_rex64): Likewise.
	(load_tp_si, add_tp_si, load_tp_di, add_tp_di): New.
	* config/i386/linux.h (TARGET_TLS_DIRECT_SEG_REFS_DEFAULT): New.
	* config/i386/linux64.h (TARGET_TLS_DIRECT_SEG_REFS_DEFAULT): New.
	* doc/invoke.texi: Add -mtls-direct-seg-refs.

2003-06-04  Mark Mitchell  <mark@codesourcery.com>

	* Makefile.in (QMTESTRUNFLAGS): Set for DejaGNU emulation.
	(QMTEST_GPP_TESTS): Use "g++" by default.
	(stamp-qmtest): Tweak database creation.
	(QMTEST_DIR/context): Update context file format.
	(qmtest-g++): Tweak command-line.

2003-06-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (varasm.o): Don't set -Wno-error.
	* rs6000/t-rs6000 (varasm.o, out_object_file): Don't clear.

2003-06-04  Zack Weinberg  <zack@codesourcery.com>

	PR bootstrap/3163
	* aclocal.m4 (AC_FUNC_MMAP_ANYWHERE, AC_FUNC_MMAP_FILE): Delete.
	(gcc_AC_FUNC_MMAP_BLACKLIST): New.
	* configure.in: Check for sys/mman.h and mmap in AC_CHECK_HEADERS
	and AC_CHECK_FUNCS lists, respectively.  Use
	gcc_AC_FUNC_MMAP_BLACKLIST, not AC_FUNC_MMAP_ANYWHERE nor
	AC_FUNC_MMAP_FILE.
	* configure, config.in: Regenerate.

2003-06-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* arm/aout.h (ASM_OUTPUT_SKIP): Fix cast for format specifier warning.
	* arm.c (arm_output_function_prologue): Fix format specifiers.
	* arm.h (ARM_PRINT_OPERAND_ADDRESS): Likewise.
	* m68k.c (m68k_output_mi_thunk): Use more readable %wd instead of
	HOST_WIDE_INT_PRINT_DEC.
	* vax.c (vax_output_function_prologue): Fix format specifiers.

2003-06-04  Richard Henderson  <rth@redhat.com>

	* cse.c (find_best_addr): Consider binary operators even if second
	argument is not CONST_INT.

2003-06-04  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* doc/invoke.texi (max-cse-path-length): Document.

2003-06-04  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.md (align): Use ASM_OUTPUT_*ALIGN macros.

2003-06-04  Andrew Pinski <pinskia@physics.uc.edu>

	* config/rs6000/darwin.h (RS6000_OUTPUT_BASENAME):
	Remove semi-colon at the end of the expression.

2003-06-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* i370.c (mvs_function_name_length): Fix signed/unsigned warnings.
	* i370.h (mvs_function_name_length): Likewise.
	* i960.h (CONSTANT_ALIGNMENT): Likewise.
	* mips/linux.h (ASM_OUTPUT_ALIGNED_BSS): Likewise.
	* pa/pa-pro-end.h (ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	* pa.h (ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	* rs6000/xcoff.h (ASM_DECLARE_FUNCTION_NAME): Delete unused
	variable.

2003-06-04  Daniel Jacobowitz  <drow@mvista.com>

	* config.gcc: Reorganize --with-cpu logic.  Set
	configure_default_options according to the default CPU, --with-cpu,
	--with-arch, --with-tune, --with-schedule, --with-abi, and
	--with-float.  Check for legal values of various options.
	* configure.in: Define configure_default_options in configargs.h.
	* configure: Regenerated.
	* config/mips/mips.h (TARGET_DEFAULT_ARCH_P)
	(TARGET_DEFAULT_FLOAT_P): New macros.
	* gcc.c (do_option_spec): New function.
	(struct default_spec, option_default_specs): New.
	(main): Call do_option_spec.
	* config/alpha/alpha.h, config/arm/arm.h, config/i386/i386.h,
	config/mips/mips.h, config/pa/pa.h, config/rs6000/rs6000.h,
	config/sparc/sparc.h (OPTION_DEFAULT_SPECS): Define.

	* doc/install.texi: Update --with-cpu documentation.  Mention
	--with-arch, --with-schedule, --with-tune, --with-abi, and
	--with-float.
	* doc/tm.texi (Driver): Document OPTION_DEFAULT_SPECS.

2003-06-04  Daniel Jacobowitz  <drow@mvista.com>

	* config.gcc: Only process --with-cpu logic in the third pass.

2003-06-04  Daniel Jacobowitz  <drow@mvista.com>

	* config.gcc: Reorganize --with-cpu section.  Remove an
	obsolete comment about the default CPU for x86-64.  Fix
	a typo for the ep9312.  Update the list of supported PowerPC
	CPUs.  Support a limited set of new --with-cpu options
	for i386.

2003-06-04  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (rs6000_complex_function_value): Unpack
	complex numbers <= 32 bits into two registers.

2003-06-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* alpha.c (print_operand_address): Fix format specifier warnings.
	* alpha/elf.h (ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	* alpha/vms.h (ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	* arm/aof.h (ASM_OUTPUT_COMMON, ASM_OUTPUT_LOCAL): Likewise.
	* arm/pe.h (ASM_OUTPUT_COMMON): Likewise.
	* avr.h (ASM_OUTPUT_COMMON, ASM_GENERATE_INTERNAL_LABEL,
	ASM_OUTPUT_SKIP): Likewise.
	* c4x.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* dsp16xx.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* h8300.h (ASM_GENERATE_INTERNAL_LABEL, ASM_OUTPUT_COMMON):
	Likewise.
	* i370.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* i386/cygming.h (ASM_OUTPUT_COMMON): Likewise.
	* i386/darwin.h (ASM_OUTPUT_COMMON): Likewise.
	* i960.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* m68k/hp320.h (PRINT_OPERAND_ADDRESS): Likewise.
	* mcore.h (ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	* pdp11.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* ptx4.h (ASM_OUTPUT_ALIGNED_COMMON): Likewise.
	* sparc/freebsd.h (ASM_GENERATE_INTERNAL_LABEL): Likewise.
	* svr3.h (ASM_OUTPUT_COMMON): Likewise.

2003-06-04  J"orn Rennecke <joern.rennecke@superh.com>

	* c-decl.c (c_init_decl_processing): Clear input_file_name
	while building common nodes.
	* dwarf2out.c (gen_compile_unit_die, dwarf2out_finish):
	Don't add working directory for strings like <built-in> .

2003-06-04  David Edelsohn  <edelsohn@gnu.org>

	* doc/install.texi (*-ibm-aix*): Native as and ld required
	to bootstrap on AIX 5L.

2003-06-04  Richard Henderson  <rth@redhat.com>

	* c-common.c (handle_cleanup_attribute): New.
	(c_common_attributes): Add it.
	* c-decl.c (finish_decl): Honor the cleanup attribute.
	* doc/extend.texi (Variable Attributes): Document it.

	* unwind-c.c: New file.
	* Makefile.in (LIB2ADDEH): Add it.
	* config/t-darwin, config/t-linux, config/t-linux-gnulibc1,
	config/ia64/t-ia64: Likewise.

2003-06-04  Jakub Jelinek  <jakub@redhat.com>

	* function.c (trampolines_created): New variable.
	(expand_function_end): Set it when doing INITIALIZE_TRAMPOLINE.
	* function.h (trampolines_created): Add.
	* config/s390/linux.h (ASM_FILE_END): Define.
	* config/alpha/linux-elf.h (ASM_FILE_END): Define.
	* config/m68k/linux.h (ASM_FILE_END): Define.
	* config/rs6000/linux.h (ASM_FILE_END): Define.
	* config/rs6000/linux64.h (ASM_FILE_END): Define.
	* config/rs6000/ppc-asm.h: Add .note.GNU-stack on powerpc-linux.
	* config/sparc/linux.h (ASM_FILE_END): Define.
	* config/sparc/linux64.h (ASM_FILE_END): Define.
	* config/i386/i386.c (ix86_asm_file_end): Use SUBTARGET_FILE_END.
	* config/i386/linux.h (SUBTARGET_FILE_END): Define.
	* config/i386/linux64.h (SUBTARGET_FILE_END): Define.

Wed Jun  4 18:39:33 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.c (min_insn_size, k8_avoid_jump_misspredicts): New functions
	(ix86_reorg): Use it.
	* i386.md (align): New insn pattern.

2003-06-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* toplev.c (rest_of_type_compilation): Fix typo.

2003-06-04  Jakub Jelinek  <jakub@redhat.com>
	    Alan Modra  <amodra@bigpond.net.au>

	* config/i386/linux.h (NO_PROFILE_COUNTERS): Define to 1.
	* config/i386/freebsd.h (NO_PROFILE_COUNTERS): Likewise.
	* config/i386/netbsd-elf.h (NO_PROFILE_COUNTERS): Likewise.
	* config/xtensa/xtensa.h (NO_PROFILE_COUTNERS): Likewise.
	* config/darwin.h (NO_PROFILE_COUNTERS): Likewise.
	* final.c (NO_PROFILE_COUNTERS): Define to 0 if not defined.
	(profile_function): Allow NO_PROFILE_COUNTERS to be non-constant.
	* config/rs6000/rs6000.c (output_profile_hook): Likewise.

	* configure.in (powerpc*-*, s390*-*): Set tls_as_opt.
	Pass it to $gcc_cv_as.
	* configure: Rebuilt.

	* config/rs6000/rs6000.c (rs6000_abi_name): Remove initializer.
	(print_operand): Allow TARGET_AIX to be non-constant.
	(rs6000_aix_emit_builtin_unwind_init, rs6000_emit_eh_toc_restore):
	Define unconditionally.
	(rs6000_elf_declare_function_name): New function.
	* config/rs6000/rs6000.md (eh_return): Allow TARGET_AIX to be
	non-constant.
	* config/rs6000/linux64.h [!RS6000_BI_ARCH] (TARGET_64BIT): Define
	to 1.
	(DEFAULT_ARCH64_P, RS6000_BI_ARCH_P): Define.
	[IN_LIBGCC2] (TARGET_64BIT): Define based on whether __powerpc64__
	is defined.
	(TARGET_AIX): Define to 1 if TARGET_64BIT.
	(PROCESSOR_DEFAULT): Remove.
	(TARGET_RELOCATABLE, RS6000_ABI_NAME, INVALID_64BIT,
	INVALID_32BIT, SUBSUBTARGET_OVERRIDE_OPTIONS): Define.
	[RS6000_BI_ARCH] (OVERRIDE_OPTIONS, ASM_FILE_START): Define.
	(ASM_DEFAULT_SPEC, ASM_SPEC, LINK_OS_LINUX_SPEC): Define for both
	-m32 and -m64.
	(MULTILIB_DEFAULTS): Define.
	(SUBSUBTARGET_EXTRA_SPECS): Define.
	(ASM_SPEC32, ASM_SPEC64, ASM_SPEC_COMMON): Define.
	(TARGET_TOC): Define only if !RS6000_BI_ARCH.
	(TARGET_NO_TOC): Remove.
	[!RS6000_BI_ARCH] (TARGET_RELOCATABLE, TARGET_EABI,
	TARGET_PROTOTYPE): Define to 0.
	(NO_PROFILE_COUNTERS): Define to TARGET_64BIT.
	(PROFILE_HOOK): Only call output_profile_hook if TARGET_64BIT.
	(ADJUST_FIELD_ALIGN, ROUND_TYPE_ALIGN): Adjust to work properly
	if !TARGET_64BIT.
	(USER_LABEL_PREFIX): Remove.
	(JUMP_TABLES_IN_TEXT_SECTION): Define to TARGET_64BIT.
	(SETUP_FRAME_ADDRESSES): Only call rs6000_aix_emit_builtin_unwind_init
	if TARGET_64BIT.
	(TARGET_OS_CPP_BUILTINS): Handle both -m32 and -m64.
	(LINK_OS_LINUX_SPEC32, LINK_OS_LINUX_SPEC64): Define.
	(STARTFILE_LINUX_SPEC, ENDFILE_LINUX_SPEC): Remove.
	(TOC_SECTION_ASM_OP): Define depending on TARGET_64BIT.
	(MINIMAL_TOC_SECTION_ASM_OP): Likewise.
	(SIZE_TYPE, PTRDIFF_TYPE, WCHAR_TYPE): Define depending on
	TARGET_64BIT.
	(RS6000_CALL_GLUE): Likewise.
	(SAVE_FP_PREFIX, SAVE_FP_SUFFIX, RESTORE_FP_PREFIX,
	RESTORE_FP_SUFFIX): Likewise.
	(ASM_DECLARE_FUNCTION_NAME): Remove.
	(ASM_DECLARE_FUNCTION_SIZE, ASM_OUTPUT_SOURCE_LINE,
	DBX_OUTPUT_BRAC, DBX_OUTPUT_NFUN): Only output dot before function
	name if TARGET_64BIT.
	(ASM_OUTPUT_SPECIAL_POOL_ENTRY_P): Handle both TARGET_64BIT and
	!TARGET_64BIT.
	(ASM_OUTPUT_REG_PUSH, ASM_OUTPUT_REG_POP): Remove undefs.
	(ASM_PREFERRED_EH_DATA_FORMAT): Take TARGET_64BIT into account.
	(DRAFT_V4_STRUCT_RET): Define.
	(SIGNAL_FRAMESIZE): New enum value.
	(MD_FALLBACK_FRAME_STATE_FOR): Define.
	* config/rs6000/default64.h: New file.
	* config/rs6000/sysv4.h (SUBTARGET_SWITCHES): Add -m32 and -m64
	options.
	(SUBTARGET_OVERRIDE_OPTIONS): If rs6000_abi_name is NULL, set it
	to RS6000_ABI_NAME.  Only disallow mixing of -fPIC with -mcall-aixdesc
	if !TARGET_64BIT.
	[!RS6000_BI_ARCH] (SUBSUBTARGET_OVERRIDE_OPTIONS): Define.
	(ASM_DECLARE_FUNCTION_NAME): Use rs6000_elf_declare_function_name
	function.
	(TARGET_OS_SYSV_CPP_BUILTINS): Define.
	(TARGET_OS_CPP_BUILTINS): Use it.
	(CPP_SYSV_SPEC): Remove.
	(CPP_SPEC): Remove cpp_sysv.
	(SUBTARGET_EXTRA_SPECS): Remove cpp_sysv.
	Add SUBSUBTARGET_EXTRA_SPECS.
	(SUBSUBTARGET_EXTRA_SPECS): Define.
	* config/rs6000/biarch64.h: New file.
	* config/rs6000/rs6000-protos.h (rs6000_elf_declare_function_name):
	New prototype.
	* config/rs6000/x-linux64: New file.
	* config/rs6000/t-linux64: Build -m64, -m32 and -m32 -msoft-float
	multilibs.
	* config/rs6000/eabi-ci.asm: Protect with #ifndef __powerpc64__.
	* config/rs6000/eabi-cn.asm: Likewise.
	* config/rs6000/tramp.asm: Likewise.
	* config/rs6000/sol-ci.asm: Likewise.
	* config/rs6000/sol-cn.asm: Likewise.
	* config/rs6000/linux.h (TARGET_64BIT): Define to 0.
	(TARGET_OS_CPP_BUILTINS): Use TARGET_OS_SYSV_CPP_BUILTINS.
	* config/rs6000/ppc-asm.h: Move __powerpc64__ section before
	_CALL_AIXDESC section.
	* config.gcc (powerpc64-*-linux*): Configure a bi-arch compiler,
	defaulting to -m64 unless --with-cpu= is one of the 32-bit CPUs
	or default32.

2003-06-04  Daniel Jacobowitz  <drow@mvista.com>

	* config.gcc: Revert accidentally committed ARM changes.

2003-06-04  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (dconstpi, dconste): New mathematical constants.
	(init_builtin_dconsts): New function to initialize dconstpi
	and dconste.
	(fold_builtin): Optimize exp(1.0) = e.  Evaluate exp(x) at
	compile time with -ffast-math when x is an integer constant.
	Optimize tan(0.0) = 0.0.  Optimize atan(0.0) = 0.0,
	atan(1.0) = pi/4 and tan(atan(x)) = x with -ffast-math.

2003-06-04  Roger Sayle  <roger@eyesopen.com>

	* calls.c (expand_call): Avoid calling pure or const functions
	when the result is ignored (or void) and none of the arguments
	are volatile.  Move warning diagnostic earlier in function.

2003-06-04  Andreas Jaeger  <aj@suse.de>

	* system.h: Do not poison TDESC_SECTION_ASM_OP,
	RDATA_SECTION_ASM_OP and SUBTARGET_PROLOGUE.

2003-06-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* final.c (asm_fprintf): Update comments, accept "-+ #0" flags,
	optimize '%' case, handle %c, don't accept %p, %e, %f or %g,
	handle %ll, optimize regular character case.

2003-06-04  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* Makefile.in (cse.o): Add params.h dependency.
	* cse.c: Include params.h.
	(PATHLENGTH): Removed.
	(struct cse_basic_block_data): Make path array dynamic.
	(cse_end_of_basic_block): Use PARAM_MAX_CSE_PATH_LENGTH instead
	of PATHLENGTH.
	(cse_main, cse_basic_block): Allocate path array.
	* params.def (PARAM_MAX_CSE_PATH_LENGTH): New.

Wed Jun  4 09:49:21 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_reorg): Replace the jump instead of adding nop.
	* i386.md (UNSPEC_REP): New constant.
	(return_internal_long): New pattern.

2003-06-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/11018
	* config/sparc/sparc.c (sparc_v8plus_shift): Use which_alternative
	consistently to decide whether the scratch register is really
	required.

2003-06-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/10876
	* config/sparc/sparc.h (CONST_OK_FOR_LETTER): Add
	new 'O' constraint for constant 4096.
	(CONST_DOUBLE_OK_FOR_LETTER_P): Likewise.
	* config/sparc/sparc.md (adddi3 expander): Canonicalize pattern.
	Do not transform into MINUS insn for constant 4096.
	(*adddi3_sp64 insn): Canonicalize pattern. Add new alternative
	for constant 4096 as third operand.
	(addsi3 expander): Remove.
	(*addsi3 insn): Rename into 'addsi3'. Canonicalize pattern. Add
	new alternative for constant 4096 as third operand.
	(subdi3 expander): Do not transform into PLUS insn for constant 4096.
	(*subdi3_sp64 insn): Add new alternative for constant 4096 as third
	operand.
	(subsi3 expander): Remove.
	(*subsi3 insn): Rename into 'subsi3'. Add new alternative for
	constant 4096 as third operand.
	* doc/md.texi (Machine Constraints): Document new 'O' constraint for
	the SPARC port.

2003-06-03  Chris Demetriou  <cgd@broadcom.com>

	* config/mips/t-linux64 (CRTSTUFF_T_CFLAGS_S): Define.

2003-06-04  Andreas Jaeger  <aj@suse.de>

	* config/i386/uwin.h: Remove SUBTARGET_PROLOGUE.

	* config/i386/i386.c (ix86_expand_prologue): Do not use
	SUBTARGET_PROLOGUE.

	* system.h: Poision SUBTARGET_PROLOGUE.

	* config/arm/arm-protos.h: Remove unused rdate_section prototype.

	* output.h: Remove TDESC_SECTION_ASM_OP and RDATA_SECTION_ASM_OP
	dependend code.

	* system.h: Poison TDESC_SECTION_ASM_OP and RDATA_SECTION_ASM_OP.

	* system.h: Poison INSN_CACHE_DEPTH, INSN_CACHE_SIZE and
	INSN_CACHE_LINE_WIDTH.

	* libgcc2.c (INSN_CACHE_PLANE_SIZE): Removed.
	(__clear_cache): Remove code dependend on INSN_CACHE_DEPTH,
	INSN_CACHE_SIZE and INSN_CACHE_LINE_WIDTH.

	* doc/tm.texi (Trampolines): Remove INSN_CACHE_DEPTH,
	INSN_CACHE_SIZE and INSN_CACHE_LINE_WIDTH.

	* dbxout.c (dbxout_type): Remove usage of DBX_OUTPUT_ENUM.
	(dbxout_symbol): Remove usage of DBX_OUTPUT_CONSTANT_SYMBOL.
	(dbxout_block): Remove usage of DBX_OUTPUT_CATCH.
	(dbxout_block): Remove usage of DBX_LBRAC_FIRST.
	(dbxout_source_file): Remove usage of DBX_OUTPUT_SOURCE_FILENAME.
	(dbxout_init): Remove test for DBX_WORKING_DIRECTORY.

	* doc/tm.texi (DBX Options): Do not document DBX_LBRAC_FIRST,
	DBX_OUTPUT_SOURCE_FILENAME and DBX_OUTPUT_ENUM and
	DBX_WORKING_DIRECTORY.

	* system.h: Poison DBX_LBRAC_FIRST, DBX_OUTPUT_ENUM,
	DBX_OUTPUT_SOURCE_FILENAME and DBX_WORKING_DIRECTORY.

	* config/frv/frv-protos.h: Remove unused const_section
	declaration.
	* config/vax/vax-protos.h: Likewise.

	* output.h: Remove CONST_SECTION_ASM_OP usage.

	* system.h: Poison CONST_SECTION_ASM_OP.

	* crtstuff.c (__do_global_dtors_aux): Remove usage of
	CRT_GET_RFIB_TEXT.
	(frame_dummy): Likewise.
	* unwind-dw2-fde-glibc.c (_Unwind_IteratePhdrCallback): Likewise.
	* system.h: Poison CRT_GET_RFIB_TEXT.

	* collect2.c (is_ctor_dtor): Remove CFRONT_LOSSAGE dependend code.

	* fix-header.c: Remove ADD_MISSING_EXTERN_C dependend variables.
	(write_lbrac): Remove ADD_MISSING_EXTERN_C dependend code.
	(recognized_function): Likewise.
	(read_scan_file): Likewise.

2003-06-03  Roger Sayle  <roger@eyesopen.com>

	* optabs.c (expand_binop): Optimize complex multiplication for
	the case of squaring a complex argument.

2003-06-03  Roger Sayle  <roger@eyesopen.com>

	* optabs.c (expand_binop): Attempt to reuse pseudos for duplicate
	non-volatile operands of binary operations.
	(prepare_cmp_insn): Likewise.

2003-06-03  Roger Sayle  <roger@eyesopen.com>

	* varasm.c (force_const_mem): Handle alignment of constants not
	representable as a type in the front-end language.

2003-06-03  Kazu Hirata  <kazu@cs.umass.edu>

	* flow.c (initialize_uninitialized_subregs): Use
	emit_move_insn instead of emitting a hardcoded move.

2003-06-03  Richard Henderson  <rth@redhat.com>

	* optabs.c (expand_abs_nojump): Split out from ...
	(expand_abs): ... here.
	* optabs.h (expand_abs_nojump): Declare.
	* ifcvt.c: (noce_try_abs): Use expand_abs_nojump.
	* Makefile.in (ifcvt.o): Depend on optabs.h.

2003-06-03  Alan Modra  <amodra@bigpond.net.au>

	* dwarf2out.c (DEBUG_STR_SECTION_FLAGS): Heed flag_merge_constants.

2003-06-03  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (default_use_cxa_atexit): New variable, defaults to no.
	(*-*-netbsd[2-9]* | *-*-netbsdelf[2-9]*): Set default_use_cxa_atexit
	to yes.
	* configure.in: Allow default_use_cxa_atexit to determine the
	value of DEFAULT_USE_CXA_ATEXIT if not explicitly enabled or
	disabled.
	* configure: Regenerate.

2003-06-03  Douglas B Rupp  <rupp@gnat.com>

	* Makefile.in (TEXI_GCC_FILES): Remove vms.texi entry.
	* doc/gcc.texi: Remove vms.texi section.
	* doc/vms.texi: Remove obsolete file.

2003-05-23  J"orn Rennecke <joern.rennecke@superh.com>

	* configure.in (inhibit_libc): Don't define when configuring
	with --with-newlib --with-headers.
	* configure: Regenerate.

	* t-sh: Remove LIB2FUNCS_EXTRA and embed-bb.c rules.

2003-06-03  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* configure.in (gcc_cv_as_hidden): Disable .hidden completely on
	IRIX 6 without GNU ld.
	* configure: Regenerate.

2003-06-03  Roger Sayle  <roger@eyesopen.com>

	* expr.c (emit_move_insn_1): Use emit_move_insn to move the parts
	of a complex number rather than invoke mov_optab directly.

2003-06-03  Kazu Hirata  <kazu@cs.umass.edu>

	* combine.c (simplify_set): Don't move a subreg in SET_SRC to
	SET_DEST if WORD_REGISTER_OPERATIONS is not defined.

2003-06-03  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/i386/x86-64.h: Remove two target-independent comments;
	 replace "GNU CC" with "GCC".

2003-06-03  Anthony Green  <green@redhat.com>

	* config/frv/t-frv (EXTRA_HEADERS): Remove media.h

2003-06-03  Roger Sayle  <roger@eyesopen.com>

	* builtins.def (BUILT_IN_CABS, BUILT_IN_CABSF, BUILT_IN_CABSL):
	New builtins representing ISO C99's cabs, cabsf and cabsl.
	* builtins.c (expand_builtin_fabs): New function.
	(expand_builtin_cabs): New function.
	(expand_builtin): Expand BUILT_IN_FABS{,F,L} and BUILT_IN_CABS{,F,L}
	using expand_builtin_fabs and expand_builtin_cabs respectively.

	* doc/extend.texi: Document new cabs, cabsf and cabsl builtins.

2003-06-03  Aldy Hernandez  <aldyh@redhat.com>

	* function.c (assign_parms): Split complex arguments.

	* doc/tm.texi (SPLIT_COMPLEX_ARGS): Document.

	* expr.h (SPLIT_COMPLEX_ARGS): Define.
	(split_complex_types): Protoize.
	(split_complex_values): Protoize.

	* calls.c (expand_call): Split complex arguments on architectures
	that require it.
	(split_complex_values): New.
	(split_complex_types): New.

	* config/rs6000/rs6000.c (rs6000_libcall_value): New.
	(rs6000_function_value): Handle complex values on AIX.
	(rs6000_complex_function_value): New.

	* config/rs6000/rs6000-protos.h (rs6000_libcall_value): Protoize.

	* config/rs6000/rs6000.h (LIBCALL_VALUE): Call function.
	(SPLIT_COMPLEX_ARGS): New.

2003-06-03  Jakub Jelinek  <jakub@redhat.com>

	* configure.in (HAVE_LD_PIE): Check for ld -pie.
	* config.in: Rebuilt.
	* configure: Rebuilt.
	* toplev.c (flag_pie, flag_shlib): New variables.
	(f_options): Add -fpie and -fPIE.
	(parse_options_and_default_flags): Set flag_pic if -fpie/-fPIE.
	Set flag_shlib if flag_pic and not -fpie/-fPIE.
	* flags.h (flag_pic, flag_shlib): Add.
	* varasm.c (default_binds_local_p): Use flag_shlib instead of
	flag_pic.
	* gcc.c (LINK_PIE_SPEC): Define.
	(LINK_COMMAND_SPEC): Use LINK_PIE_SPEC.
	(option_map): Add --pie -> -pie mapping.
	* config/sol2.h (ASM_SPEC): Handle -fpie the same way as -fpic
	and -fPIE the same way as -fPIC.
	* config/openbsd.h (ASM_SPEC): Likewise.
	* config/frv/frv.h (ASM_SPEC): Likewise.
	* config/arm/linux-gas.h (SUBTARGET_CPP_SPEC): Likewise.
	* config/arm/semi.h (ASM_SPEC): Likewise.
	* config/arm/netbsd-elf.h (SUBTARGET_EXTRA_ASM_SPEC): Likewise.
	* config/freebsd-spec.h (FBSD_CPP_SPEC): Likewise.
	* config/i386/beos-elf.h (CC1_SPEC): Likewise.
	* config/i386/freebsd-aout.h (ASM_SPEC): Likewise.
	* config/m68k/linux.h (CPP_SPEC): Likewise.
	* config/m68k/netbsd.h (ASM_SPEC): Likewise.
	* config/m68k/openbsd.h (ASM_SPEC): Likewise.
	* config/m68k/netbsd-elf.h (ASM_SPEC): Likewise.
	* config/mips/linux.h (SUBTARGET_CPP_SPEC): Likewise.
	* config/mips/openbsd.h (SUBTARGET_ASM_SPEC): Likewise.
	* config/pa/pa-linux.h (CPP_SPEC): Likewise.
	* config/netbsd-aout.h (ASM_SPEC): Likewise.
	* config/rs6000/sysv4.h (ASM_SPEC, CPP_SYSV_SPEC): Likewise.
	* config/rs6000/vxworks.h (CPP_SPEC): Likewise.
	* config/sparc/linux.h (CPP_SUBTARGET_SPEC, ASM_SPEC): Likewise.
	* config/sparc/linux64.h (CPP_SUBTARGET_SPEC, ASM_SPEC): Likewise.
	* config/sparc/sparc.h (ASM_SPEC): Likewise.
	* config/sparc/sp64-elf.h (ASM_SPEC): Likewise.
	* config/sparc/sysv4.h (ASM_SPEC): Likewise.
	* config/sparc/netbsd-elf.h (ASM_SPEC): Likewise.
	* config/sparc/openbsd64.h (ASM_SPEC): Likewise.
	* config/cris/linux.h (CRIS_ASM_SUBTARGET_SPEC): Likewise.
	* config/linux.h (STARTFILE_SPEC, ENDFILE_SPEC): Handle -pie.
	Simplify.
	* config/alpha/elf.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* config/i386/linux64.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* config/ia64/linux.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* config/rs6000/sysv4.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* config/rs6000/linux64.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* config/sparc/linux.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* config/sparc/linux64.h (STARTFILE_SPEC, ENDFILE_SPEC): Likewise.
	* doc/invoke.texi: Document -pie, -fpie and -fPIE options.

2003-06-03  Jakub Jelinek  <jakub@redhat.com>

	* builtins.c (expand_builtin_memcpy): Remove endp argument and endp
	!= 0 handling.  Pass 0 to store_by_pieces.
	(expand_builtin_mempcpy): Add endp argument.  Don't call
	expand_builtin_memcpy, call store_by_pieces resp. move_by_pieces
	directly.  If ignoring result, only do expand_call.
	(expand_builtin_stpcpy): Likewise.  Call expand_builtin_mempcpy
	otherwise.
	(expand_builtin_strncpy, expand_builtin_memset): Adjust
	store_by_pices callers.
	(expand_builtin): Adjust expand_builtin_memcpy and
	expand_builtin_mempcpy callers.
	* expr.c (can_move_by_pieces): New function.
	(move_by_pieces): Add endp argument, return to resp. memory at end
	or one byte earlier depending on endp.
	(store_by_pieces): Likewise.
	(emit_block_move): Adjust call to move_by_pieces.
	(emit_push_insn): Adjust move_by_pieces caller.
	* expr.h (can_move_by_pieces): New prototype.
	(store_by_pieces): Adjust prototypes.
	* rtl.h (move_by_pieces): Adjust prototype.
	* config/mips/mips.c (expand_block_move): Adjust move_by_pieces
	caller.

2003-06-03  Ben Elliston  <bje@wasabisystems.com>

	* doc/md.texi (Processor pipeline description): Improve wording.

2003-06-03  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (c_common_handle_option): New, pulled out of
	c_common_decode_option.  Substitute uses of argv.
	(c_common_decode_option): Broken into two.

2003-06-02  Roger Sayle  <roger@eyesopen.com>
	    Zack Weinberg  <zack@codesourcery.com>

	* emit-rtl.c (gen_complex_constant_part):  Remove unnecessary
	test of TREE_CONSTANT_POOL_ADDRESS_P.

2003-06-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips.c: Don't include output.h twice.
	* stormy16.c: Likewise.
	* xtensa.c: Likewise.
	* output.h: Protect against multiple inclusion.

2003-06-02  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (OLD_ARG_MODE): New macro.
	(FUNCTION_ARG_ADVANCE, FUNCTION_ARG_PASS_BY_REFERENCE): Use it.
	(FUNCTION_ARG_1): Break out of:
	(FUNCTION_ARG).  Use OLD_ARG_MODE.

2003-06-02  Kazuhiro Inaoka  <inaoka.kazuhiro@renesas.com>

	* gcc/config.gcc Add support multilib parts for m32rx processor.

2003-06-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Makefile.in (c-options.c): Pass in $(AWK) to opts.sh.
	(mostlyclean): Delete c-options.c and c-options.h.

2003-06-02  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (CL_REJECT_NEGATIVE): New.
	(c_common_decode_option): Update to use it.
	* c.opt: Update documentation; use RejectNegative.
	* opts.sh: Handle RejectNegative.

2003-06-01  Zack Weinberg  <zack@codesourcery.com>

	* ggc-page.c (init_ggc): Give better diagnostics on failure to
	open /dev/zero.
	* toplev.c (crash_signal): Reset handling for received signal
	to SIG_DFL.

2003-06-02  Ben Elliston  <bje@wasabisystems.com>

	* config/arm/arm.c (arm_use_dfa_pipeline_interface): Declare.
	(TARGET_SCHED_USE_DFA_PIPELINE_INTERFACE): Define if not already.
	(arm_use_dfa_pipeline_interface): Implement.
	* config/arm/arm.md (arm): New automaton.
	(write_buf): Remove function units; new cpu unit.
	(write_blockage): Remove function units; new cpu unit.
	(core): Remove function units; new cpu unit.
	(r_mem_f_wbuf): New instruction reservation.
	(store1_wbuf, store2_wbuf, store3_wbuf, store4_wbuf): Likewise.
	(store1_ldsched, store2, store3, store4): Likewise.
	(load_ldsched, load_ldsched_xscale, load_or_store): Likewise.
	(mult, mult_ldsched, mult_ldsched_strongarm): Likewise.
	(multi_cycle, single_cycle): Likewise.
	* config/arm/fpa.md (armfp): New automaton.
	(fpa): Remove function units; new cpu unit.
	(fpa_mem): Remove function unit; new cpu unit.
	(fdivx, fdivd, fdivs, fmul, ffmul, farith, ffarith): New reservations.
	(r_2_f, f_2_r, f_load, f_store, r_mem_f, f_mem_r): Likewise.

2003-06-01  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtin-attrs.def (ATTR_ASM_FPRINTF): New.
	* c-format.c (enum format_type): Add asm_fprintf_format_type.
	(NOARGUMENTS, asm_fprintf_length_specs, asm_fprintf_flag_specs,
	asm_fprintf_flag_pairs, asm_fprintf_char_table): New.
	(format_types_orig): Renamed from format_types.  Add new data.
	(format_types): Declare as pointer.
	(handle_format_attribute): Move later in file so we have all
	necessary declarations.  Add section to capture HOST_WIDE_INT.
	* output.h (ATTRIBUTE_ASM_FPRINTF, __gcc_host_wide_int__): New.
	(asm_fprintf): Mark with ATTRIBUTE_ASM_FPRINTF.

2003-06-01  Andreas Jaeger  <aj@suse.de>

	* doc/tm.texi (Storage Layout): Remove ROUND_TYPE_SIZE and
	ROUND_TYPE_SIZE_UNIT.

	* stor-layout.c (finalize_record_size): Remove usages of
	ROUND_TYPE_SIZE and ROUND_TYPE_SIZE_UNIT.
	(finalize_type_size): Likewise.
	(layout_type): Likewise.

	* system.h: Poison ROUND_TYPE_SIZE and ROUND_TYPE_SIZE_UNIT.

	* loop.c (check_insn_for_givs): Remove DONT_REDUCE_ADDR macro.

	* config/d30v/d30v.h: Remove text copied from the manual.

2003-06-01  Roger Sayle  <roger@eyesopen.com>
	    John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>
	    Geoffrey Keating  <geoffk@apple.com>

	* emit-rtl.c (gen_lowpart_common): Handle interpreting integer
	constants as condition code values.

2003-06-01  DJ Delorie  <dj@redhat.com>

	* cppmacro.c (warn_of_redefinition): Handle cases where the two
	definitions have different numbers of tokens.

2003-06-01  Andreas Jaeger  <aj@suse.de>

	* gen-protos.c (main): Readd unused attribute for argc.

2003-06-01  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in (c-options.c, c-options.h): Parallel make safe.
	* c.opt: End in blank line.
	* opts.sh: Take AWK from environment if available; use C locale.

2003-06-01  Andreas Schwab  <schwab@suse.de>

	* config/m68k/linux.h: Remove code protected by USE_GNULIBC_1.

2003-06-01  Andreas Jaeger  <aj@suse.de>

	* gen-protos.c (main): Revert patch to check for argument.

2003-06-01  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/11044
	* config/i386/i386.md (length attribute): Set length to 4
	for instructions of type "fcmp".

2003-06-01  Andreas Jaeger  <aj@suse.de>

	* toplev.c: Use ISO C90 prototypes.

	* toplev.h: Use ISO C90 prototypes.

	* genrecog.c: Use ISO C90 prototypes.
	(nodes_identical): Correct declaration to match prototype.
	(maybe_both_true): Likewise.
	(merge_trees): Likewise.

	* genpeep.c (gen_peephole): Remove #if 0 code.
	Use ISO C90 prototypes.

	* genattrtab.c (copy_rtx_unchanging): Remove #if 0'ed code.
	Remove #if 0'ed function simplify_by_alternatives.
	(optimize_attrs): Remove #if 0'ed code.
	Remove ^L.
	Use ISO C90 prototypes.
	(make_canonical): Remove #if 0'ed code.
	(convert_const_symbol_ref): Remove #if 0'ed function.

	* gen-protos.c (main): Check for argument.

	* rtl.h: Use ISO C90 prototypes for functions from lists.c.

	* params.h: Use ISO C90 prototypes.
	* params.c: Likewise.
	* intl.c: Likewise.
	* intl.h: Likewise.
	* lists.c: Likewise.
	* errors.c: Likewise.
	* errors.h: Likewise.
	* gencodes.c: Likewise.
	* genpreds.c: Likewise.
	* genattr.c: Likewise.
	* gen-protos.c: Likewise.
	* genflags.c: Likewise
	* genconditions.c: Likewise.
	* genautomata.c: Likewise.
	* gencheck.c: Likewise.
	* genconfig.c: Likewise.
	* genconstants.c: Likewise.
	* genemit.c: Likewise.
	* genextract.c: Likewise.
	* gengenrtl.c: Likewise.
	* gengtype.c: Likewise.
	* gengtype.h: Likewise.
	* genopinit.c: Likewise.
	* genoutput.c: Likewise.
	* gensupport.c: Likewise.
	* gensupport.h: Likewise.

	* sdbout.h: Use ISO C90 prototypes.

	* sdbout.c (CONTIN): Removed empty macro.
	(sdbout_one_type): Remove CONTIN usages.
	Remove ^Ls.
	(tag_of_ru_type): Remove #if 0'ed function.
	(sdbout_symbol): Remove #if 0'ed code.
	(sdbout_one_type): Remove a #if 1.
	(sdbout_one_type): Remove #if 0'ed code.
	(sdbout_init): Remove RMS_QUICK_HACK_1 code.
	Remove PARAMS, use ISO C90 prototypes for all functions.

2003-06-01  Josef Zlomek  <zlomekj@suse.cz>

	* rtl.def (CONST_DOUBLE): Update comment.

2003-06-01  Neil Booth  <neil@daikokuya.co.uk>

	* opts.sh: Remove path from sort.

2003-06-01  Aldy Hernandez  <aldyh@redhat.com>

	PR/9680
	* config/rs6000/rs6000.h (CANNOT_CHANGE_MODE_CLASS): Require
	TARGET_SPE for SPE_VECTOR_MODE.

2003-05-31  Aldy Hernandez  <aldyh@redhat.com>

	* toplev.c (botch): Remove.
	(do_abort): Remove.
	(set_Wunused): Comment.
	(set_Wextra): Comment.
	Remove ^L's.
	(rest_of_compilation): Factor out common code into functions.
	(rest_of_handle_inlining): New.
	(rest_of_handle_ssa): New.
	(rest_of_handle_cse): New.
	(rest_of_handle_gcse): New.
	(rest_of_handle_loop_optimize): New.
	(rest_of_handle_jump_bypass): New.
	(rest_of_handle_sibling_calls): New.
	(rest_of_handle_null_pointer): New.
	(rest_of_handle_addresof): New.
	(rest_of_handle_flow): New.
	(rest_of_handle_branch_prob): New.
	(rest_of_handle_if_conversion): New.
	(rest_of_handle_tracer): New.
	(rest_of_handle_loop2): New.
	(rest_of_handle_cse2): New.
	(rest_of_handle_life): New.
	(rest_of_handle_combine): New.
	(rest_of_handle_if_after_combine): New.
	(rest_of_handle_regmove): New.
	(rest_of_handle_sched): New.
	(rest_of_handle_old_regalloc): New.
	(rest_of_handle_new_regalloc): New.
	(rest_of_handle_regrename): New.
	(rest_of_handle_reorder_blocks): New.
	(rest_of_handle_sched2): New.
	(rest_of_handle_new_regalloc): New.
	(rest_of_handle_old_regalloc): New.
	(rest_of_handle_regrename): New.
	(rest_of_handle_reorder_blocks): New.
	(rest_of_handle_stack_regs): New.
	(rest_of_handle_machine_reorg): New.
	(rest_of_handle_delay_slots): New.
	(rest_of_handle_final): New.

	* toplev.h (botch): Remove prototype.
	(do_abort): Same.

2003-05-31  Neil Booth  <neil@daikokuya.co.uk>

	* Makefile.in (c-opts.o, c-options.h): Update dependencies.
	* c-opts.c: Include c-options.h and c-options.c.
	(CL_C_ONLY, CL_OBJC_ONLY, CL_CXX_ONLY, CL_OBJCXX_ONLY):
	Rename CL_C, CL_OBJC, CL_CXX, CL_OBJCXX.
	(CL_ARG, CL_ALL, COMMAND_LINE_OPTIONS, struct cl_option,
	OPT, opt_comp): Remove.
	(missing_arg, c_common_init_options, c_common_decode_option,
	write_langs): Update for macro redefinitions and enumeration
	name changes.
	* c.opt, opts.sh: New files.
	* doc/passes.texi: Update.

2003-05-31  Andreas Jaeger  <aj@suse.de>

	* function.c (trampoline_address): Remove ALLOCATE_TRAMPOLINE
	usage.

	* doc/tm.texi (Trampolines): Remove ALLOCATE_TRAMPOLINE.

	* config/d30v/d30v.h: Remove traces of ALLOCATE_TRAMPOLINE.

	* system.h: Poison ALLOCATE_TRAMPOLINE.

	* doc/tm.texi (Misc): Remove HANDLE_PRAGMA.
	* system.h: Poison HANDLE_PRAGMA.

2003-05-31  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Update dump file names.

2003-05-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-format.c (format_length_info, format_char_info,
	format_flag_spec, format_flag_pair, format_kind_info):
	De-const-ify structure members.

2003-05-31  Roger Sayle  <roger@eyesopen.com>

	* flags.h (flag_wrapv): New flag controlling overflow semantics.
	* toplev.c (flag_wrapv): Declare the variable with default false.
	(lang_independent_options): New option "-fwrapv" to set the above.

	* fold-const.c (extract_muldiv_1): Disable optimization of (2*x)/2
	as x, when signed arithmetic overflow wraps around.
	(fold): Optimize "-A - B" as "-B - A" if overflow wraps around.
	* loop.c (basic_induction_var): Ignore BIVs that rely on undefined
	overflow when flag_wrapv is true.

	* doc/invoke.texi: Document new -fwrapv command line option.
	* doc/c-tree.texi: Mention that the overflow semantics of
	NEGATE_EXPR, PLUS_EXPR, MINUS_EXPR and MULT_EXPR is dependent
	upon both flag_wrapv and flag_trapv.

2003-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi (mips-sgi-irix5): Add missing
	HTML <hr> marker.

2003-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/md.texi (Machine Constraints): Document
	missing SPARC constraints.

2003-05-31  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/md.texi (Automaton pipeline description): Use
	"type" instead of "cpu" as the attribute in the examples.

2003-05-30  Stan Shebs  <shebs@apple.com>

	* system.h: Poison OBJC_PROLOGUE.

2003-05-30  Roger Sayle  <roger@eyesopen.com>

	* emit-rtl.c (gen_complex_constant_part): New function for getting
	the constant real or imaginary part of a complex constant.
	(gen_realpart): Use it.
	(gen_imagpart): Likewise.

2003-05-30  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Fix typos.
	* doc/rtl.texi: Likewise.

2003-05-30  Dhananjay Deshpande  <dhananjayd@kpitcummins.com>

	* config/h8300/crti.asm: Use .h8300hn and .h8300sn for normal
	mode.
	* config/h8300/crtn.asm: Likewise.
	* config/h8300/lib1funcs.asm: Likewise.
	* config/h8300/h8300.c (asm_file_start): Likewise.
	* config/h8300/elf.h (LINK_SPEC): Use h8300hnelf and
	h8300snelf emulations for normal mode.
	* config/h8300/h8300.h (LINK_SPEC): Use h8300hn and h8300sn
	emulations for normal mode.

2003-05-30  Dhananjay Deshpande  <dhananjayd@kpitcummins.com>

	* config/h8300/h8300.c (h8300_tiny_constant_address_p): Return
	true if TARGET_NORMAL_MODE.

2003-05-30  Roger Sayle  <roger@eyesopen.com>

	* cse.c (cse_insn): Simplify REG_EQUAL note on libcalls when
	making a substitution.
	(dead_libcall_p): If directly replacing a libcall with a
	constant value produces an invalid instruction, also try forcing
	the constant into the constant pool.
	* expr.c (emit_move_insn): Add a REG_EQUAL note when it is not
	obvious that the source is a constant.
	(compress_float_constant): Use set_unique_reg_note to place
	REG_EQUAL notes on instructions.

2003-05-30  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.c (extern_list): Add GTY marker.
	(extern_head): Separate out definition. Add marker.
	(mips_output_external): Use ggc_alloc for extern_list
	allocation.
	(mips_output_external_libcall): Ditto.

2003-05-30  Florian Weimer  <fw@deneb.enyo.de>

	* doc/install.texi: Ada-enabled bootstrap requires GNAT 3.14 or
	later.

2003-05-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* vax.h (ASM_GENERATE_INTERNAL_LABEL): Fix format specifier
	warnings.
	(PRINT_OPERAND): Likewise.

2003-05-30  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/mips.h (SUBTARGET_ASM_DEBUGGING_SPEC): Move
	-mdebug/-no-mdebug switches ...
	(MDEBUG_ASM_SPEC): ... here.
	Use only with gas.
	(EXTRA_SPECS): Initialize mdebug_asm_spec.

2003-05-29  Matt Kraai  <kraai@alumni.cmu.edu>

	* gthr-gnat.c: Remove #undef UNUSED.
	(__gnat_default_lock, __gnat_default_unlock): Prototype.
	(__gnat_task_lock, __gnat_task_unlock): Make declarations
	prototypes.
	(__gnat_install_locks): Convert declaration to ISO C90, make
	parameter declarations prototypes, and remove blank line.
	* gthr-gnat.h (__gnat_install_locks): Make parameter
	declarations prototypes.

2003-05-29  Jason Merrill  <jason@redhat.com>

	* Makefile.in (unstrap): Remove stage_last after make unstage1.

2003-05-29  Roger Sayle  <roger@eyesopen.com>

	* mips-tfile.c (PAGE_SIZE): Increase page size to 32K.

2003-05-29  Roger Sayle  <roger@eyesopen.com>
	    Kaveh Ghazi  <ghazi@caip.rutgers.edu>

	PR bootstrap/10169
	* mips-tfile.c (main): Use getopt_long instead of getopt.
	Add new command line option --version to display version.
	Treat --verbose like -v to report a single line version.
	(options): New global variable for getopt_long.
	* mips-tdump.c (main): Use getopt_long instead of getopt.
	New command line options -v, --version and -verbose to display
	the program version number (to match mips-tfile's behavior).
	(options): New global variable for getopt_long.

	* gcov.c (options): Zero-terminate getopt_long array.
	* gcov-dump.c (options): Likewise.

	* Makefile.in (mips-tdump.o): Add dependency on version.h.

2003-05-29  Stan Shebs  <shebs@apple.com>

	Remove OBJC_PROLOGUE everywhere.
	* objc/objc-act.c (finish_objc): Remove use of OBJC_PROLOGUE.
	* config/avr/avr.h: Remove no-op ref to OBJC_PROLOGUE.
	* config/d30v/d30v.h: Similarly.
	* config/ip2k/ip2k.h: Similarly.
	* doc/tm.texi: Remove doc of OBJC_PROLOGUE.

2003-05-29  Roger Sayle  <roger@eyesopen.com>

	* c-semantics.c (genrtl_do_stmt_1): New function split out from...
	(gen_rtl_do_stmt): ... here.  Call genrtl_do_stmt_1.
	(expand_unreachable_stmt): Expand unreachable while statements
	using genrtl_do_stmt_1.

2003-05-29  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (mips_output_load_label): Declare.
	* config/mips/mips.c (mips_output_load_label): New function.
	(mips_output_conditional_branch): Use it.
	* config/mips/mips.md (jump): And here.

2003-05-28  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa-protos.h (smalloffset_double_mem_p): Delete.
	(xtensa_split_operand_pair): New proto.
	* config/xtensa/xtensa.c (move_operand): Handle DFmode and DImode.
	(smalloffset_double_mem_p): Delete.
	(gen_float_relational, printx, print_operand, xtensa_va_arg):
	Fix whitespace.
	(xtensa_split_operand_pair): New.
	(xtensa_dbx_register_number): Fix formatting.
	* config/xtensa/xtensa.h (EXTRA_CONSTRAINT): Remove 'S' constraint.
	* config/xtensa/xtensa.md (movdi, movdf): Force constants to memory
	instead of splitting them into single-word moves.  Remove unnecessary
	checks for reload_in_progress and reload_completed.
	(movdi_internal, movdf_internal): Change to post-reload split patterns.
	Add constraints to allow constant operands.
	(movsf_internal): Allow CONST_INT operands.

2003-05-27  Danny Smith   <dannysmith@users.sourceforge.net>

	* config.gcc (i[34567]86-*-mingw32*): Add host makefile
	fragment i386/x-mingw32.
	* config/i386/x-mingw32: New file. Make local_includedir
	relative to EXEC_PREFIX.

2003-05-27  Aaron W. LaFramboise  <awlaframboise@aol.com>

	* config/i386/mingw32.h (STANDARD_INCLUDE_DIR): Update.
	(MD_STARTFILE_PREFIX): Define.

2003-05-27  Denis Chertykov  <denisc@overta.ru>

	* cselib.c (cselib_invalidate_regno): Abort if hardreg have a
	VOIDmode.
	* cselib.c (cselib_process_insn): Pass reg_raw_mode for hardreg in
	call of cselib_invalidate_regno.

2003-05-28  Daniel Jacobowitz  <drow@mvista.com>

	* config/mips/linux.h (LIB_SPEC): Add missing -lc and correct
	-lthread to -lpthread.

2003-05-28  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Bruce Korb  <bkorb@gnu.org>
	    Arno Klaassen  <arno@heho.snv.jussieu.fr>

	* fixinc/inclhack.def: Add missing declaration of getpagesize()
	to unistd.h on Solaris 2.5.1.
	Fix prototype of recv() and send() in sys/socket.h on
	Solaris 2.5.1 and 2.6.
	* fixinc/tests/base/unistd.h: Add solaris_unistd fix test.
	* fixinc/tests/base/sys/socket.h: Add solaris_socket test.
	* fixinc/check.tpl: Use 'diff -c', not 'diff -u'.
	* fixinc/fixincl.x: Regenerate.

2003-05-27  Jason Merrill  <jason@redhat.com>

	* tree.c (expr_first, expr_length): New fns.
	* tree.h: Declare them.

	* tree.c (iterative_hash_expr): Hash commutative expressions
	consistently.

2003-05-27  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* tree.h (contains_placeholder_p): Now returns bool.
	(CONTAINS_PLACEHOLDER_P): New macro.
	(type_contains_placeholder_p): New function.
	* tree.c (save_expr): Remove code avoiding folding COMPONENT_REF.
	(contains_placeholder_p): Now returns bool.
	Rework to use CONTAINS_PLACEHOLDER_P macro.
	(type_contains_placeholder_p): New function.
	* fold-const.c (fold, case COMPONENT_REF): Don't fold if
	type_contains_placeholder_p.
	(fold_range_test, fold_mathfn_compare, fold_inf_compare, fold):
	Use CONTAINS_PLACEHOLDER_P macro.
	* builtins.c (fold_builtin): Likewise.
	* calls.c (initialize_argument_information): Likewise.
	* emit-rtl.c (set_mem_attributes_minus_bitpos): Likewise.
	* explow.c (expr_size): Likewise.
	* expr.c (store_constructor, get_inner_reference): Likewise.
	* function.c (assign_parms): Likewise.
	* stor-layout.c (variable_size): Likewise.

2003-05-25  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* diagnostic.h (output_verbatim, verbatim):  Remove  printf
	attribute.

2003-05-25  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Update Kean Johnston.

2003-05-24  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (save_fpregs_{si,di}): Add length attribute.

2003-05-24  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config/rs6000/440.md, config/stormy16/stormy16protos.h,
	config/stormy16/stormy16.c, config/stormy16/stormy16.md:
	Replace "GNU CC" with "GCC".

2003-05-24  Matt Kraai  <kraai@alumni.cmu.edu>

	* builtins.c (expand_builtin_memcpy): Use mode of dest_addr for
	intermediate computation.

2003-05-23  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.md (clzsi, clzdi): New patterns.

2003-05-23  Geoffrey Keating  <geoffk@apple.com>

	* gcc.c (default_compilers): Use -o to specify preprocessor's output
	file.  Make -no-integrated-cpp work when building PCH files.
	* objc/lang-specs.h: Likewise.

2003-05-23  Nathanael Nerode  <neroden@gcc.gnu.org>

	* fixinc/Makefile.in: Correct description.
	* fixinc/Makefile.in, fixinc/fixfixes.c, fixinc/fixincl.c,
	fixinc/fixlib.c, fixinc/fixlib.h, fixinc/fixtests.c,
	fixinc/genfixes: Replace "GNU CC" with "GCC".

2003-05-23  Roger Sayle  <roger@eyesopen.com>

	* builtins.def: Define atan, atanf, atanl, tan, tanf and tanl
	builtin functions (and their __builtin_* variants).
	* builtins.c (mathfn_built_in): Handle tan{,f,l} and atan{,f,l}.
	(expand_builtin): Don't expand tan{,f,l} or atan{,f,l} when not
	optimizing.

	* doc/extend.texi: Document new tan and atan builtins, and
	their float and long double variants.

2003-05-23  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/sparc/netbsd-elf.h (TARGET_OS_CPP_BUILTINS): Define
	__sparcv9 in the TARGET_ARCH64 case.

Fri May 23 22:17:32 CEST 2003  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_reorg): Calls are also jumps.

2003-05-23  J"orn Rennecke <joern.rennecke@superh.com>

	* cse.c (count_reg_usage): When processing an INSNs REG_EQUAL
	note containing an EXPR_LIST, process all the arguments.

Fri May 23 21:19:31 CEST 2003  Jan Hubicka  <jh@suse.cz>
			       Andreas Jaeger  <aj@suse.de>

	* i386.h (TARGET_CPU_CPP_BUILTINS): Define __amd64 and __amd64__;
	do not use assertion.

2003-05-23  Mike Stump  <mrs@apple.com>

	* tlink.c (scan_linker_output): Add support for darwin linker, as it
	emits unresolved symbols one per line, consuming the entire line.

2003-05-23  Larin Hennessy <larin@science.oregonstate.edu>
	    Zack Weinberg <zack@codesourcery.com>

	* explow.c (allocate_dynamic_stack_space): Remove call to gen_probe.
	* config/m68k/m68k.c (m68k_output_function_prologue):
	Remove code under #if NEED_PROBE.
	* config/m68k/m68k.h: Don't define NEED_PROBE.
	* config/m68k/m68k.md: Remove "probe" insn.
	* doc/md.texi: Remove documentation of "probe" pattern.

2003-05-23  Dorit Naishlos  <gcchaifa@il.ibm.com>

	* config/rs6000/rs6000.md (save_fpregs_{si,di}): Add branch attribute.

2003-05-23  Eric Botcazou  <ebotcazou@libertysurf.fr>

	* doc/install.texi: Remove sparc64-*-*. Add sparc64-*-solaris2*.
	Document sparcv9-*-solaris2* as a synonym for sparc64-*-solaris2*.

2003-05-22  Roger Sayle  <roger@eyesopen.com>

	* real.c (real_maxval): New function to return the largest finite
	value representable in a given mode (i.e. FLT_MAX and DBL_MAX).
	* real.h (real_maxval): Prototype here.
	* fold-const.c (fold_inf_compare): Transform comparisons against
	+-Infinity into comparisons against DBL_MAX (or equivalent).

2003-05-22  Mike Stump  <mrs@apple.com>

	* config.gcc (*-*-darwin*): Remove use_collect2=no, as it is the
	default.

2003-05-22  DJ Delorie  <dj@redhat.com>

	* calls.c (expand_call): If the arg block is going to grow
	downward, we need argblock to point to the top of the block,
	not the bottom.

2003-05-22  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* c-decl.c (duplicate_decls): Test DECL for ERROR_MARK.

	* expr.c (expand_expr, case CONSTRUCTOR): Put into memory if
	constant and EXPAND_CONST_ADDRESS, not just EXPAND_INITIALIZER.

2003-05-22  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* m68hc11.c: Don't use the `0' flag for asm_fprintf specifiers.
	* m68k.c: Likewise.
	* m68k.h: Likewise.

2003-05-22  Zack Weinberg  <zack@codesourcery.com>

	PR other/2873
	* fixinc/inclhack.def (avoid_wchar_t_type): Add bypass
	expressions to prevent triggering on recent curses.h,
	linux/nls.h, or X11/Xlib.h.
	(stdio_va_list): Add _G_va_list to bypass pattern.
	(strict_ansi_not): Add bypass pattern for __SCO_VERSION__.
	* fixinc/fixincl.x: Regenerate.

2003-05-22 Rekha Bhintade <rekhad@kpitcummins.com>

	* gcc/config/sh/sh.h (TARGET_SWITCHES): Display all the target
	switches when --target-help option is specified.

2003-05-22  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR bootstrap/10805
	* doc/install.texi (sparc-sun-solaris2.7): Document bootstrap
	failure with Sun assembler 5.0 Alpha 03/27/98.

2003-05-21  Loren James Rittle  <ljrittle@acm.org>

	* config/sparc/freebsd.h (CPP_CPU64_DEFAULT_SPEC): Add -D__sparcv9
	to match system compiler convention.

2003-05-21  Danny Smith  <dannysmith@users.sourceforge.net>

	* gthr-win32.h (__GTHREAD_HIDE_WIN32API): Test for nonzero
	value, not just if defined.
	Update copyright year.

2003-05-21  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	PR target/6428
	* pa-hpux10.h (LINK_SPEC, LIB_SPEC): Move -L options for profiling
	directories from LIB_SPEC to LINK_SPEC.  Emit warning if `-p' or `-pg'
	option is used without `-static'.
	* pa-hpux11.h (LINK_SPEC, LIB_SPEC): Likewise.
	* pa64-hpux.h (LINK_SPEC, LIB_SPEC): Likewise.

2003-05-21  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.h (MASK_SERIALIZE_VOLATILE,
	TARGET_SERIALIZE_VOLATILE): Delete.
	(MASK_CONST16, MASK_ABS, MASK_ADDX): Renumber flag bits.
	(TARGET_DEFAULT): Remove MASK_SERIALIZE_VOLATILE.
	(TARGET_SWITCHES): Remove "-mserialize-volatile" and
	"-mno-serialize-volatile".
	* config/xtensa/xtensa.c (print_operand): Remove checks of
	TARGET_SERIALIZE_VOLATILE.
	* config/xtensa/xtensa.md (*lsiu, *ssiu): Likewise.
	* doc/invoke.texi (Option Summary, Xtensa Options): Remove
	"-mserialize-volatile" and "-mno-serialize-volatile" options.

2003-05-21  Nathan Sidwell  <nathan@codesourcery.com>

	* c-parse.in (fndef): Set DECL_SOURCE_LINE and FILE earlier.
	(nested_function): Likewise.
	(notype_nested_function): Likewise.

2003-05-21  Nick Clifton  <nickc@redhat.com>

	* config/stormy16/stormy-abi: Update overflow type for
	R_XSTORMY16_16 reloc.

2003-05-21  Nathan Sidwell  <nathan@codesourcery.com>

	* c-common.h (enum rid): Remove RID_BOUNDED, RID_UNBOUNDED.
	* c-parse.in (reswords): Remove __bounded__ and __unbounded__.
	(rid_to_yy): Remove RID_BOUNDED, RID_UNBOUNDED slots.
	* print-tree.c (print_node): Remove ambient-boundedness.
	* tree.h (tree_common): Remove bounded_flag.
	(BOUNDED_INDIRECT_YPE_P, BOUNDED_POINTER_TYPE_P,
	BOUNDED_REFERENCE_TYPE_P, MAYBE_BOUNDED_INDIRECT_TYPE_P,
	MAYBE_BOUNDED_POINTER_TYPE_P, MAYBE_BOUNDED_REFERENCE_TYPE_P,
	TREE_BOUNDED, TYPE_MAIN_VARIANTS_PHYSICALLY_EQUAL_P,
	TYPE_MAIN_PHYSICAL_VARIANT, TYPE_BOUNDED, TYPE_QUAL_BOUNDED):
	Remove.
	(TYPE_QUALS): Remove BOUNDED.
	(TREE_EXPR_QUALS, TREE_FUNC_QUALS): Remove.
	(TYPE_BOUNDED_VALUE, TYPE_BOUNDED_BASE, TYPE_BOUNDED_EXTENT,
	TYPE_BOUNDED_SUBTYPE, TYPE_UNBOUNDED_VARIANT, TYPE_POINTER_DEPTH,
	TYPE_AMBIENT_BOUNDEDNESS, MAX_POINTER_DEPT,
	VA_LIST_POINTER_DEPTH): Remove.
	(struct tree_type): Remove pointer_depth.

2003-05-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* c-pretty-print.c (pp_c_integer_literal): Use
	HOST_WIDE_INT_PRINT_DOUBLE_HEX.

2003-05-20  Roger Sayle  <roger@eyesopen.com>
	    Kazu Hirata  <kazu@cs.umass.edu>
	    Joern Rennecke  <joern.rennecke@superh.com>

	* gcse.c (cprop_jump):  Make use of REG_EQUAL notes on both
	setcc and jump, if they exist.  If substituted instruction
	fails to validate, store current effort in a REG_EQUAL note.
	(cprop_insn): Don't attempt further substitutions if the
	current instruction has been deleted.
	(local_cprop_pass): Likewise.

	* jump.c (redirect_jump):  Also update REG_EQUAL note, if
	one is attached to the jump instruction.
	(invert_jump): Delete REG_EQUAL note on jump, if one exists.

2003-05-21  Danny Smith  <dannysmith@users.sourceforge.net>

	PR c++/9738
	* config/i386/winnt.c (i386_pe_encode_section_info): Enable
	even if not first.

2003-05-20  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* genautomata.c (output_description, output_automaton_units,
	output_state_arcs): Add missing specifiers.

2003-05-20  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/lib1funcs.asm: Avoid use of .Lfe* in .size directives.
	(do_abs, do_addx2, do_addx4, do_addx8): New assembler macros.
	(__mulsi3): Use do_addx* instead of ADDX* instructions.  Formatting.
	(nsau): Rename to do_nsau.  Provide alternate version for use when
	the NSAU instruction is available.
	(__udivsi3, __divsi3, __umodsi3, __modsi3): Use do_nsau macro.
	(__divsi3, __modsi3): Use do_abs macro instead of ABS instruction.
	* config/xtensa/xtensa-config.h: Update comments to match binutils.
	(XCHAL_HAVE_ABS, XCHAL_HAVE_ADDX): Define.
	* config/xtensa/xtensa.h (MASK_ABS, MASK_ADDX): Define.
	(TARGET_ABS, TARGET_ADDX): Define.
	(TARGET_DEFAULT): Conditionally add MASK_ABS and MASK_ADDX.
	(TARGET_SWITCHES): Add "abs", "no-abs", "addx", and "no-addx".
	* config/xtensa/xtensa.md (*addx2, *addx4, *addx8, *subx2, *subx4,
	*subx8): Set predicate condition to TARGET_ADDX.
	(abssi2): Set predicate condition to TARGET_ABS.
	* doc/invoke.texi (Option Summary): Document new "-mabs", "-mno-abs",
	"-maddx", and "-mno-addx" options.
	(Xtensa Options): Likewise.  Also tag some opcode names with @code.

2003-05-20  Kevin Ryde <user42@zip.com.au>
	    Wolfgang Bangerth <bangerth@dealii.org>

	PR/10355
	* doc/extend.texi: Put a warning into the documentation
	of attribute regparm.

2003-05-20  Jason Merrill  <jason@redhat.com>

	* tree.c (expr_last): New fn.
	* tree.h: Declare it.
	* objc/objc-act (expr_last): Rename to objc_expr_last.

2003-05-20  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (sh_register_move_cost): Add clase for moving between
	FP registers and MAC registers.

2003-05-19  John David Anglin  <dave.anglin@nrc-gnrc.gc.ca>

	* pa/milli64.S ($$mulI): Fix typo.

2003-05-19  Matt Kraai  <kraai@alumni.cmu.edu>

	* alias.c (nonlocal_mentioned_p, nonlocal_referenced_p)
	(nonlocal_set_p): Remove initial blank line.
	* dwarf2out.c (simple_type_size_in_bits): Likewise.
	* et-forest.c (et_forest_create): Likewise.
	* explow.c (stabilize): Likewise.
	* fix-header.c (write_lbrac): Likewise.
	* graph.c (start_fct, node_data): Likewise.
	* jump.c (only_sets_cc0_p, sets_cc0_p): Likewise.
	* rtlanal.c (global_reg_mentioned_p): Likewise.
	* tree.c (bit_position): Likewise.

2003-05-19  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/linux64.h (LIB_SPEC): Add missing -lc and correct
	-lthread to -lpthread.

2003-05-19  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (c_common_decode_option): Don't accept dollars
	as identifier characters in assembly.
	* doc/cpp.texi: Document this.

2003-05-19  Seth Arnold  <sarnold@wirex.com>
	    Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (rs6000_stack_info): Do not add
	vrsave_size twice.

2003-05-19  Aldy Hernandez  <aldyh@redhat.com>

	* doc/tm.texi (function_arg): Fix typo.

2003-05-19  Matt Austern  <austern@apple.com>

	* c-opts.c (COMMAND_LINE_OPTIONS): Add -Winvalid-offsetof option.
	* c-common.h (warn_invalid_offsetof): Declare.
	* c-common.c (warn_invalid_offsetof): Define.
	* doc/invoke.texi: Document -Winvalid-offsetof.
	* testsuite/g++.dg/other/offsetof3.C: New.
	* testsuite/g++.dg/other/offsetof4.C: New.

2003-05-19  Kevin B. Hendricks  <kevin.hendricks@sympatico.ca>
	    David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_alignment_string,
	rs6000_alignment_flags): New variables.
	(rs6000_parse_alignment_option): New function.
	(rs6000_override_options): Call it.
	* config/rs6000/rs6000.h (TARGET_OPTIONS): Add -malign-XXX option.
	(MASK_ALIGN_POWER, MASK_ALIGN_NATURAL, TARGET_ALIGN_NATURAL): New
	macros.
	* config/rs6000/aix.h (ADJUST_FIELD_ALIGN): Always use COMPUTED
	natural alignment if TARGET_NATURAL_ALIGNMENT
	(ROUND_TYPE_ALIGN): Always use default record alignment if
	TAGET_NATURAL_ALIGNMENT.
	* config/rs6000/darwin.h (ADJUST_FIELD_ALIGN): Same
	(ROUND_TYPE_ALIGN): Same.
	* config/rs6000/linux64.h (ADJUST_FIELD_ALIGN): Same
	(ROUND_TYPE_ALIGN): Same.
	* doc/invoke.texi (Option Summary, PowerPC Options): Document
	new options.

2003-05-19  J"orn Rennecke <joern.rennecke@superh.com>

	* c-decl.c (finish_decl): When setting the DECL_ASSEMBLER_NAME
	of a function using ASMSPEC, prepend a star.

2003-05-19  Jason Merrill  <jason@redhat.com>

	* tree-inline.c (copy_body_r): Avoid generating &* during inline
	substitution.

2003-05-19  Andrew Macleod  <amacleod@redhat.com>

	* config/stormy16/stormy16.c (xstormy16_expand_prologue): Do
	not mark assignments to the hard frame pointer as being stack
	frame related.
	(xstormy16_expand_epilogue): Mark adjustments to the stack
	pointer as being stack frame related.

2003-05-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (ISA_HAS_LOAD_DELAY, ISA_HAS_XFER_DELAY,
	ISA_HAS_FCMP_DELAY, ISA_HAS_HILO_INTERLOCKS): New macros.
	(PREDICATE_CODES): Add hilo_operand.
	* config/mips/mips.c (hilo_operand): New predicate.
	(mips_adjust_insn_length): Account for the number nops that might
	be needed to avoid hardware hazards.
	* config/mips/mips.md (dslot): Remove attribute.
	(hazard): New attribute.
	(can_delay): Use it.  Check for calls, branches & jumps.
	(muldi3): Use the standard dmult pattern for mips16 code.
	(muldi3_internal, muldi3_internal2): Adjust conditions accordingly.

2003-05-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (final_prescan_insn,
	mips_count_memory_refs, mips_fill_delay_slot): Remove.
	* config/mips/mips.h (delay_type, dslots_load_total,
	dslots_load_filled, dslots_jump_total, dslots_jump_filled,
	dslots_number_nops, num_refs, mips_load_reg, mips_load_reg2,
	mips_load_reg3, mips_load_reg4): Remove.
	(MASK_STATS): Remove.
	(MASK_EXPLICIT_RELOCS): Reuse its value.
	(TARGET_STATS): Remove.
	(TARGET_SWITCHES): Turn -mstats and -mno-stats into no-ops.
	Warn that -mstats is now ignored.
	(FINAL_PRESCAN_INSN): Undefine.
	(DBR_OUTPUT_SEQEND): Remove handling of dslot statistics.
	(ASM_OUTPUT_REG_POP): Likewise.
	* config/mips/mips.c (dslots_load_total, dslots_load_filled,
	dslots_jump_total, dslots_jump_filled, dslots_number_nops, num_refs,
	mips_load_reg, mips_load_reg2, mips_load_reg3, mips_load_reg4,
	mips_fill_delay_slot, mips_count_memory_refs,
	final_prescan_insn): Remove.
	(output_block_move): Remove calls to mips_count_memory_refs.
	(print_operand): Remove printing of #nop for TARGET_STATS.
	(mips_output_function_epilogue): Remove TARGET_STATS code.
	Reorganize setting of fnnmae.
	* config/mips/mips.md: Remove handling of dslot statistics
	throughout file.  Change all fcmp patterns into normal asm
	templates, removing calls to mips_fill_delay_slot.
	* doc/invoke.texi: Remove documentation of -mstats.

2003-05-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips_class_max_nregs): Return the number of
	words in the mode.

2003-05-19  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (override_options): Disable explicit
	relocs for old ABIs unless using gas.

2003-05-18  Eric Christopher  <echristo@redhat.com>

	* config/mips/mips.h: Remove definition of g_switch_value.

2003-05-18  Matt Kraai  <kraai@alumni.cmu.edu>

	* flags.h (g_switch_value): Change to an unsigned
	HOST_WIDE_INT.
	* toplev.c (g_switch_value): Likewise.

	* config/alpha/alpha.c (small_symbolic_operand): Remove
	g_switch_value cast.
	(alpha_in_small_data_p): Cast size to an unsigned
	HOST_WIDE_INT.

	* config/frv/frv.c (frv_in_small_data_p): Cast size to an
	unsigned HOST_WIDE_INT.
	* config/frv/frv.h (g_switch_value, g_switch_set): Remove.
	(ASM_OUTPUT_ALIGNED_DECL_LOCAL): Declare g_switch_set.

	* config/m32r/m32r.c (m32r_in_small_data_p): Cast size to an
	unsigned HOST_WIDE_INT.
	(m32r_asm_file_start): Use HOST_WIDE_INT_PRINT_UNSIGNED.
	* config/m32r/m32r.h (g_switch_value, g_switch_set): Remove.
	(ASM_OUTPUT_ALIGNED_COMMON): Declare g_switch_value.

	* config/rs6000/rs6000.c (rs6000_file_start): Use
	HOST_WIDE_INT_PRINT_UNSIGNED.
	(small_data_operand): Cast summand to unsigned HOST_WIDE_INT.
	(rs6000_elf_in_small_data_p): Cast size to unsigned
	HOST_WIDE_INT.
	* config/rs6000/sysv4.h (g_switch_value, g_switch_set):
	Remove.
	(SUBTARGET_OVERRIDE_OPTIONS): Declare g_switch_value and
	g_switch_set.
	(ASM_OUTPUT_ALIGNED_LOCAL): Declare g_switch_value and remove
	g_switch_value cast.

2003-05-18  Roger Sayle  <roger@eyesopen.com>
	    Zack Weinberg  <zack@codesourcery.com>

	PR middle-end/10472
	* builtins.c (expand_builtin_memcpy):  Call force_operand on
	expressions and use simplify_gen_binary to create the addition.

2003-05-18  Andreas Schwab  <schwab@suse.de>

	* config/m68k/m68k.md: Use define_constants for unspec numbers.

2003-05-18  Neil Booth  <neil@daikokuya.co.uk>

	* config/sparc/sparc.h: Define sparc for now.

2003-05-18  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc: Clear xm_file, md_file at the beginning of each pass.

	* config/stormy16/stormy16.h: Remove about 3000 lines of
	target-independent comments.  Update copyright notice.

	* doc/collect2.texi: GNU CC -> GCC.
	* doc/headerdirs.texi: GNU CC -> GCC.

2003-05-18  Gabriel Dos Reis <gdr@integrable-solutions.net>

	* hashtable.h (struct ht_identifier): Add data member "hash_value".
	* hashtable.c (ht_lookup): Use it when searching, remember.
	(ht_expand): Do not recompute.
	* tree.h (IDENTIFIER_HASH_VALUE): New macro.

2003-05-18  Nathan Sidwell  <nathan@codesourcery.com>

	* gcov-io.c (gcov_read_bytes): Fix fread thinko.

2003-05-18  Neil Booth  <neil@daikokuya.co.uk>

	* c-cppbuiltin.c (TARGET_OS_CPP_BUILTINS, TARGET_OBJFMT_CPP_BUILTINS):
	Default here.
	(c_cpp_builtins): Invoke TARGET_OBJFMT_CPP_BUILTINS().
	* defaults.h: Don't default TARGET_OS_CPP_BUILTINS here.
	* config/elfos.h (TARGET_OBJFMT_CPP_BUILTINS): Define __ELF__.
	* config/freebsd-spec.h, config/netbsd-elf.h, config/alpha/gnu.h,
	config/arm/linux-elf.h, config/arm/rtems-elf.h,
	config/arm/unknown-elf.h, config/cris/cris.h, config/cris/linux.h,
	config/h8300/elf.h, config/i370/linux.h, config/i386/beos-elf.h,
	config/i386/gnu.h, config/i386/linux.h, config/i386/linux64.h,
	config/i386/moss.h, config/i386/rtemself.h, config/ia64/ia64.h,
	config/m68k/rtemself.h, config/mcore/mcore-elf.h, config/mips/linux.h,
	config/pa/pa-linux.h, config/rs6000/linux.h, config/rs6000/linux64.h,
	config/rs6000/sysv4.h, config/rs6000/vxworks.h, config/s390/linux.h,
	config/sh/coff.h, config/sh/elf.h, config/sh/rtemself.h,
	config/sh/sh.h, config/sparc/linux.h, config/sparc/linux64.h,
	config/sparc/openbsd64.h, config/sparc/sp64-elf.h,
	config/sparc/sp86x-elf.h, config/xtensa/elf.h, config/xtensa/linux.h:
	Don't define __ELF__.
	* config/alpha.h, config/m68k/linux.h (TARGET_OBJFMT_CPP_BUILTINS):
	Define __ELF__.
	* doc/cpp.texi: Document __ELF__.
	* doc/tm.texi: Document TARGET_OBJFMT_CPP_BUILTINS.	*

2003-05-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (validate_arglist): Eliminate libiberty VA_ macros,
	always use stdarg.
	* c-errors.c (pedwarn_c99): Likewise.
	* c-format.c (status_warning): Likewise.
	* c-semantics.c (build_stmt): Likewise.
	* calls.c (emit_library_call, emit_library_call_value): Likewise.
	* collect2.c (notice, fatal_perror, fatal, error): Likewise.
	* cpperror.c (cpp_error, cpp_error_with_line): Likewise.
	* diagnostic.c (build_message_string, output_printf,
	output_verbatim, verbatim, inform, warning, pedwarn, error, sorry,
	fatal_error, internal_error, warning_with_decl, pedwarn_with_decl,
	error_with_decl, fnotice): Likewise.
	* dwarf2asm.c (dw2_asm_output_data, dw2_asm_output_delta,
	dw2_asm_output_offset, dw2_asm_output_pcrel, dw2_asm_output_addr,
	dw2_asm_output_addr_rtx, dw2_asm_output_nstring,
	dw2_asm_output_data_uleb128, dw2_asm_output_data_sleb128,
	dw2_asm_output_delta_uleb128, dw2_asm_output_delta_sleb128,
	dw2_asm_output_encoded_addr_rtx): Likewise.
	* emit-rtl.c (gen_rtx, gen_rtvec): Likewise.
	* errors.c (warning, error, fatal, internal_error): Likewise.
	* final.c (output_operand_lossage, asm_fprintf): Likewise.
	* fix-header.c (fatal): Likewise.
	* gcc.c (fatal, error, notice): Likewise.
	* gcov.c (fnotice): Likewise.
	* genattrtab.c (attr_rtx, attr_printf): Likewise.
	* gengtype.c (error_at_line, xasprintf, oprintf): Likewise.
	* gensupport.c (message_with_line): Likewise.
	* mips-tfile.c (fatal, error): Likewise.
	* protoize.c (notice): Likewise.
	* ra-debug.c (ra_debug_msg): Likewise.
	* read-rtl.c (fatal_with_file_and_line): Likewise.
	* rtl-error.c (error_for_asm, warning_for_asm): Likewise.
	* tree.c (build, build_nt, build_function_type_list): Likewise.

2003-05-17  Neil Booth  <neil@daikokuya.co.uk>

	* defaults.h (TARGET_CPU_CPP_BUILTINS, CPP_PREDEFINES): Remove.
	* gcc.c (cpp_predefines): Remove.
	(cpp_unique_options, do_spec_1): Remove handling of CPP_PREDEFINES.
	(static_specs): Remove predefines.
	* system.h: Poison CPP_PREDEFINES.
	* config/freebsd.h, config/openbsd.h, config/ptx4.h, config/svr3.h,
	config/svr4.h, doc/tm.texi: Remove references to CPP_PREDEFINES.

2003-05-17  Neil Booth  <neil@daikokuya.co.uk>

	* config/m68k/hp320.h, config/m68k/linux.h, config/m68k/m68k-none.h,
	config/m68k/m68k.h, config/m68k/m68kemb.h, config/m68k/m68kv4.h,
	config/m68k/openbsd.h, config/m68k/rtemself.h: Remove CPP_PREDEFINES,
	use TARGET_OS_CPP_BUILTINS and TARGET_CPU_CPP_BUILTINS instead.

2003-05-17  Neil Booth  <neil@daikokuya.co.uk>

	PR c/9209
	* c-common.c, c-common.h (dollars_in_ident): Remove.
	* c-opts.c (DOLLARS_IN_IDENTIFIERS): Default to true.
	(c_common_init_options, c_common_decode_option): Set dollars_in_ident.
	* cpphash.h (warned_dollar): Rename warn_dollars.
	* cppinit.c (struct lang_flags, lang_defaults, cpp_set_lang)
	Permit dollars regardless of -std=.
	(post_options): Set warn_dollars.
	* cpplex.c (forms_identifier_p): Use warn_dollars.
	* config/darwin.h, config/alpha/vms.h, config/m68hc11/m68hc11.h:
	Remove redundant definitions of DOLLARS_IN_IDENTIFIERS.
	* doc/cpp.texi, doc/cppopts.texi, doc/invoke.texi, doc/tm.texi:
	Update documentation.

2003-05-17  Andreas Schwab  <schwab@suse.de>

	* config/m68k/m68k.c (m68k_output_function_prologue): Use
	HOST_WIDE_INT_PRINT_DEC for fprintf and %wd for asm_fprintf when
	formatting a HOST_WIDE_INT.
	(m68k_output_function_epilogue): Likewise.

2003-05-17  Zack Weinberg  <zack@codesourcery.com>

	* doc/install.texi: Remove information about desupported targets.

2003-05-17  Andreas Schwab  <schwab@suse.de>

	* config/m68k/coff.h: Remove support for Sun FPA and Sun SKY board.
	* config/m68k/linux.h: Likewise.
	* config/m68k/m68k-none.h: Likewise.
	* config/m68k/netbsd-elf.h: Likewise.
	* config/m68k/sgs.h: Likewise.
	* config/m68k/m68k.h: Likewise.
	* config/m68k/m68k.md: Likewise.
	* config/m68k/m68k.c: Likewise.
	* doc/md.texi (Machine Constraints): Remove Sun FPA specific
	constraints.
	* doc/invoke.texi (Option Summary): Remove -mfpa.
	(M680x0 Options): Likewise.

2003-05-17  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.c (rs6000_function_value): Simplify REAL_TYPE logic.

2003-05-17  Neil Booth  <neil@daikokuya.co.uk>

	* config/sol2.h: Add TARGET_SUB_OS_CPP_BUILTINS.
	* config/sparc/liteelf.h, config/sparc/openbsd64.h,
	config/sparc/rtemself.h, config/sparc/sol2-64.h,
	config/sparc/sp64-elf.h, config/sparc/sp86x-elf.h:
	Update for use of TARGET_SUB_OS_CPP_BUILTINS.

2003-05-17  Neil Booth  <neil@daikokuya.co.uk>

	* i960/i960.h, i960/rtems.h: Use TARGET_OS_CPP_BUILTINS and
	TARGET_CPU_CPP_BUILTINS in preference to CPP_PREDEFINES.

2003-05-17  Neil Booth  <neil@daikokuya.co.uk>

	* config.gcc (sparc-*-sysv4*): Add sparc/sysv4-only.h.
	* sparc/aout.h, sparc/elf.h, sparc/freebsd.h, sparc/linux.h,
	sparc/linux64.h, sparc/lite.h, sparc/litecoff.h, sparc/liteelf.h,
	sparc/netbsd-elf.h, sparc/openbsd.h, sparc/openbsd64.h,
	sparc/pbd.h, sparc/rtemself.h, sparc/sol2-64.h, sparc/sol2-bi.h,
	sparc/sol2.h, sparc/sp64-elf.h, sparc/sp86-elf.h, sparc/sparc.h,
	sparc/sysv4.h,
	* sparc/sysv4-only.h: New.

2003-05-17  Alan Modra  <amodra@bigpond.net.au>

	* function.c (assign_parms): Check for zero size args.

2003-05-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* cfgloopanal.c (test_for_iteration): Use string concatentation on
	HOST_WIDE_INT_PRINT_* format specifier to collapse multiple
	function calls into one.
	* dbxout.c (dbxout_symbol): Likewise.
	* defaults.h (ASM_OUTPUT_SIZE_DIRECTIVE): Likewise.
	* dwarf2asm.c (dw2_asm_output_data_uleb128,
	dw2_asm_output_data_sleb128): Likewise.
	* genrecog.c (debug_decision_2): Likewise.
	* loop.c (emit_prefetch_instructions): Likewise.
	* print-rtl.c (print_rtx): Likewise.
	* print-tree.c (print_node_brief, print_node): Likewise.
	* ra-debug.c (dump_igraph, dump_graph_cost,
	dump_static_insn_cost): Likewise.
	* ra-rewrite.c (dump_cost): Likewise.
	* sdbout.c (PUT_SDB_INT_VAL, PUT_SDB_SIZE): Likewise.
	* sreal.c (dump_sreal): Likewise.
	* unroll.c (unroll_loop, precondition_loop_p): Likewise.
	* varasm.c (assemble_vtable_entry): Likewise.

	* avr.c (avr_output_function_prologue,
	avr_output_function_epilogue, print_operand): Fix format specifier
	warnings.
	(init_cumulative_args): Mark parameter with ATTRIBUTE_UNUSED.
	* avr.h (FUNCTION_VALUE_REGNO_P): Fix signed/unsigned warnings.

2003-05-16  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (expand_block_move): Unify the TARGET_STRING
	and ! TARGET_STRING cases.

	* doc/cppopts.texi (-undef): Fix texinfo warning.

	* doc/cppopts.texi (-H): Document that -H works for PCH files too.
	* cppfiles.c (validate_pch): When -H is used, print some information
	about PCH files found.

2003-05-16  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/mips/t-elf: Remove obsolete rules adding dependencies on tm.h.
	* config/mips/t-isa3264, config/mips/t-r3900: Likewise.
	* config/mips/t-sr71k: Likewise.

2003-05-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* arc.c (arc_output_function_prologue,
	arc_output_function_epilogue): Fix format specifier warnings.
	* arc.h (LARGE_INT): Fix signed/unsigned warnings.

	* v850.c (print_operand): Fix format specifier warnings.

	* ns32k.c (ADJSP, ns32k_output_function_prologue): Fix format
	specifier warnings.

	* mcore.c (mcore_print_operand_address, mcore_print_operand): Fix
	format specifier warnings.

	* ip2k.c (function_prologue, function_epilogue, print_operand):
	Fix format specifier warnings.
	* ip2k.md: Likewise.

	* i960.c (i960_output_function_prologue, i960_print_operand,
	i960_print_operand_addr): Fix format specifier warnings.

	* i370.c (ascebc, ebcasc): Wrap in macros controlling usage.
	(i370_output_function_prologue): Fix format specifier warnings.
	* i370.h (PRINT_OPERAND): Likewise.

	* fr30.c (fr30_print_operand): Fix format specifier warnings.

	* dsp16xx.c (print_operand_address): Fix format specifier warning.
	* dsp16xx.h (INCLUDE_DEFAULTS): Add missing initializers.

	* c4x.c (c4x_print_operand, c4x_print_operand_address): Fix format
	specifier warnings.

	* alpha.c (print_operand_address, alpha_start_function,
	unicosmk_output_ssib): Use string concatentation on
	HOST_WIDE_INT_PRINT_* format specifier to collapse multiple
	function calls into one.
	* arm.c (arm_print_operand): Likewise.
	* cris.c (cris_asm_output_mi_thunk): Likewise.
	* frv.c (frv_asm_output_mi_thunk): Likewise.
	* ia64.c (ia64_print_operand, process_set): Likewise.
	* m68k.c (m68k_output_function_epilogue, m68k_output_mi_thunk):
	Likewise.
	* mips/iris5gas.h (PUT_SDB_SIZE): Likewise.
	* mips.h (PUT_SDB_INT_VAL, PUT_SDB_SIZE): Likewise.
	* pa.c (output_div_insn, pa_asm_output_mi_thunk): Likewise.
	* pa.h (PRINT_OPERAND_ADDRESS): Likewise.
	* rs6000.c (rs6000_va_start, print_operand_address): Likewise.
	* s390.c (s390_assemble_integer): Likewise.
	* sparc.c (sparc_flat_function_prologue,
	sparc_flat_function_epilogue): Likewise.
	* stormy16.c (xstormy16_print_operand_address, xstormy16_print_operand): Likewise.
	* vax.c (vax_output_mi_thunk): Likewise.

	* frv.c (frv_print_operand_memory_reference): Fix format specifier
	warning.
	(frv_rtx_costs): Mark parameter with ATTRIBUTE_UNUSED.

	* m68k.c (m68k_output_function_epilogue): Fix format specifier
	warnings.

	* stormy16-protos.h (xs_hi_general_operand,
	xs_hi_nonmemory_operand): Prototype.
	* stormy16.c (xstormy16_output_shift): Fix format specifier
	warnings.

	* cris.c: Fix format specifier warnings.

2003-05-16  Nick Clifton  <nickc@redhat.com>

	* config/arm/lib1funcs.asm: Fix typo: LSM instead of LSYM.

2003-05-16  Wolfgang Bangerth <bangerth@dealii.org>

	* doc/bugreport.texi: Remove most of the of the preface of the
	bugs section.

2003-05-16  Jakub Jelinek  <jakub@redhat.com>

	* config/ia64/unwind-ia64.c (uw_update_reg_address): Handle
	.save XX, r0.

2003-05-15  Roger Sayle  <roger@eyesopen.com>

	* config/alpha/alpha.h (ASM_OUTPUT_SKIP): Fix typo.

2003-05-15  Eric Christopher  <echristo@redhat.com>

	* cfgcleanup.c (merge_blocks): Fix return value.

2003-05-15 Eric Christopher <echristo@redhat.com>

	* combine.c (expand_compound_operation): Make sure
	that zero_extend operation is profitable.

2003-05-15  Richard Henderson  <rth@redhat.com>

	* config/alpha/linux.h, config/alpha/linux-elf.h: Remove
	code protected by USE_GNULIBC_1.

2003-05-15  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc: Purge all targets obsoleted in GCC 3.3.  Also
	remove hppa*-*-mpeix* which could not be built, and prune
	files from tmake_file= or tm_file= lists that don't exist.

	* config/alpha/alpha-interix.h, config/alpha/alpha32.h
	* config/alpha/t-interix, config/arm/conix-elf.h
	* config/arm/t-arm-aout, config/arm/t-strongarm-coff
	* config/arm/unknown-elf-oabi.h, config/i386/win32.h
	* config/m68k/3b1.h, config/m68k/3b1g.h, config/m68k/amix.h
	* config/m68k/atari.h, config/m68k/ccur-GAS.h, config/m68k/crds.h
	* config/m68k/hp2bsd.h, config/m68k/hp3bsd.h
	* config/m68k/hp3bsd44.h, config/m68k/linux-aout.h
	* config/m68k/m68k-psos.h, config/m68k/mot3300.h
	* config/m68k/pbb.h, config/m68k/plexus.h, config/m68k/sun2.h
	* config/m68k/sun2o4.h, config/m68k/sun3.h, config/m68k/sun3mach.h
	* config/m68k/sun3n.h, config/m68k/sun3n3.h, config/m68k/sun3o3.h
	* config/m68k/t-mot3300, config/m68k/t-mot3300-gald
	* config/m68k/t-mot3300-gas, config/m68k/t-mot3300-gld
	* config/m68k/tower-as.h, config/m68k/tower.h
	* config/m88k/aout-dbx.h, config/m88k/m88k-aout.h
	* config/m88k/m88k-modes.def, config/m88k/m88k-move.sh
	* config/m88k/m88k-protos.h, config/m88k/m88k.c
	* config/m88k/m88k.h, config/m88k/m88k.md, config/m88k/openbsd.h
	* config/m88k/sysv4.h, config/m88k/t-luna, config/m88k/t-luna-gas
	* config/m88k/t-m88k, config/m88k/t-sysv4, config/mcore/gfloat.h
	* config/mips/rtems64.h, config/mips/sni-gas.h
	* config/mips/sni-svr4.h, config/mips/t-ecoff
	* config/mn10200/lib1funcs.asm, config/mn10200/mn10200-protos.h
	* config/mn10200/mn10200.c, config/mn10200/mn10200.h
	* config/mn10200/mn10200.md, config/mn10200/t-mn10200
	* config/pa/pa-hiux.h, config/pa/pa-hpux7.h, config/pa/pa-hpux9.h
	* config/pa/pa-oldas.h, config/pa/t-mpeix, config/psos.h
	* config/romp/romp-protos.h, config/romp/romp.c
	* config/romp/romp.h, config/romp/romp.md, config/rs6000/aix31.h
	* config/rs6000/aix3newas.h, config/rs6000/mach.h
	* config/sparc/bsd.h, config/sparc/hal.h
	* config/sparc/linux-aout.h, config/sparc/lynx-ng.h
	* config/sparc/lynx.h, config/sparc/netbsd.h
	* config/sparc/sp86x-aout.h, config/sparc/splet.h
	* config/sparc/sun4gas.h, config/sparc/sun4o3.h
	* config/sparc/sunos4.h, config/sparc/t-chorus-elf
	* config/sparc/t-halos, config/sparc/t-sparcbare
	* config/sparc/t-splet, config/sparc/t-sunos41
	* config/v850/rtems.h: Delete file.

2003-05-15  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000-protos.h (function_value): Protoize.

	* config/rs6000/rs6000.h (FUNCTION_VALUE): Call function.

	* config/rs6000/rs6000.c (rs6000_function_value): New.

2003-05-15  Philip Blundell  <philb@gnu.org>

	* config/arm/arm.c (arm_is_xscale): Rename to arm_arch_xscale.
	All uses updated.
	(arm_tune_xscale): New variable.
	(arm_override_options): Set it.
	(arm_adjust_cost): Use it in place of arm_arch_xscale.
	(arm_gen_load_multiple): Likewise.
	(arm_gen_store_multiple): Likewise.
	* config/arm/arm.md (is_xscale): Likewise.
	* config/arm/arm.h (arm_tune_xscale): Declare.

2003-05-15  Philip Blundell  <philb@gnu.org>

	PR target/10730
	* config/arm/arm.c (adjacent_mem_locations): Reject offsets
	involving invalid constants.

2003-05-15  John David Anglin  <dave.anglin@nrc-cnrc.gc.ca>

	* pa.c (hppa_expand_prologue): Remove blockage.

2003-05-15  Wolfgang Bangerth <bangerth@dealii.org>

	* doc/bugreport.texi: Remove most of the bug reporting
	instructions and merge them into bugs.html.

2003-05-14  Matt Kraai  <kraai@alumni.cmu.edu>

	* config/rs6000/sysv4.h (ASM_OUTPUT_ALIGNED_LOCAL): Cast
	g_switch_value to unsigned HOST_WIDE_INT.

2003-05-14  Eric Christopher  <echristo@redhat.com>

	* combine.c: Fix header comments.
	(distribute_notes): Remove usage of elim_i1, elim_i2. Propagate
	to all calls and prototype.

2003-05-14  Roger Sayle  <roger@eyesopen.com>

	PR optimization/10764
	* config/i386/i386.md (atan2df3, atan2sf3, atan2xf3, atan2tf3):
	Add an explicit clobber to show that UNSPEC_FPATAN clobbers st(1).
	(*fyl2x_sfxf3, *fyl2x_dfxf3, *fyl2x_xf3, *fyl2x_tfxf3):  Likewise,
	add an explicit clobber to show that UNSPEC_FYL2X clobbers st(1).
	(logsf2, logdf2, logxf2, logtf2): Update expander patterns to match
	the corresponding *fyl2x_?fxf3 instructions.

2003-05-14  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/lib2funcs.S (TRAMPOLINE_SIZE): Change from 49 to 59.
	* config/xtensa/xtensa-config.h (XCHAL_HAVE_CONST16,
	XCHAL_HAVE_L32R): New.
	* config/xtensa/xtensa-protos.h (non_const_move_operand,
	xtensa_load_constant, xtensa_function_prologue,
	xtensa_function_epilogue): Delete prototypes.
	(xtensa_expand_prologue): New.
	* config/xtensa/xtensa.c (frame_size_const,
	TARGET_ASM_FUNCTION_PROLOGUE, TARGET_MACHINE_DEPENDENT_REORG,
	non_const_move_operand, xtensa_load_constant, xtensa_reorg,
	xtensa_function_prologue): Delete.
	(add_operand, xtensa_mem_offset): Formatting.
	(move_operand): If the const16 option is available, allow any SFmode
	and SImode constants.
	(xtensa_emit_move_sequence): Inline the former contents of
	xtensa_load_constant with modifications to handle the const16 option.
	(override_options): Add xtensa_char_to_class['W'] and set it to
	the general register class only if the const16 option is enabled.
	Fix formatting.  Disallow PIC when using the const16 option.
	(print_operand): Reorganize to switch on "letter" instead of the
	RTL code.  Add output_operand_lossage calls for invalid cases.
	Add support for 't' and 'b' letters.
	(xtensa_expand_prologue): New function to replace
	xtensa_function_prologue and xtensa_reorg.
	(xtensa_function_epilogue): Declare this as static.  Delete code
	to print the retw.n or retw instruction.
	(xtensa_return_addr): Use A0_REG instead of 0.
	(xtensa_rtx_costs): Add costs for using the const16 option.
	* config/xtensa/xtensa.h (MASK_CONST16, TARGET_CONST16): New.
	(TARGET_DEFAULT): Add CONST16 if L32R instructions not available.
	(TARGET_SWITCHES): Add "const16" and "no-const16".
	(REG_CLASS_FROM_LETTER): Add comment about new 'W' letter.
	(EXTRA_CONSTRAINT): Change 'T' constraint to only apply when not
	using the const16 option.
	(TRAMPOLINE_TEMPLATE): Rewrite to avoid hardwired use of l32r insn.
	(TRAMPOLINE_SIZE): Change from 49 to 59.
	(INITIALIZE_TRAMPOLINE): Adjust offsets to match new trampoline.
	(GO_IF_LEGITIMATE_ADDRESS): Do not allow constant pool addresses
	when using the const16 option.
	(PREDICATE_CODES): Delete non_const_move_operand.
	* config/xtensa/xtensa.md (define_constants): Add A1_REG, A8_REG, and
	UNSPECV_ENTRY.
	(movdi, movdf): If the source is a constant, always expand to a
	sequence of movsi insns.
	(movdi_internal, movdf_internal): Remove alternative using l32r insns.
	(movsi_internal, movsf_internal): Add alternative using const16 insns.
	(movsf): Add const16 support.
	(entry, prologue, epilogue): New.
	(set_frame_ptr): Add missing mode for unspec_volatile operation.
	Likewise for subsequent split pattern.
	* doc/invoke.texi (Option Summary, Xtensa Options): Document new
	"-mconst16" and "-mno-const16" options.

2003-05-14  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (ia64_expand_load_address): Force destination
	to be DImode register.  Merge load_symptr.
	* config/ia64/ia64.md (load_symptr): Remove.

2003-05-14  Richard Henderson  <rth@redhat.com>

	* rtl.h (TREE_CONSTANT_POOL_ADDRESS_P): Rename from
	DEFERRED_CONSTANT_P.
	* integrate.c (copy_rtx_and_substitute): Update use.
	* varasm.c (build_constant_desc): Set SYMBOL_REF_DECL
	to the copy generated.
	(maybe_output_constant_def_contents): Examine TREE_ASM_WRITTEN
	of the constant to see if we should emit.
	(mark_constant): Similarly.
	(output_constant_def_contents): Set TREE_ASM_WRITTEN.

2003-05-14  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (movsi_internal2): Use compare for self
	move record condition.
	(movdi_internal2): Same.

2003-05-14  Nathan Sidwell  <nathan@codesourcery.com>

	* gcov-io.h (gcov_write_bytes, gcov_read_bytes): Remove here.
	(GCOV_TAG_*) Force type to gcov_unsigned_t.
	(GCOV_CHECK, GCOV_CHECK_READING, GCOV_CHECK_WRITING): New.
	(struct gcov_var): Remove modified. Add start, length, offset,
	overread. Have buffer array for libgcov.
	(gcov_sync, gcov_seek): Definitions moved to gcov-io.c.
	(gcov_position, gcov_rewrite, gcov_is_eof): Adjust.
	* gcov-io.c (gcov_open): Set mode, do not read anything.
	(gcov_close): Write final block.
	 (gcov_write_block, gcov_allocate): New.
	(gcov_write_bytes): Make static. Write or allocate buffer.
	(gcov_write_unsigned, gcov_write_counter): Buffer can never be
	null.
	(gcov_write_string): Adjust.
	(gcov_write_tag)
	(gcov_write_length): Adjust. Flush the block.
	(gcov_write_tag_length): Buffer can never be null.
	(gcov_read_bytes): Make static. Read in block.
	(gcov_sync): Moved here. Adjust.
	(gcov_seek): Moved here. Adjust.
	* coverage.c (read_counts_file): Adjust.
	* gcov-dump.c (print_prefix): Add position parameter.
	(flag_dump_positions): New flag.
	(options, main, print_usage): Add it.
	(dump_file, tag_blocks, tag_arcs, tag_lines, tag_counters,
	tag_summary): Adjust.
	* gcov.c (read_graph_file, read_count_file): Adjust.
	* libgcov.c (gcov_exit): Adjust.

	* Makefile.in (LIBGCC_DEPS): Use $(srcdir) on gcov files
	(libgcov.a): Depend on libgcc.a.
	(gcov.o, gcov-dump.o): Add gcov-io.c.
	* mklibgcc.in (libgcov_c_dep): Use $(srcdir).

	* loop.c (check_dbra_loop): Factor common test.

2003-05-14  Ben Elliston  <bje@wasabisystems.com>

	* doc/md.texi (Automaton pipeline description): Grammar fixes.

2003-05-14  Richard Sandiford  <rsandifo@redhat.com>

	* target-def.h (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(TARGET_INITIALIZER): Include it.
	* target.h (struct gcc_target): Add machine_dependent_reorg field.
	* toplev.c (rest_of_compilation): Use targetm.machine_dependent_reorg.
	* system.h: Poison MACHINE_DEPENDENT_REORG.

	* config/alpha/alpha-protos.h (alpha_reorg): Remove declaration.
	* config/alpha/alpha.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/alpha/alpha.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(alpha_handle_trap_shadows): Remove "first insn" parameter.
	(alpha_align_insns): Likewise.
	(alpha_reorg): Likewise.  Make static.  Update calls to above
	functions.

	* config/arm/arm-protos.h (arm_reorg): Remove declaration.
	* config/arm/arm.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/arm/arm.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(arm_reorg): Remove parameter.  Make static.

	* config/avr/avr-protos.h (machine_dependent_reorg): Remove.
	* config/avr/avr.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/avr/avr.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(avr_reorg): Renamed from machine_dependent_reorg.  Make static.
	Remove parameter.

	* config/c4x/c4x-protos.h (c4x_process_after_reload): Remove.
	* config/c4x/c4x.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/c4x/c4x.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(c4x_reorg): Renamed from c4x_process_after_reload.  Make static.
	Remove parameter.

	* config/d30v/d30v-protos.h (d30v_machine_dependent_reorg): Remove.
	* config/d30v/d30v.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/d30v/d30v.c (d30v_machine_dependent_reorg): Remove.

	* config/frv/frv-protos.h (frv_machine_dependent_reorg): Remove.
	* config/frv/frv.c: Remove orphaned comment.

	* config/i386/i386-protos.h (x86_machine_dependent_reorg): Remove.
	* config/i386/i386.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/i386/i386.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(ix86_reorg): Renamed from x86_machine_dependent_reorg.  Make static.
	Remove parameter.

	* config/ia64/ia64-protos.h (ia64_reorg): Remove declaration.
	* config/ia64/ia64.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/ia64/ia64.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(emit_insn_group_barriers): Remove "first insn" parameter.
	(emit_all_insn_group_barriers): Likewise.
	(ia64_reorg): Likewise.  Make static.  Update calls to above functions.
	(ia64_output_mi_thunk): Update call to emit_all_insn_group_barriers.

	* config/ip2k/ip2k-protos.h (machine_dependent_reorg): Remove.
	* config/ip2k/ip2k.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/ip2k/ip2k.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(ip2k_reorg): Renamed from machine_dependent_reorg.  Make static.
	Remove parameter.

	* config/m68hc11/m68hc11-protos.h (m68hc11_reorg): Remove declaration.
	* config/m68hc11/m68hc11.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/m68hc11/m68hc11.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(m68hc11_reorg): Make static.  Remove parameter.

	* config/mcore/mcore-protos.h (mcore_dependent_reorg): Remove.
	* config/mcore/mcore.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/mcore/mcore.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(conditionalize_optimization): Remove parameter.
	(mcore_reorg): Renamed from mcore_dependent_reorg.  Remove parameter.
	Make static.  Update call to conditionalize_optimization.

	* config/mips/mips-protos.h (machine_dependent_reorg): Remove.
	* config/mips/mips.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/mips/mips.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(mips_reorg): Renamed from machine_dependent_reorg.  Remove parameter.
	Make static.

	* config/mmix/mmix-protos.h (mmix_machine_dependent_reorg): Remove.
	* config/mmix/mmix.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/mmix/mmix.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(mmix_reorg): Renamed from mmix_machine_dependent_reorg.  Make static.
	Remove parameter.

	* config/pa/pa-protos.h (pa_reorg): Remove declaration.
	* config/pa/pa.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/pa/pa.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(pa_combine_instructions): Remove "first insn" parameter.
	(remove_useless_addtr_insns): Likewise.
	(pa_reorg): Likewise.  Make static.  Update calls to above functions.

	* config/rs6000/rs6000.h (MACHINE_DEPENDENT_REORG): Remove
	commented-out definition.

	* config/s390/s390-protos.h (s390_machine_dependent_reorg): Remove.
	* config/s390/s390.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/s390/s390.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(s390_reorg): Renamed from s390_machine_dependent_reorg.  Make static.
	Remove parameter.

	* config/sh/sh-protos.h (machine_dependent_reorg): Remove.
	* config/sh/sh.h (MACHINE_DEPENDENT_REORG): Remove.
	* config/sh/sh.c (TARGET_MACHINE_DEPENDENT_REORG): Define.
	(sh_reorg): Renamed from machine_dependent_reorg.  Make static.
	Remove parameter.
	(sh_output_mi_thunk): Call sh_reorg directly.
	* config/sh/sh.md: Update comment.

	* config/stormy16/stormy16.h (MACHINE_DEPENDENT_REORG): Remove
	commented-out definition.

	* config/v850/v850-protos.h (v850_reorg): Remove declaration.
